<?php

/**
* archive stuff
*                                                                                
* $Header: /TEMPLATE/library/include/CMMDBArchive.inc.php 4     20.02.03 19:20 Emov $
*
* @author Yury Emelyanov <emov@hypermethod.com>
*/
define('DBARCHIVE_USE_LOCK', 0);
define('VERBOSE', 0);
define('SIGNATURE', 'N5TNKNG3LK3N43NKNKF3N4F-4G45G2-5H34H-45Y45');

class CMMDBArchive {
	
	/**
	* returns full table dump
	*
	* @param $tableName
	* @return string
	* @access private
	*/
	function _tableDump($tableName, $fp, $where)
	{
		$dump = <<<eod
#
# CMMDBArchive table dump:
#
# tablename: $tableName
#

eod;
		fwrite($fp, $dump);
		$tableName = strtolower($tableName);

		$query = "SELECT * FROM $tableName WHERE $where";

		$res = sqldb_query($query) or trigger_error("can't query table to dump", MME_ERROR);

		$numRows = num_rows($res);
		$numFields = num_fields($res);
		if ($numRows > 0) {
			//wether is nummeric
			$isNumeric = array();
			for ($i = 0; $i < $numFields; $i++) {
				$field = fetch_field($res, $i);
				$fieldNames[] = '`' . $field->name . '`';
				$isNumeric[$i] = (boolean) $field->numeric;
			}
			
			fwrite($fp, "DELETE FROM `$tableName` WHERE $where;\n\n");

			$insertClause = "INSERT INTO `$tableName` (" . join(', ', $fieldNames) . ") ";

			while($row = fetch_row($res)) {

				$processed_row = array();
				fwrite($fp, $insertClause . 'VALUES (');
				//now values should go to $dump
				$values = '';

				for ($i = 0; $i < $numFields; $i++) 
				{
					$value = $row[$i];
					if ($i) $values .= ', ';
					if (isset($value)) {
						if (!$isNumeric[$i]) {
							$values .= "'" . mysql_escape_string($value) . "'";
						} else {
							$values .= $value;
						}
					} else {
						$values .= 'NULL';
					}
				}
				fwrite($fp, $values . ");\n");

			}

		} else {
			fwrite($fp, "# table is empty\n\n");
		}
		
		sqldb_free_result($res);
		return true; //$dump
	}
	
	/**
	* returns full db dump
	*
	* @return void
	* @access private
	*/
	function _DBDump($fp, $CID, $MID)
	{
		//maybe we should lock tables for read
		$dump = '';
		$tables = CMMDBArchive::_getTableNames($CID, $MID);
		$res = true;
		foreach($tables as $table=>$where) 
		{
			$res = $res && CMMDBArchive::_tableDump($table, $fp, $where);
		}
		return $res;
	}
	                


	/**
	* returns modules list
	*
	* @return string
	* @access private
	*/                                        
	function _getMODULES($CID, $MID) {
		global $mod_list_table;
		$in_MODULES = "";
		if($MID == -1) {
			$res = sqldb_query("SELECT ModID FROM $mod_list_table WHERE CID = '$CID'");
			if($res) {
				while($row = fetch_array($res)) {
					$in_MODULES = $in_MODULES . $row[0] . ", ";
				}
			}
			if($in_MODULES != "") {
				$in_MODULES = substr($in_MODULES, 0, -2);
			}
		} else {
			$in_MODULES = $MID;
		}
		return $in_MODULES;
	}


	function _getTARGETS($CID) {
		global $mod_list_table;
		$in_TARGETS = "";
	
			$res = sqldb_query("SELECT TID FROM target WHERE CID = '$CID'");
			if($res) {
				while($row = fetch_array($res)) {
					$in_TARGETS = $in_TARGETS . $row[0] . ", ";
				}
			}
			if($in_TARGETS != "") {
				$in_TARGETS = substr($in_TARGETS, 0, -2);
			}
		
		return $in_TARGETS;
	}


	/**
	* returns lessons list
	*
	* @return string
	* @access private
	*/                                        
	function _getLESSONS($CID, $MID, $in_MODULES) {
		global $lesson_table;
		$in_LESSONS = "";
		if($in_MODULES != "") {
			$res = sqldb_query("SELECT LID FROM $lesson_table WHERE CID = '$CID' AND MID IN ($in_MODULES)");
			if($res) {
				while($row = fetch_array($res)) {
					$in_LESSONS = $in_LESSONS . $row[0] . ", ";
				}
			}
			if($in_LESSONS != "") {
				$in_LESSONS = substr($in_LESSONS, 0, -2);
			}
		}
		return $in_LESSONS;
	}

	/**
	* returns tests list
	*
	* @return string
	* @access private
	*/                                        
	function _getTESTS($CID, $MID, $in_MODULES)
	{       global $mod_list_table;
		$in_TESTS = "";

        /*
		if($in_MODULES!="")
		{
			$res = sqldb_query("SELECT test_id FROM $mod_list_table WHERE CID='$CID' AND ModID IN ($in_MODULES)");

			if($res)
				while($row = fetch_array($res))
				{
					$test_arr = explode(";", $row[0]);
					foreach($test_arr as $tid)
						if(trim($tid)!="")
							$in_TESTS= $in_TESTS.$tid.", ";
				}
			if($in_TESTS!="") $in_TESTS= substr($in_TESTS, 0, -2);
		}
    */
        $res = sqldb_query("SELECT tid FROM test WHERE cid='$CID'");

			if($res)
				while($row = fetch_array($res))
				{
					$test_arr = explode(";", $row[0]);
					foreach($test_arr as $tid)
						if(trim($tid)!="")
							$in_TESTS= $in_TESTS.$tid.", ";
				}
			if($in_TESTS!="") $in_TESTS= substr($in_TESTS, 0, -2);

		return $in_TESTS;
	}

	/**
	* returns kodes list
	*
	* @return string
	* @access private
	*/                                        
	function _getKODES($CID, $MID, $in_MODULES, $in_TESTS)
	{
	        global $testtable;
		$in_KODES = "";                    
		if($in_MODULES!="" && $in_TESTS!="")
		{
			$res = sqldb_query("SELECT data FROM $testtable WHERE CID='$CID' AND tid IN ($in_TESTS)");
			if($res)
				while($row = fetch_array($res))
				{
					$vopr_arr = explode("~~", $row[0]);
					
					foreach($vopr_arr as $vid)
						if(trim($vid)!="")
							$in_KODES= $in_KODES."'".$vid."', ";
				}
			if($in_KODES!="") $in_KODES = substr($in_KODES, 0, -2);
		}

		return $in_KODES;
	}


	function _getKODES_NEW($CID, $MID, $in_MODULES, $in_TESTS)
	{
	        global $testtable;
		$in_KODES_NEW = "";                    
		if($in_MODULES!="" && $in_TESTS!="")
		{
			$res = sqldb_query("SELECT id_list FROM test_list WHERE id_test IN ($in_TESTS)");

			if($res)
				while($row = fetch_array($res))
				{
					$vopr_arr = explode("~~", $row[0]);
					
					foreach($vopr_arr as $vid)
						if(trim($vid)!="")
							$in_KODES_NEW= $in_KODES_NEW."'".$vid."', ";
				}
			if($in_KODES_NEW!="") $in_KODES_NEW = substr($in_KODES_NEW, 0, -2);
		}

		return $in_KODES_NEW;
	}


function _getKODES_NEW1($CID, $MID, $in_MODULES, $in_TESTS)
	{
	        global $testtable;
		$in_KODES_NEW = "";                    
		if($in_MODULES!="" && $in_TESTS!="")
		{
			$res = sqldb_query("SELECT distinct id_list FROM target_list  WHERE id_target IN ($in_TESTS)");

			if($res)
				while($row = fetch_array($res))
				{
					$vopr_arr = explode("~~", $row[0]);
					
					foreach($vopr_arr as $vid)
						if(trim($vid)!="")
							$in_KODES_NEW= $in_KODES_NEW."'".$vid."', ";
				}
			if($in_KODES_NEW!="") $in_KODES_NEW = substr($in_KODES_NEW, 0, -2);
		}

		return $in_KODES_NEW;
	}

	/**
	* returns personal category list
	*
	* @return string
	* @access private
	*/                                        
	function _getSPECS()
	{
		global $specialtable;
		$in_SPECS = "";
		$res = sqldb_query("SELECT SpID FROM $specialtable");
		if($res)
			while($row = fetch_array($res))
			{
				$spid = $row[0];
				if(trim($spid)!="")
					$in_SPECS = $in_SPECS."'".$spid."', ";
			}
		if($in_SPECS!="") $in_SPECS= substr($in_SPECS, 0, -2);
		

		return $in_SPECS;
	}

	/**
	* returns table list with WHERE clause
	*
	* @return string
	* @access private
	*/                                        
	function _getTableNames($CID, $MID)
	{
		$in_MODULES = CMMDBArchive::_getMODULES($CID, $MID);
		$in_TARGETS = CMMDBArchive::_getTARGETS($CID, $MID);
		$in_LESSONS = CMMDBArchive::_getLESSONS($CID, $MID, $in_MODULES);
		$in_TESTS = CMMDBArchive::_getTESTS($CID, $MID, $in_MODULES);
		$in_KODES = CMMDBArchive::_getKODES($CID, $MID, $in_MODULES, $in_TESTS);
		$in_KODES_NEW = CMMDBArchive::_getKODES_NEW($CID, $MID, $in_MODULES, $in_TESTS);
		$in_KODES_NEW1 = CMMDBArchive::_getKODES_NEW1($CID, $MID, $in_MODULES, $in_TARGETS);
		$in_SPECS = CMMDBArchive::_getSPECS();


//pr($in_TESTS);
//pr($in_KODES_NEW);
//pr($in_KODES_NEW1);
        	
		global $coursestable, $lesson_table, $mod_list_table, $mod_cont_table, $target_table, $testtable, $listtable, $testneedtable, $file_table, $bookstable, $specialtable, $glossarytable;

		$tables[$coursestable] = $tables["exercise"] = "CID = '$CID'";
		$tables[$lesson_table] = "CID = '$CID'" . ($MID != -1 ? " AND MID = '$MID'" : "");
		$tables[$mod_list_table] = "CID = '$CID'" . ($MID != -1 ? " AND ModID = '$MID'" : "");
       	$tables[$mod_cont_table] = $in_MODULES == "" ? "0" : "McID IN ($in_MODULES)";
		$tables[$target_table] = "CID = '$CID'" . ($MID == -1 ? "" : " AND " . ($in_LESSONS == "" ? "0" : "LID IN ($in_LESSONS)"));
		$tables['target_special'] = $in_LESSONS == "" ? "0" : "target_id IN ($in_LESSONS)";
		$tables['lesson_target'] = $tables['mod_lesson']  = $in_LESSONS == "" ? "0" : "lesson_id IN ($in_LESSONS)";
		$tables[$testtable] = "cid = '$CID'" . ($MID == -1 ? "" : " AND " . ($in_TESTS == "" ? "0" : "tid IN ($in_TESTS)"));
		$tables[$listtable] = $tables[$testneedtable] = $tables[$file_table] = $in_KODES_NEW == "" ? "0" : "kod IN ($in_KODES_NEW)";
     //   $tables[$listtable] = $tables[$testneedtable] = $tables[$file_table] = $in_KODES_NEW == "" ? "0" : "kod IN ($in_KODES_NEW1)";

		$tables['target_list'] = $in_KODES_NEW1 == "" ? "0" : "id_target IN ($in_KODES_NEW1)";
    //    $tables['test_list'] =$in_KODES_NEW == "" ? "0" : "id_list IN ($in_KODES_NEW1)";
		$tables['test_list'] =$in_KODES_NEW == "" ? "0" : "id_list IN ($in_KODES_NEW)";
		//"kod LIKE '$CID-%'"
        
//pr($in_KODES_NEW);
//pr($tables['test_list']);

		if($MID == -1)
		{	$tables[$bookstable] = "CID = '$CID'";
			$tables[$specialtable] = "SpID IN ($in_SPECS)";
			$tables[$glossarytable] = "CID = '$CID'";
		}

        return $tables;
	}
	
	/**
	* @desc makes archive
	*
	* @return string
	* @access public
	*/
	function makeArchive($pathname, $CID, $MID) 
	{
		$fileName = /*DIR_DB_ARCHIVE . "/". */$pathname;
		$fp = fopen($fileName, 'w');
		if (!$fp) trigger_error("<h1>  .</h1> <h1>    <i>'$fileName'</i>  .</h1><br><br><h2>,          .</h2><br><br>", MME_ERROR);
		
fwrite($fp, SIGNATURE."\n");
fwrite($fp, "# INFO section #######################\n\n");
fwrite($fp, "CID=$CID\n");
fwrite($fp, "MID=$MID\n");
fwrite($fp, "\n\n");
fwrite($fp, "# DB DUMP section #######################\n");


		$res = CMMDBArchive::_DBDump($fp, $CID, $MID);

		fclose($fp);
		return $res;
	}
	
	function addOptionsToArchive($pathname, $CID) {
		$fileName = $pathname;
		$fp = fopen($fileName, 'a');
		if (!$fp) trigger_error("<h1>  .</h1> <h1>    <i>'$fileName'</i>  .</h1><br><br><h2>,          .</h2><br><br>", MME_ERROR);
		$optionstable='OPTIONS';
		$res = CMMDBArchive::_tableDump($optionstable, $fp, "OptionID > 7");

		fclose($fp);
		return $res;
	}
	
	function addSearchToArchive($pathname, $CID) {
		$fileName = $pathname;
		$fp = fopen($fileName, 'a');
		if (!$fp) trigger_error("<h1>  .</h1> <h1>    <i>'$fileName'</i>  .</h1><br><br><h2>,          .</h2><br><br>", MME_ERROR);
		
		$res = CMMDBArchive::_tableDump('search', $fp, "doc_id LIKE '../course" . $CID . "/%'");

		fclose($fp);
		return $res;
	}
	
	function addForumToArchive($pathname, $CID) {
		$_forum_files = '';
		$fileName = $pathname;
		$fp = fopen($fileName, 'a');
		if (!$fp) trigger_error("<h1>  .</h1> <h1>    <i>'$fileName'</i>  .</h1><br><br><h2>,          .</h2><br><br>", MME_ERROR);
		
		if ($_fthreads = CMMDBArchive::_getFDivs($fp, $CID)) {
			if ($_fmessages = CMMDBArchive::_getFThreads($fp, $_fthreads)) {
				if ($_ffiles = CMMDBArchive::_getFMessages($fp, $_fmessages)) {
					$_forum_files = CMMDBArchive::_getFFiles($fp, $_ffiles);
				}
			}
		}

		fclose($fp);
		return $_forum_files;
	}
	
	function _getFDivs($fp, $cid) {
		$fdivs = '';
		$tbl = 'forumdiv';
		$where = "CID = " . $cid;
		$sql = "SELECT fdid FROM " . $tbl . " WHERE " . $where;
		$res = sqldb_query($sql);
		if($res) {
			while($row = fetch_array($res)) {
				$fdivs = $fdivs . $row[0] . ", ";
			}
		}
		if($fdivs != "") {
			$fdivs = substr($fdivs, 0, -2);
			$res = CMMDBArchive::_tableDump($tbl, $fp, $where);
		}
		return $fdivs;
	}

	function _getFThreads($fp, $fdivs) {
		$fthrs = '';
		$tbl = 'forumthreads';
		$where = "fdid IN (" . $fdivs . ")";
		$sql = "SELECT thread FROM " . $tbl . " WHERE " . $where;
		$res = sqldb_query($sql);
		if($res) {
			while($row = fetch_array($res)) {
				$fthrs = $fthrs . $row[0] . ", ";
			}
		}
		if($fthrs != "") {
			$fthrs = substr($fthrs, 0, -2);
			$res = CMMDBArchive::_tableDump($tbl, $fp, $where);
		}
		return $fthrs;
	}

	function _getFMessages($fp, $fthrs) {
		$fmsgs = '';
		$tbl = 'forummessages';
		$where = "thread IN (" . $fthrs . ")";
		$sql = "SELECT id FROM " . $tbl . " WHERE " . $where;
		$res = sqldb_query($sql);
		if($res) {
			while($row = fetch_array($res)) {
				$fmsgs = $fmsgs . $row[0] . ", ";
			}
		}
		if($fmsgs != "") {
			$fmsgs = substr($fmsgs, 0, -2);
			$res = CMMDBArchive::_tableDump($tbl, $fp, $where);
		}
		return $fmsgs;
	}

	function _getFFiles($fp, $fmsgs) {
		$ffls = '';
		$tbl = 'forumfiles';
		$where = "msgid IN (" . $fmsgs . ")";
		$sql = "SELECT name FROM " . $tbl . " WHERE " . $where;
		$res = sqldb_query($sql);
		if($res) {
			while($row = fetch_array($res)) {
				$ffls = $ffls . $row[0] . ", ";
			}
		}
		if($ffls != "") {
			$ffls = substr($ffls, 0, -2);
			$res = CMMDBArchive::_tableDump($tbl, $fp, $where);
		}
		return $ffls;
	}

	function _tsToDate($ts)
	{
		return date('Y-m-d-H-i-s', $ts);
	}
	
	/**
	* gets archive dates
	*
	* @return array(ts=>str)
	* @access public
	*/
	function getArchiveDates() 
	{
		$dir = dir(DIR_DB_ARCHIVE) or trigger_error("can't access db archive dir :" . DIR_AB_ARCHIVE, MME_ERROR);
		$dates = array();
		while (false !== ($entry = $dir->read())) {
		    if (($entry != '.') && ($entry != '..')) {
		    	//process now
		    	$aDate = explode('-', $entry);
		    	$date = mktime($aDate[4], $aDate[5], $aDate[6], $aDate[2], $aDate[3], $aDate[1]);
		    	$sDate = date(DATE_FORMAT_STRING_PHP, $date) . ' ' . date("H:i:s", $date);
		    	$dates[$date] = $sDate;
		    }
		}
		//sorting dates:
		array_flip($dates);
		arsort($dates);
		array_flip($dates);
		return $dates;
	}
	
	/**
	* locks tables
	*
	* @return void
	* @access private
	*/
	function _lockTables($tablesList) 
	{
		if (DBARCHIVE_USE_LOCK) {
			$query = "LOCK TABLES ";
			$qTables = array();
			foreach($tablesList as $table=>$null) {
				 $qTables[] = "$table WRITE";
			}
			$query .= join(', ', $qTables);
			sqldb_query($query) or trigger_error("Can't lock tables before restoring", MME_ERROR);
		}
	}
	                                                                     
	/**
	* init data before restoring
	*
	* @return void
	* @access private
	*/
	function _initFile($fileName, &$CID, &$MID) 
	{                             
		$CID = $MID = -2;
               
		$fp = fopen($fileName, "r");
		if(!$fp) return false;

		$s = trim(fgets($fp));

		if($s!=SIGNATURE) return false;

		while(!feof($fp))
		{
			$s = fgets($fp);
			
			if(!(strpos($s, "DB DUMP")===false)) break;

			$exp = explode("=", $s);
			if(count($exp)!=2) continue;	

			$exp[0] = trim($exp[0]); $exp[1] = trim($exp[1]);
			if($exp[0]=="" || $exp[1]=="") continue;

			if($exp[0]=="CID")
				$CID = $exp[1];
			if($exp[0]=="MID")
				$MID = $exp[1];
		}	

		fclose($fp);
	
		if($CID=="" || $MID=="" || $CID<=0) return false;

		return true;
	}

	        
	/**
	* deletes needed from tables
	*
	* @return void
	* @access private
	*/
	function _emptyTables($CID, $MID, $except_table) 
	{                                 

		$tables = CMMDBArchive::_getTableNames($CID, $MID);
		foreach($tables as $table => $where)
		{
			if($table==$except_table) continue;

			$query = "DELETE FROM `$table` WHERE $where;";
//echo "$query<br>";    

			$res = sqldb_query($query);
			if (!$res) {
				if (VERBOSE) echo "emptying table `$table` - FAILED<br>";
				if (DBARCHIVE_USE_LOCK)	sqldb_query("UNLOCK TABLES") or trigger_error("Failed to unlock tables after error in emptying. Mysql block can occur.", MME_ERROR);
				trigger_error("Can't empty table", MME_ERROR);
			} else {
				if (VERBOSE) echo "emptying table `$table` - OK<br>";
			}          


		}
	}
	
	/**
	* executes sql on database
	*
	* @return void
	* @access private
	*/
	function _execSqlFile($fileName) 
	{
		//this version is pretty fast but we can play with speed using fread and other array walk method

		$file = file($fileName);
		$strNo = 0;
		$bDump = false;
		foreach($file as $line) {
			if(!$bDump)
			{	if(!(strpos($line, "DB DUMP")===false)) $bDump = true;
			
				continue;
			}

			$strNo++;
			if ($line[0] == '#') continue; //skipping comment
			$query = trim($line);
			if (!$query) continue;

			$res = sqldb_query($query);
			if (!$res) {
				if (VERBOSE) echo "#$strNo - FAILED<br>";
				if (DBARCHIVE_USE_LOCK) sqldb_query("UNLOCK TABLES") or trigger_error("Failed to unlock tables after error in inserting. Mysql block can occur.", MME_ERROR);
				echo "<br>Error in line $strNo:<br><span style='color:red'>".sqldb_error()."</span><br>$query<br><br>";//$query
//				trigger_error("can't insert data, str $strNo", MME_ERROR);
				return false;
			} else {
				if (VERBOSE) echo "#$strNo - OK<br>";
			}
		}
		return true;
	}

	
	/**
	* locks tables
	*
	* @return void
	* @access private
	*/
	function _unlockTables() 
	{
		if (DBARCHIVE_USE_LOCK) {
			$query = "UNLOCK TABLES";
			sqldb_query($query) or trigger_error("can't unlock tables", MME_WARNING);
		}
	}
	
	/**
	* restores DB as it was at date
	*
	* @return string
	* @access public
	*/
	function restoreToDate($date) 
	{
		
		$fileName = 'dump-' . CMMDBArchive::_tsToDate($date) . '.sql';

		CMMDBArchive::restoreFromFile($fileName);		
		
		return $fileName;
	}
	
	/**
	* restores DB
	*
	* @return string
	* @access public
	*/
	function restoreFromFile($fileName) 
	{
		global $specialtable;

        	$CID = $MID = -2;
		
//		$fileName = DIR_DB_ARCHIVE . '/' . $fileName;

		$res = CMMDBArchive::_initFile($fileName, $CID, $MID);

		if(!$res) return false;
		
		$tables = CMMDBArchive::_getTableNames($CID, $MID);
		
		CMMDBArchive::_lockTables($tables);
		
		CMMDBArchive::_emptyTables($CID, $MID, $specialtable);
		
		$res = CMMDBArchive::_execSqlFile($fileName);
		if(!$res) return false;
		
		CMMDBArchive::_unLockTables();
		
		return true;
	}


}
?>