function FAFrame(id)
	{
		this.o_ref=null;
		this.o_frame=null;
		this.o_frame_cap=null;
		this.o_frame_body=null;
		this.o_node=null;
		this.o_screen=null;
		this.o_scenario=null;
		this.z_current=null;

		this.items_count=0;
		this.p_index=0;
		this.p_items={};
		this.oParams={};
		this.oEvents={
			0: FAStrings.event_none,
			'onenter': FAStrings.event_on_enter,
			'onleave': FAStrings.event_on_leave
			};
		this.id=id;
		this.name=null;
		this.local_id=id;
		return this;
	}

FAFrame.prototype.assemble = function()
	{
		var oFrame, oNode, oScreen, iFrame;
		oFrame=this.o_ref.p_timeline.document.createElement('<DIV class="frame_holder" sKey="'+this.id+'">');
		oFrame.innerHTML='<DIV class="frame_1corn"><IFRAME src="blank.html" class="frame_body" frameborder=0 allowTransparency=true style="margin:0px;"></IFRAME><DIV class="frame_options"><DIV class="frame_name">'
		+(this.name ? this.name : this.id)
		+'</DIV></DIV></DIV><DIV class="frame_shadow"><DIV class="frame_2corn"><DIV class="frame_3corn"></DIV></DIV></DIV>';
		oFrame.onmousedown=FAUtil.frameClick;
		oFrame.ondblclick=FAUtil.frameDblClick;
		oFrame.o_ref=this;
		oScreen=this.o_ref.z_editor_body.document.createElement('<DIV class="fa_screen">');
		oScreen.o_ref=this;

		this.o_ref.z_timeline.appendChild(oFrame);
		this.o_ref.z_editor_body.appendChild(oScreen);
		this.o_frame=oFrame;
		this.o_frame_cap=oFrame.firstChild.lastChild.lastChild;
		this.o_frame_cap.o_ref=this;
		this.o_frame_cap.ondblclick=FAUtil.frameEditCap;
		iFrame=oFrame.firstChild.firstChild;
		iFrame.contentWindow.document.open();
		iFrame.contentWindow.document.write('<HEAD>'+(this.o_ref.work_dir ? '<BASE href="'+this.o_ref.work_dir+'" />' : '')+'</HEAD><BODY style="background-color:#404040; margin:0px" scroll=no onselectstart="return false"></BODY>');
		iFrame.contentWindow.document.close();
		iFrame.contentWindow.document.o_ref=this;
		iFrame.contentWindow.document.onmousedown=FAUtil.frameClick;
		iFrame.contentWindow.document.ondblclick=FAUtil.frameDblClick;
		iFrame.contentWindow.document.oncontextmenu=FAUtil.timelineContextMenu;
		this.o_frame_body=iFrame.contentWindow.document.body;
		this.o_screen=oScreen;
		oScreen.contentEditable=true;
		oScreen.unselectable=true;
		oScreen.ondragstart=FAUtil.cancelEvent;
		oScreen.document.execCommand("2D-Position", false, true);
	    oScreen.document.execCommand("MultipleSelection", false, true);
	    oScreen.document.execCommand("LiveResize", false, true);
		this.o_node=this.o_ref.p_tree.insertNode(this.id, this.name, null, 1, 1);

		this.oParams={
				'frame_id' : [FAStrings.prop_frame_id, this.id, 'readonly'],
				'frame_name' : [FAStrings.prop_frame_name, this.name, 'text'],
				'next_frame' : [FAStrings.prop_next_frame, this.getNext(), 'frames'],
				'description' : [FAStrings.prop_description, '', 'htmlarea'],
				'edit_frame_descr': ['', FAStrings.prop_edit_frame_descr, 'command'],
				'XSMPL_error_message' : [FAStrings.prop_error_message, '', 'textarea'],
				'XSMPL_frame_true': [FAStrings.prop_frame_true, 1, 'int'],
				'XSMPL_frame_false': [FAStrings.prop_frame_false, -1, 'int']
			}
	}

		
FAFrame.prototype.getNext=function()
	{
		if (this.o_frame.nextSibling)
			{
				return this.o_frame.nextSibling.o_ref.id;
			}
		return null;
	}

FAFrame.prototype.setName=function(name)
	{
		this.name=name;
		this.o_frame_cap.innerHTML=name;
		this.o_ref.p_tree.renameNode(this.id, name);
		if (this.o_ref.z_current_prop && this.o_ref.z_current_prop===this)
			this.o_ref.setPropertyPanelCaption(name);
		this.o_ref.setProperty(this, 'frame_name', name);
	}

FAFrame.prototype.remove=function()
	{
		var x;

		for(x in this.p_items)
			{
				if (this.o_ref.z_current_prop && this.o_ref.z_current_prop===this.p_items[x])
					this.o_ref.showProperties();
				delete this.p_items[x];
			}
		if (this.o_scenario.p_keys[this.id])
			delete this.o_scenario.p_keys[this.id];
		for (x=0; x < this.o_scenario.p_frames.length; x++)
			if (this.o_scenario.p_frames[x]===this)
				{
					this.o_scenario.p_frames.splice(x, 1);
					break;
				}
		this.p_items={};
		if (this.o_ref.z_current_prop===this)
			this.o_ref.showProperties();
		this.o_ref.p_tree.removeNode(this.id);
		this.o_screen.removeNode(true);
		this.o_frame.removeNode(true);
		
	}
	
FAFrame.prototype.selectItem=function(sKey)
	{
		var oObj;
		if (oObj=this.p_items[sKey])
			{
				if (oObj.isScript)
					{
						this.o_ref.p_tree.selectNode(oObj.full_id);
						this.o_ref.showProperties(oObj);
					}
				else
					{
						if (!this.o_ref.z_curframe || this.o_ref.z_curframe.id!=this.id)
							this.switchTo();
						this.z_current=oObj;
 						var range=this.o_ref.z_editor_body.document.body.createControlRange();
 						if (range)
 							{

								range.addElement(this.p_items[sKey]);
								range.select();
							}
					}
			}
	}
	
FAFrame.prototype.removeItem=function(sKey, bTreeFixed)
	{
		var x, res;
		if (x=this.p_items[sKey])
			{
				if (x.tagName)
					{
						x.oFrameObj.removeNode();
						res=x.removeNode();
					}
				else
					{
						res=x;
					}
				if (!bTreeFixed)
					this.o_ref.p_tree.removeNode(x.full_id);
				if (this.o_ref.z_current_prop===x)
					this.o_ref.showProperties();
				x.o_ref=null;
				this.items_count--;
				delete this.p_items[sKey];
				return res;
			}
		return null;
	}
	
FAFrame.prototype.renameItem=function(sKey, sName)
	{
		var oObj=this.p_items[sKey], oNode;
		if (oObj)
			{
				oNode=this.o_ref.p_tree.keys[oObj.full_id];
				if (oNode)
					this.o_ref.p_tree.renameNode(oNode.sKey, sName);
				oObj.name=sName;
				if (this.o_ref.z_current_prop && this.o_ref.z_current_prop===oObj)
					this.o_ref.setPropertyPanelCaption(sName, this.name);
				this.o_ref.setProperty(oObj, 'name', sName);
			}
	}
	
FAFrame.prototype.insertItem=function(oObj)
	{
		if (oObj && oObj.local_id)
			{
				if (this.p_items[oObj.local_id])
					{
						oObj.local_id=FAUtil.getUniqueID(oObj.local_id)[0];
					}
				
				oObj.full_id=this.id+'|'+oObj.local_id;
				oObj.o_ref=this;
				
				oObj.oParams.id[1]=oObj.local_id;
				this.p_items[oObj.local_id]=oObj;
				if (!oObj.isScript)
					{
						oObj.style.zIndex=++this.items_count;
						this.o_screen.appendChild(oObj);
						if (oObj.oFrameObj)
							{
								if (oObj.oFrameObj.document !== this.o_frame_body.document)
									{
										var tObj=this.o_frame_body.document.createElement(oObj.oFrameObj.tagName);
										if (oObj.oFrameObj.tagName=='IMG')
											tObj.src=oObj.oFrameObj.src;
										tObj.style.cssText=oObj.oFrameObj.style.cssText;
										oObj.oFrameObj=null;
										oObj.oFrameObj=tObj;
									}
								oObj.oFrameObj.style.zIndex=this.items_count;
								this.o_frame_body.appendChild(oObj.oFrameObj);
							}
					}
			}
	}

FAFrame.prototype.select = function()
	{
		if (this.o_frame)
			{
				if (this.o_ref.z_curframe_tl)
					{
						this.o_ref.z_curframe_tl.o_frame.className='frame_holder';
						this.o_ref.z_curframe_tl=null;
					}
				this.o_frame.className='frame_holder selected';
				this.o_ref.z_curframe_tl=this;
			}
	}
	
FAFrame.prototype.switchTo = function()
	{
		FAUtil.switchToFrame(this);
		this.o_ref.showProperties(this);
	}
	
FAFrame.prototype.getItem = function(sID)
	{
		return this.p_items[sID] ? this.p_items[sID] : null;
	}

FAFrame.prototype.addScriptItem=function(sType, sParent, sId, sName, oParams)
	{
		var iGroup=11, iFlags=0x21, oDefParams, oObj={}, oParent, id;
		
		if (oParent=this.p_items[sParent])
			sParent=this.p_items[sParent].full_id;
		else
			if (this.id != sParent)
				return false
		if (!sName)
			sName=sType.toUpperCase();

		id=FAUtil.getUniqueID(sId ? sId : sType)[0];

		oDefParams={'id' : [FAStrings.prop_id, id, 'readonly']}
		
		switch (sType)
			{
				case 'if':
						iGroup=12;
						oDefParams['expression']=[FAStrings.prop_expression, '', 'textarea'];
					break;
				case 'switch':
						iGroup=13;
						oDefParams['expression']=[FAStrings.prop_expression, '', 'textarea'];
					break;
				case 'event':
						iGroup=10;
						oDefParams['event']=[FAStrings.prop_event, 0, 'events'];
					break;
				case 'set':
						oDefParams['variable']=[FAStrings.prop_variable, '', 'text'];
						oDefParams['expression']=[FAStrings.prop_expression, '', 'textarea'];
					break;

				case 'call':
						oDefParams['method']=[FAStrings.prop_method, '', 'text'];
					break;

				case 'case':
						iGroup=15;
						oDefParams['compare']=[FAStrings.prop_value, '', 'textarea'];
					break;

				case 'else':
						iGroup=14;
					break;

				case 'otherwise':
						iGroup=15;
					break;

				case 'goto':
						oDefParams['frame']=[FAStrings.prop_frame, '', 'frames'];
					break;
			}

		oDefParams['active']=[FAStrings.prop_active, true, 'checkbox'];
		if (oParams && typeof(oParams)=='object')
			{
				for (var x in oParams)
					if (x!='id' && oDefParams[x])
						oDefParams[x][1]=oParams[x];
			}
		if (oParams && oParams['event'])
			{
				sName+=' ('+this.o_ref.events[oParams['event']]+')';
			}
		oObj.oParams=oDefParams;
		oObj.isLocked=false;
		oObj.isScript=true;
		oObj.o_ref=this;
		oObj.local_id=id;
		oObj.full_id=this.id+'|'+id;
		oObj.name=sName;
		oObj.sType=sType;
		oObj.iGroup=iGroup;
		if (!(oObj.oNode=this.o_ref.p_tree.insertNode(oObj.full_id, sName, sParent, iGroup, iFlags, 11, oObj)))
			return false;
		
		this.p_items[id]=oObj;
		
		this.selectItem(id);

		/* double nodes */
		
		if (!sId)
			{
				this.o_ref.p_tree.expandNode(sParent, true);
				switch (sType)
					{
						case 'if':
							this.addScriptItem('else', id, null, 'ELSE');
						break;
						case 'switch':
							this.addScriptItem('otherwise', id, null, 'OTHERWISE');
						break;
					}
			}
		return oObj;
	}

FAFrame.prototype.addItem=function(sType, sName, iX, iY, iWidth, iHeight, oParams)
	{
		var id=sType,  p,  oDefParams, iGroup=0, fObjBg='#4b4b4b', fObjBorder='#505050', oEvents, oProperties, oMethods;
		if (oParams)
			{
				if (oParams.id)
					id=oParams.id;
				if (oParams.name)
					sName=oParams.name;
			}
		
		id=FAUtil.getUniqueID(id);
		if (!sName)
			{
				if (FAStrings['name_'+sType])
					sName=FAStrings['name_'+sType]+' '+id[1];
				else
					sName=sType+' '+id[1];
			}
		id=id[0];

		if (!iWidth)
			iWidth=FAUtil.defaultObjects[sType] ? FAUtil.defaultObjects[sType].w : 25;

		if (!iHeight)
			iHeight=FAUtil.defaultObjects[sType] ? FAUtil.defaultObjects[sType].h : 25;

		if (iX === undefined || iX === null)
			iX=Math.floor((this.o_ref.z_editor.offsetWidth- iWidth) / 2);

		if (iY === undefined || iY === null)
			iY=Math.floor((this.o_ref.z_editor.offsetHeight-iHeight) / 2);
		
		oDefParams={
			'id' : [FAStrings.prop_id, id, 'readonly'],
			'name' : [FAStrings.prop_object_name, sName, 'text'],
			'x' : [FAStrings.prop_x, iX, 'text'],
			'y' : [FAStrings.prop_y, iY, 'text'],
			'width' : [FAStrings.prop_width, iWidth, 'text'],
			'height' : [FAStrings.prop_height, iHeight, 'text'],
			'visibility': [FAStrings.prop_visible, true, 'checkbox'],
			'proportional' : [FAStrings.prop_proportions, false, 'checkbox'],
			'locked' : [FAStrings.prop_lock, false, 'checkbox']
		}

		oEvents={
			0: FAStrings.event_none,
			'onkeydown': FAStrings.event_on_keydown,
			'onkeyup': FAStrings.event_on_keyup,
			'onmousedown': FAStrings.event_on_mousedown,
			'onmouseup': FAStrings.event_on_mouseup,
			'onmouseover': FAStrings.event_on_mouseover,
			'onmousemove': FAStrings.event_on_mousemove,
			'onmouseout': FAStrings.event_on_mouseout,
			'onclick': FAStrings.event_on_click
			};

		oProperties=
			{
			};

		oMethods=
			{
			};

		var obj, fobj;
		switch(sType)
			{

				case 'label':
					obj=this.o_ref.z_editor_body.document.createElement('<INPUT type="text" readonly="true">');
					fobj=this.o_frame_body.document.createElement('DIV');
					obj.className='label';
					fObjBg='#444400';
					obj.hideFocus=true;
					iGroup=4;
					oDefParams['label_text']=[FAStrings.prop_text, '', 'textarea'];
					oDefParams['font']=[FAStrings.prop_font, '', 'select', FAUtil.fonts];
					oDefParams['bold']=[FAStrings.prop_bold , '', 'checkbox'];
					oDefParams['italic']=[FAStrings.prop_italic , '', 'checkbox'];
					oDefParams['underline']=[FAStrings.prop_underline , '', 'checkbox'];
					oDefParams['border']=[FAStrings.prop_border, '', 'checkbox'];
					oDefParams['fontsize']=[FAStrings.prop_font_size, '', 'fontsize'];
					if (oParams)
						{
							if (oParams['label_text'])
								obj.value=oParams['label_text'];
							if (oParams['fontsize'])
								obj.style.fontSize=oParams['fontsize'];
						}
					break;

				case 'textinput':
						obj=this.o_ref.z_editor_body.document.createElement('<INPUT type="text" class="text" readonly="true" UNSELECTABLE ATOMICSELECTION>');
						fobj=this.o_frame_body.document.createElement('DIV');
						fObjBg='#aaaaaa';
						if (!iHeight)
							iHeight=20;
						iGroup=5;
						fObjBorder='';
						oDefParams['multiline']=[FAStrings.prop_multiline, false, 'checkbox'];
						oDefParams['max_size']=[FAStrings.prop_max_size, 0, 'int'];
						oDefParams['default']=[FAStrings.prop_default_text, '', 'textarea'];
						oDefParams['XSMPL_target_state']=[FAStrings.prop_target_text, '', 'textarea'];
						oDefParams['XSMPL_error_message']=[FAStrings.prop_error_message, '', 'textarea'];
						oDefParams['XSMPL_ignore_case']=[FAStrings.prop_ignore_case, false, 'checkbox'];
						oDefParams['font']=[FAStrings.prop_font, '', 'select', FAUtil.fonts];
						oDefParams['bold']=[FAStrings.prop_bold, '', 'checkbox'];
						oDefParams['italic']=[FAStrings.prop_italic, '', 'checkbox'];
						oDefParams['underline']=[FAStrings.prop_underline, '', 'checkbox'];
						oDefParams['fontsize']=[FAStrings.prop_font_size, '', 'fontsize'];
						if (oParams)
							{
								if (oParams['default'])
									obj.value=oParams['default'];
								if (oParams['fontsize'])
									obj.style.fontSize=oParams['fontsize'];
							}
					break;

				case 'message':
						obj=this.o_ref.z_editor_body.document.createElement('<INPUT type="text" class="message" UNSELECTABLE ATOMICSELECTION>');
						obj.isFixed=true;
						fobj=this.o_frame_body.document.createElement('DIV');
						fObjBg='#feb041';
						iWidth=35;
						iHeight=35;
						iGroup=6;	
						fObjBorder='';
						obj.isUnresizable=true;
						delete oDefParams['visibility'];
						delete oDefParams['proportional'];
						oEvents={'onalert': FAStrings.event_onalert}
						oDefParams['text']=[FAStrings.prop_text, '', 'textarea'];
						oDefParams['type']=[FAStrings.prop_type, '', 'select', {'default':'default', 'error':'error'}];
					break;

				case 'checkbox':
						obj=this.o_ref.z_editor_body.document.createElement('<INPUT type="checkbox" class="checkbox" readonly="true" UNSELECTABLE ATOMICSELECTION>');
						fobj=this.o_frame_body.document.createElement('DIV');
						fObjBg='#dbdbdc';
						obj.isFixed=true;
						obj.contentEditable=false;
						obj.onclick=FAUtil.cancelEvent;
						iWidth=16;
						iHeight=16;
						iGroup=7;
						obj.isUnresizable=true;
						delete oEvents['onkeyup'];
						delete oEvents['onkeydown'];
						oDefParams['checked']=[FAStrings.prop_default_state, false, 'checkbox'];
						if (oParams && oParams['checked'])
							obj.checked=true;
						oDefParams['XSMPL_target_state']=[FAStrings.prop_target_state, '', 'checkbox'];
						oDefParams['XSMPL_error_message']=[FAStrings.prop_error_message, '', 'textarea'];
					break;

				case 'button':
						obj=this.o_ref.z_editor_body.document.createElement('<INPUT type="button" class="button" readonly="true" UNSELECTABLE ATOMICSELECTION value="Button">');
						fobj=this.o_frame_body.document.createElement('DIV');
						fObjBg='#dbdbdc';
						iGroup=8;
						delete oEvents['onkeyup'];
						delete oEvents['onkeydown'];
						oDefParams['input_value']=[FAStrings.prop_default_text, 'Button', 'text'];
						oDefParams['XSMPL_goto']=[FAStrings.prop_goto, 0, 'frames'];
						if (oParams && oParams['input_value'])
							obj.value=oParams['input_value'];
					break;

				case 'hotspot':
						obj=this.o_ref.z_editor_body.document.createElement('<INPUT type="text" readonly HIDEFOCUS UNSELECTABLE ATOMICSELECTION>');
						fobj=this.o_frame_body.document.createElement('DIV');
						fObjBg='#ff0000';
						fObjBorder='';
						fobj.style.cssText='filter:alpha(opacity=50);'
						obj.className='hotspot';
						iGroup=3;
						oDefParams['XSMPL_goto']=[FAStrings.prop_goto, 0, 'frames'];
					break;

				case 'image':
						iGroup=2;
						obj=this.o_ref.z_editor_body.document.createElement('<IMG>');
						
						fobj=this.o_frame_body.document.createElement('IMG');
						obj.className='empty';

						obj.src=this.o_ref.images_dir+'empty.gif';
						obj.style.backgroundImage='url('+this.o_ref.images_dir+'empty_bg.gif)';
						fobj.src=this.o_ref.images_dir+'empty.gif';

						obj.propsLocked=0;
						oDefParams['src']=[FAStrings.prop_source, null, 'file'];
						oDefParams['size']=[FAStrings.prop_size, null, 'readonly'];
						oDefParams['real_width']=[FAStrings.prop_orig_width, null, 'readonly']
						oDefParams['real_height']=[FAStrings.prop_orig_height, null, 'readonly']
						oDefParams['restore']=[FAStrings.prop_orig_size, FAStrings.prop_orig_restore, 'command'];
					break;
				default:
					return;
			}

		if (oParams && typeof(oParams)=='object')
			{
				for (var x in oParams)
					if (x!='id' && oDefParams[x])
						oDefParams[x][1]=oParams[x];
			}

		obj.oParams=oDefParams;
		obj.oEvents=oEvents;
		obj.oMethods=oMethods;
		obj.oProperties=oProperties;
		obj.isLocked = oDefParams['locked'][1];
		if (oDefParams['proportional'])
			obj.propsLocked = oDefParams['proportional'][1] ? (iWidth / iHeight) : 0;
		obj.iGroup=iGroup;
		obj.o_ref=this;
		obj.local_id=id;
		obj.full_id=this.id+'|'+id;
		obj.name=sName;
		obj.sType=sType;
		obj.isScript=false;

		if (obj)
			{
				with(obj.style)
					{
						position='absolute';
						posLeft=iX;
						posTop=iY;
					}
				obj.style.posWidth=iWidth;
				obj.style.posHeight=iHeight;
				obj.style.zIndex=++this.items_count;
				this.o_screen.appendChild(obj);
			}

		if (fobj)
			{
				with(fobj.style)
					{
						position='absolute';
						posLeft=2+iX * FAUtil.factor_x;
						posTop=2+iY * FAUtil.factor_y;
						if (fObjBorder)
							border='1px solid '+fObjBorder;
						backgroundColor=fObjBg;
						fontSize='1px';
						zIndex=this.items_count;
					}
				
				obj.oFrameObj=fobj;
				fobj.style.posWidth=iWidth * FAUtil.factor_x;
				fobj.style.posHeight=iHeight * FAUtil.factor_y;
				this.o_frame_body.appendChild(fobj);
			}

		this.p_items[id]=obj;
		obj.oNode=this.o_ref.p_tree.insertNode(obj.full_id, sName, this.id, iGroup, 1, iGroup);
		if (obj.sType=='image' && obj.oParams['src'][1])
			{
				FAUtil.setImage(obj, obj.oParams['src'][1], obj.oParams['src'][1]);
			}
		this.o_ref.z_editor_body.document.focus();
		this.selectItem(id);
		return obj;
	}


FAFrame.prototype.getLayoutXml=function()
	{
		var x, oItem, sTag='', sAttribs='', sContent='', sResult='', aTempItems=[], aItems=[], z=0, p_min=0, p_max=0;
		for(x in this.p_items)
			if (!this.p_items[x].isScript)
				{
					z=this.p_items[x].style.zIndex;
					if (z < p_min) p_min = z;
					if (z >= p_max) p_max = z;
					if (aItems[z])
						{
							aTempItems=aItems.slice(0, z);
							aItems=aTempItems.concat([this.p_items[x]], aItems.slice(z));
						}
					else
						aItems[z]=this.p_items[x];
				}

		if (this.oParams.description[1])
			sResult+='<DESCRIPTION><![CDATA['+FAUtil.stripTags(this.oParams.description[1])+']]></DESCRIPTION>\n';
		for (x=p_min; x <= p_max; x++)
			if (aItems[x])
				{
					sTag='';
					sAttribs='';
					sContent='';
					oItem=aItems[x];
					switch (oItem.sType)
						{
							case 'label':
									sTag='LABEL';
									sAttribs=FAUtil.getAttributeParam(oItem, 'label_text')+
									FAUtil.getAttributeParam(oItem, 'fontsize')+
									FAUtil.getAttributeParam(oItem, 'font')+
									FAUtil.getAttributeParam(oItem, 'bold')+
									FAUtil.getAttributeParam(oItem, 'italic')+
									FAUtil.getAttributeParam(oItem, 'underline');
								break;
	
							case 'textinput':
									sTag='TEXTINPUT';
									sAttribs=FAUtil.getAttributeParam(oItem, 'multiline')+
									FAUtil.getAttributeParam(oItem, 'XSMPL_target_state')+
									FAUtil.getAttributeParam(oItem, 'XSMPL_error_message')+
									FAUtil.getAttributeParam(oItem, 'XSMPL_ignore_case')+
									FAUtil.getAttributeParam(oItem, 'fontsize')+
									FAUtil.getAttributeParam(oItem, 'default')+
									FAUtil.getAttributeParam(oItem, 'font')+
									FAUtil.getAttributeParam(oItem, 'bold')+
									FAUtil.getAttributeParam(oItem, 'italic')+
									FAUtil.getAttributeParam(oItem, 'underline');
								break;
	
							case 'message':
									sTag='MESSAGE';
									sAttribs=FAUtil.getAttributeParam(oItem, 'type')
									+FAUtil.getAttributeParam(oItem, 'text');
								break;
	
							case 'checkbox':
									sTag='CHECKBOX';
									sAttribs=FAUtil.getAttributeParam(oItem, 'checked')+
									FAUtil.getAttributeParam(oItem, 'XSMPL_target_state')+
									FAUtil.getAttributeParam(oItem, 'XSMPL_error_message');
								break;
	
							case 'button':
									sTag='BUTTON';
									sAttribs=FAUtil.getAttributeParam(oItem, 'input_value')+
									FAUtil.getAttributeParam(oItem, 'XSMPL_goto');
								break;
	
							case 'hotspot':
									sTag='HOTSPOT';
									sAttribs=FAUtil.getAttributeParam(oItem, 'XSMPL_goto')
								break;

							case 'image':
									sTag='IMAGE';
									sAttribs=FAUtil.getAttributeParam(oItem, 'src')+
									FAUtil.getAttributeParam(oItem, 'size')+
									FAUtil.getAttributeParam(oItem, 'real_width')+
									FAUtil.getAttributeParam(oItem, 'real_height');
								break;
						}
					if (sTag)
						{
							sAttribs+=FAUtil.getAttributeParam(oItem, 'id')+FAUtil.getAttributeParam(oItem, 'name')+
								FAUtil.getAttributeParam(oItem, 'x')+FAUtil.getAttributeParam(oItem, 'y')+
								FAUtil.getAttributeParam(oItem, 'width')+FAUtil.getAttributeParam(oItem, 'height')+
								FAUtil.getAttributeParam(oItem, 'proportional')+
								FAUtil.getAttributeParam(oItem, 'visibility')+
								FAUtil.getAttributeParam(oItem, 'locked');
							sResult+='\t\t\t\t<'+sTag+' '+sAttribs+ (sContent ? '><![CDATA['+sContent+']]></'+sTag+'>' : '/>')+'\n';
						}
				}
		return '\t\t\t<FRAME id="'+this.id+'" '+FAUtil.getAttributeParam(this, 'frame_name')
		+FAUtil.getAttributeParam(this, 'XSMPL_error_message')
		+FAUtil.getAttributeParam(this, 'XSMPL_frame_true')
		+FAUtil.getAttributeParam(this, 'XSMPL_frame_false')+'>\n'+sResult+'\t\t\t</FRAME>\n';
	}
		
FAFrame.prototype.pGetLocalId=function(sFullId)
	{
		var t;
		if (t=sFullId.match(/(.*)\|(.*)/))
			return t[2];
		else
			return sFullId;
	}

FAFrame.prototype.pGetEvents=function(sEventId)
	{
		var oEvent, sParent, oParent, t;
		if (oEvent=this.p_items[sEventId])
			{
				sParent=this.pGetLocalId(this.o_ref.p_tree.getAncestor(oEvent.full_id));
				oParent=this;
				if (oParent.id==sParent || (oParent=this.p_items[sParent]))
					return oParent.oEvents;
			}
		return null;
	}

FAFrame.prototype.getAllProperties=function()
	{
	}

FAFrame.prototype.getScriptXml=function()
	{
		var x, oItem, sTag='', sAttribs='', sContent='', sResult='', aItems={}, z=0;
		if (this.o_node)
			{
				sResult=FAUtil.getScriptNodeXml(this.o_node, '\t\t\t\t');
			}
		return '\t\t\t<DATA for="'+this.id+'">\n'+sResult+'\t\t\t</DATA>\n';
	}