function FAScenario()
	{
		this.title=FAStrings.untitled_scenario;
		this.author='';
		this.file='';
		this.host='';
		this.frame_prefix = FAStrings.frame_prefix;
		this.succes_perc = 80;
		this.time = 300;
		this.progress = 0;
		this.is_complex = false;
		this.is_new = true;
		this.max_steps=10;

		this.p_frames=[];
		this.p_keys={};
		this.p_items={};
		this.oParams=null;
		this.p_description='';
		this.o_ref=null;

		this.oParams={
				's_title' : [FAStrings.scen_title, FAStrings.scen_title_value, 'text'],
				's_file': [FAStrings.scen_file, '', 'readonly'],
				's_host': [FAStrings.scen_host, '', 'readonly'],
				's_author' : [FAStrings.scen_author, '', 'text'],
				's_code': [FAStrings.scen_code, '', 'text'],
	
				's_frame': [FAStrings.scen_frame, this.frame_prefix, 'text'],
				's_success': [FAStrings.scen_success, this.succes_perc, 'int'],
				's_time': [FAStrings.scen_time, this.time, 'int'],
				's_maxsteps': [FAStrings.scen_maxsteps, this.max_steps, 'int'],

				's_edit_options': [FAStrings.scen_panels, FAStrings.scen_edit_panels, 'command'],

				'XSMPL_default_error': [FAStrings.scen_default_error, FAStrings.scen_default_error_text, 'textarea'],
				'XSMPL_start_frame': [FAStrings.scen_start_frame, '', 'frames'],
				'XSMPL_finish_frame': [FAStrings.scen_finish_frame, '', 'frames'],
				's_mode': [FAStrings.scen_scripting_mode, this.is_complex, 'select', {0 : FAStrings.scen_simple_mode, 1: FAStrings.scen_complex_mode}]
			}

		this.p_panels={
				'task': {title : FAStrings.panel_task, height: 200, data : '', expanded : 0},
				'instruct': {title : FAStrings.panel_instructions, height: 200, data : '', expanded : 1}
			};

/*		this.p_messages={
				'error': 'You performed illegal action. Please, read carefully the instruction and try once more.'
			};
*/
		this.vars={
				'msg_notpassed' : ['string', FAStrings.msg_notpassed],
				'msg_passed' : ['string', FAStrings.msg_passed],
				'msg_incomplete' : ['string', FAStrings.msg_incomplete]
			};
	return this;
}
FAScenario.prototype.getUniqueID = function(sID)
	{
		if (!sID)
			sID='uniqid';
		var index=1, pre_id, p;
		if (p=sID.match(/(.*)_([\d]+)$/))
			{
				pre_id=p[1];
				index=parseInt(p[2]);
			}
		else
			pre_id=sID;
		if (this.p_items[pre_id] || this.p_items[pre_id+'_'+index])
			{
				
				while(this.p_items[pre_id+'_'+index])
					index++;
				return pre_id+'_'+index;
			}
		return pre_id;
	}
	
FAScenario.prototype.addItem=function(sType, sId, sName, oParams)
	{
		var iGroup=11, iFlags=0x21, iIcon=11, oDefParams, oObj={}, oParent;

		if (!sName)
			sName=sType.toUpperCase();

		id=this.getUniqueID(sId ? sId : sType);

		oDefParams={'id' : ['ID', id, 'readonly']}

		switch (sType)
			{
				case 'message':
						sName='Message';
						oEvents={'onalert': 'On Alert'}
						iGroup=20;
						iIcon=6;
						oDefParams['text']=['Text', '', 'textarea'];
						oDefParams['type']=['Type', '', 'select', {'default':'default', 'error':'error'}];
					break;
				case 'set':
						oDefParams['variable']=['Variable', '', 'text'];
						oDefParams['type']=['Type', 'number', 'variable_type'];
						oDefParams['expression']=['Expression', '', 'textarea'];
					break;
				case 'call':
						oDefParams['method']=['Procedure', '', 'text'];
					break;
				case 'goto':
						oDefParams['frame']=['Frame', '', 'frames'];
					break;
			}

		oDefParams['active']=['Active', true, 'checkbox'];

		if (oParams && typeof(oParams)=='object')
			{
				for (var x in oParams)
					if (x!='id' && oDefParams[x])
						oDefParams[x][1]=oParams[x];
			}

		oObj.oParams=oDefParams;
		oObj.isLocked=false;
		oObj.isScript=true;
		oObj.o_ref=this;
		oObj.local_id=id;
		oObj.full_id='root|'+id;
		oObj.name=sName;
		oObj.sType=sType;
		oObj.iGroup=iGroup;
		var oRoot=this.o_ref.p_tree.keys[0], i=0; sNext=0;

		if (oRoot.oHolder)
			for(i=0; i<oRoot.oHolder.children.length; i++)
				{
					if (oRoot.oHolder.children[i].iGroup < 10)
						{
							sNext=oRoot.oHolder.children[i].sKey;
							break;
						}
				}

		if (!(oObj.oNode=this.o_ref.p_tree.insertNode(oObj.full_id, sName, 0, iGroup, iFlags, iIcon, oObj, sNext ? sNext : null)))
			return false;
		this.p_items[id]=oObj;
		return oObj;
	}

FAScenario.prototype.clear = function()
	{
		var x;
		this.p_frames=[];
		for(x in this.p_keys)
			{
				this.p_keys[x].remove();
				delete this.p_keys[x];
			}
		this.p_keys={};
		this.o_ref.p_tree.clear();
		this.description='';
		this.author='';
		this.host='';
		this.file='';
	}
	
FAScenario.prototype.setTitle=function(sTitle)
	{
		this.title=sTitle;
		this.o_ref.p_tree.setCaption(this.title)
		this.o_ref.setProperty(this, 's_title', this.title);
		if (this.o_ref.z_current_prop===this)
			this.o_ref.showProperties(this);
		document.title=this.o_ref.title_prefix+' - '+sTitle;
	}

FAScenario.prototype.getXmlString=function(bPreview)
	{
		var x, sResult='', sLayout='', sScript='', sVars='', oObj;
		sResult=
		'\t\t<PROPERTY name="s_author"><![CDATA['+FAUtil.exportValue(this.oParams['s_author'][1])+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="s_code"><![CDATA['+FAUtil.exportValue(this.oParams['s_code'][1])+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="s_frame"><![CDATA['+FAUtil.exportValue(this.oParams['s_frame'][1])+']]></PROPERTY>\n'
		//+'\t\t<PROPERTY name="mission"><![CDATA['+FAUtil.exportValue(this.oParams['s_mission'][1])+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="s_time"><![CDATA['+FAUtil.exportValue(this.oParams['s_time'][1])+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="s_progress"><![CDATA['+this.progress+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="s_maxsteps"><![CDATA['+FAUtil.exportValue(this.oParams['s_maxsteps'][1])+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="s_success"><![CDATA['+FAUtil.exportValue(this.oParams['s_success'][1])+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="XSMPL_default_error"><![CDATA['+FAUtil.exportValue(this.oParams['XSMPL_default_error'][1])+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="XSMPL_start_frame"><![CDATA['+FAUtil.exportValue(this.oParams['XSMPL_start_frame'][1])+']]></PROPERTY>\n'
		+'\t\t<PROPERTY name="XSMPL_finish_frame"><![CDATA['+FAUtil.exportValue(this.oParams['XSMPL_finish_frame'][1])+']]></PROPERTY>\n';

		var oRoot=this.o_ref.p_tree.keys[0], oObj, t1, t2;

		for (x in this.p_panels)
			{
				sResult+='\t\t<PANEL id="'+x+'" title="'+this.p_panels[x].title+'" height="'
				+(this.p_panels[x].height ? this.p_panels[x].height : 0) +'" expanded="'
				+((this.p_panels[x].expanded && !bPreview) ? 1 : 0)+'">'
				+(typeof(this.p_panels[x].data)=='number' ? this.p_panels[x].data : '<![CDATA['+this.p_panels[x].data+']]>') +'</PANEL>\n';
			}

		for (x in this.vars)
				sVars+='\t\t<SET name="'+x+'" type="'+this.vars[x][0]+'">'+(typeof(this.vars[x][1])=='number' ? this.vars[x][1] : '<![CDATA['+this.vars[x][1]+']]>') +'</SET>\n';

		if (oRoot.oHolder)
			for(i=0; i<oRoot.oHolder.children.length; i++)
				if (oRoot.oHolder.children[i].iGroup > 9 && oRoot.oHolder.children[i].oData)
					{
						oObj=oRoot.oHolder.children[i].oData;
						switch (oObj.sType)
							{
								case 'set':
										if ((t1=oObj.oParams['variable'][1]) && (t2=oObj.oParams['type'][1]))
											sVars+='\t\t<SET id="'+oObj.local_id+'" name="'+oObj.name+'" variable="'+t1+'" type="'+t2+'"><![CDATA['+oObj.oParams['expression'][1]+ ']]></SET>\n';
									break;
								case 'message':
										if ((t1=oObj.oParams['text'][1]) && (t2=oObj.oParams['text'][1]))
											sVars+='\t\t<MESSAGE id="'+oObj.local_id+'" name="'+oObj.name+'" type="'+t2+'"><![CDATA['+t2+ ']]></MESSAGE>\n';
									break;
								case 'goto':
										if (t1=oObj.oParams['frame'][1])
											sVars+='\t\t<GOTO id="'+oObj.local_id+'" name="'+oObj.name+'" frame="'+t1+'" />\n';
									break;
								case 'call':
										if (t1=oObj.oParams['method'][1])
											sVars+='\t\t<CALL id="'+oObj.local_id+'" name="'+oObj.name+'" method="'+t1+'" />\n';
									break;
							}
					}



		for (x=0; x < this.p_frames.length; x++)
			{
				sLayout+=this.p_frames[x].getLayoutXml();
				sScript+=this.p_frames[x].getScriptXml();
			}

		return '\n<FASCRIPT version="1.0">\t<COMPOSITION '
		+FAUtil.getAttributeParam(this, 's_title', 'title')
		+(this.oParams['s_mode'][1] ? ' mode="complex"' : ' mode="simple"')
		+'>\n'+sResult+'\t\t<MAP>\n'+sVars+sScript+'\t\t</MAP>\n\t\t<STRUCTURE>\n'+sLayout+'\t\t</STRUCTURE>\n\t</COMPOSITION></FASCRIPT>';
	}
	
FAScenario.prototype.getFirstFrame=function()
	{
		if (this.o_ref.z_timeline.firstChild)
			return this.o_ref.z_timeline.firstChild;
		return false;
	}

FAScenario.prototype.getLastFrame=function()
	{
		if (this.o_ref.z_timeline.lastChild)
			return this.o_ref.z_timeline.lastChild;
		return false;
	}

FAScenario.prototype.getFrame=function(sKey, iDir)
	{
		if (iDir)
			{
				for (var i=0; i < this.p_frames.length; i++)
					if (this.p_frames[i].id==sKey)
						break;
				if (iDir > 0)
					{
						if (i < this.p_frames.length)
							return this.p_frames[i+iDir];
					}
				else
					{
						if (i < this.p_frames.length)
							return this.p_frames[i-iDir];
					}
			}
		else
			return this.p_keys[sKey];
	}

FAScenario.prototype.setXmlString=function(sXml)
	{
		var oXml=getXml(sXml), cScripts, cStructs, cGlobVars, i, j, oFrame, oObj, oNode, cComposition;
		if (oXml && oXml.documentElement)
			{
				cComposition = oXml.documentElement.selectNodes('/COMPOSITION');
				cGlobVars = oXml.documentElement.selectNodes('(/COMPOSITION/SET | /COMPOSITION/CALL | /COMPOSITION/MESSAGE | /COMPOSITION/GOTO | /COMPOSITION/PROPERTY )');
				cScripts = oXml.documentElement.selectNodes('/COMPOSITION/MAP/DATA');
				cStruct = oXml.documentElement.selectNodes('/COMPOSITION/STRUCTURE/FRAME');
			}
		i=0;
		if (cComposition.length)
			{
				var s='';
				if (s=cComposition[0].getAttribute('title'))
					this.setTitle(s);
				if (s=cComposition[0].getAttribute('mode'))
					this.oParams['s_mode'][1]=s;
			}

		if (cStruct.length)
			while (oNode=cStruct[i++])
				{
					oFrame=this.addFrame(oNode.getAttribute('id'), oNode.getAttribute('frame_name'));
					if (oObj=oNode.getElementsByTagName('DESCRIPTION'))
						{
							if (oObj[0])
								this.o_ref.setProperty(oFrame, 'description', oObj[0].text);
						}
					if (oNode.childNodes.length)
						this.pParseChildNodes(oNode, oFrame);
				}
		i=0;
		if (cScripts.length)
			{
				while (oNode=cScripts[i++])
					if (oFrame=this.getFrame(oNode.getAttribute('for')))
							{
								if (oNode.childNodes.length)
									this.pParseChildNodes(oNode, oFrame, oFrame.id);
							}
			}
		if (cGlobVars.length)
			{
				this.pParseGlobalNodes(cGlobVars);
			}
		if (this.p_frames[0])
			{
				this.p_frames[0].switchTo();
			}
	}
	
FAScenario.prototype.pParseGlobalNodes=function(oNodeColl)
	{
		var i=-1, j=0, oObj, oParams={}, oAttr, oItem;
		while (oObj=oNodeColl[++i])
			{
				oParams={}
				oItem=null;
				if (oObj.attributes.length)
					{
						for (j=0; j<oObj.attributes.length; j++)
							{
								oAttr=oObj.attributes[j];
								switch (oAttr.nodeName.toLowerCase())
									{
										case 'active':
												oParams[oAttr.nodeName]=parseInt(oAttr.nodeValue) ? true : false;
											break;
										default:
												var x=oAttr.nodeValue;
												if (x && typeof (x)=='string')
													x=x.replace(/&amp;/g, "&").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&apos;/g, "'").replace(/&quot;/g, '"');
												oParams[oAttr.nodeName]=x;
									}
							}
					}
				switch (oObj.nodeName)
					{
						case 'SET':
						case 'GOTO':
						case 'CALL':
						case 'MESSAGE':
								this.addItem(oObj.nodeName.toLowerCase(),  oObj.getAttribute('id'), oObj.getAttribute('name'), oParams);
						case 'VAR':
							break;
						case 'PROPERTY':
								var sName=oObj.getAttribute('name');
								if (this.oParams[sName])
									this.oParams[sName][1]=oObj.text;
							break;
						case 'PANEL':
							break;
					}
			}
	}

FAScenario.prototype.pParseChildNodes=function(oNode, oFrame, sParent)
	{
		var i=-1, j=0, oObj, oParams={}, oAttr, oItem;
		while(oNode.childNodes[++i])
			{
				oObj=oNode.childNodes[i];
				oParams={}
				oItem=null;
				if (oObj.attributes.length)
					{
						
						for (j=0; j<oObj.attributes.length; j++)
							{
								oAttr=oObj.attributes[j];
								switch (oAttr.nodeName.toLowerCase())
									{
										case 'name':
										case 'x':
										case 'y':
										case 'width':
										case 'height':
											break;
										case 'active':
										case 'visibility':
										case 'proportional':
										case 'locked':
										case 'bold':
										case 'italic':
										case 'underline':
										case 'multiline':
										case 'checked':
											oParams[oAttr.nodeName]=parseInt(oAttr.nodeValue) ? true : false;
											break;
										default:
												var x=oAttr.nodeValue;
												if (x && typeof (x)=='string')
													x=x.replace(/&amp;/g, "&").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&apos;/g, "'");
												oParams[oAttr.nodeName]=x;
									}
							}
					}
//alert(oObj.nodeName);

				switch (oObj.nodeName)
					{
						case 'IMAGE':
						case 'HOTSPOT':
						case 'LABEL':
						case 'TEXTINPUT':
						case 'MESSAGE':
						case 'CHECKBOX':
						case 'BUTTON':
								oFrame.addItem(oObj.nodeName.toLowerCase(), oObj.getAttribute('name'), oObj.getAttribute('x'), oObj.getAttribute('y'), oObj.getAttribute('width'), oObj.getAttribute('height'), oParams);
								this.pParseChildNodes(oObj, oFrame);
							break;
						case 'EVENT':
								sParent=oObj.getAttribute('for');
								oItem=oFrame.addScriptItem(oObj.nodeName.toLowerCase(), sParent, oObj.getAttribute('id'), oObj.getAttribute('name'), oParams);
								this.pParseChildNodes(oObj, oFrame, oItem ? oItem.local_id : undefined);
							break;
						case 'IF':
						case 'SWITCH':
						case 'SET':
						case 'ELSE':
						case 'CALL':
						case 'CASE':
						case 'OTHERWISE':
						case 'GOTO':
								
								oItem=oFrame.addScriptItem(oObj.nodeName.toLowerCase(), sParent, oObj.getAttribute('id'), oObj.getAttribute('name'), oParams);
								this.pParseChildNodes(oObj, oFrame, oItem ? oItem.local_id : undefined);
							break;
					}
					
			}
	}
	
FAScenario.prototype.addFrame=function(sId, sName)
	{
		if (sId)
			{
				var index=1, pre_id, p;
				if (p=sId.match(/(.*)_([\d]+)$/))
					{
						pre_id=p[1];
						index=parseInt(p[2]);
					}
				else
					pre_id=sId;
			}
		else
			{
				pre_id='frame';
				index=this.p_frames.length+1;
			}
		if (this.p_keys[pre_id+'_'+index])
			{
				while(this.p_keys[pre_id+'_'+index])
					index++;
			}
		 sId=pre_id+'_'+index;
		if (!sName)
			sName = this.frame_prefix + ' '+index;

		var frame=new FAFrame(sId);
		frame.name=sName;
		frame.o_scenario=this;
		frame.o_ref=this.o_ref;
		frame.assemble();
		this.p_frames.push(frame);
		this.p_keys[sId]=frame;
		if (this.o_ref.z_prop_has_frames)
			this.o_ref.showProperties(this.o_ref.z_current_prop);
		return frame;
	}
	
FAScenario.prototype.removeFrame=function(sId)
	{
		if (this.p_keys[sId])
			{
				var o=this.p_keys[sId];
				o.remove();
				if (this.o_ref.z_curframe==o)
					this.o_ref.z_curframe=null;
				delete this.p_keys[sId];
				this.o_ref.p_tree.removeNode(sId);
			}
	}

FAScenario.prototype.moveFrame=function(sId, iDir)
	{
		var oFrame, i=0, oTemp;
		if (!iDir)
			iDir = 1;
		
		if (oFrame=this.p_keys[sId])
			{
				for (; i < this.p_frames.length; i++)
					if (this.p_frames[i]===oFrame)
						break;
				if (i < this.p_frames.length)
					{
						if (iDir > 0)
							{
								if (oFrame.o_frame.nextSibling)
									{
										oFrame.o_frame.swapNode(oFrame.o_frame.nextSibling);
										oTemp=this.p_frames.slice(0, i);
										this.p_frames=oTemp.concat([this.p_frames[i+1]], [oFrame], this.p_frames.slice(i+2));
									}
							}
						else
							if (oFrame.o_frame.previousSibling)
								{
									oFrame.o_frame.swapNode(oFrame.o_frame.previousSibling);
									oTemp=this.p_frames.slice(0, i-1);
									this.p_frames=oTemp.concat([oFrame], [this.p_frames[i-1]], this.p_frames.slice(i+1));
								}
					}
			}
	}

FAScenario.prototype.showPreferences=function()
	{
		var res, args={
				'scenario': this,
				'ref' : this.o_ref
			}
		res=showModalDialog("scripts/scenario.html", args, "border:thin; center:yes; dialogHeight:525px; dialogWidth:600px; help:yes; maximize:true; minimize:no; status:no; resizeable:yes");
		if (res && res.preferences)
			{
				var x, oPref=res.preferences;
				
				this.title=oPref.title;
				this.author=oPref.author;
				this.file=oPref.file;
				this.frame_prefix = oPref.frame_prefix;
				this.succes_perc = oPref.succes_perc;
				this.time = oPref.time;
				this.p_description = oPref.description;

				if (oPref.panels)
					for (x in oPref.panels)
						{
							this.p_panels[x]={
									title : oPref.panels[x].title,
									height : oPref.panels[x].height,
									data : oPref.panels[x].data,
									expanded : oPref.panels[x].expanded
								}
						}

				if (oPref.vars)
					for (x in oPref.vars)
						this.vars[x]=oPref.vars[x];

				if (oPref.messages)
					for (x in oPref.messages)
						this.p_messages[x]=oPref.messages[x];
				return true;
			}
		return false;
	}
