<?php 
final class FlexEdFileDialog
	{
		const
			DEFAULT_DIR_NAME='Folder';

		static
			$mime=array(
				'file'=>0,
				'folder'=>1,
				'.html'=>3,
				'.js'=>4,
				'.doc'=>5,
				'.css'=>6,
				'.gif'=>7,
				'.jpg'=>8,
				'.jpeg'=>8,
				'.tiff'=>9,
				'.tif'=>9,
				'.jp2'=>10,
				'.exe'=>11,
				'.com'=>11,
				'.bat'=>11,
				'.chm'=>12,
				'.hlp'=>12,
				'.rar'=>13
				);
			
		private static
			$VARS='',
			$ERROR=false,
			$BUFFER='';

		static function PROCESS($_dir=null)
			{
				FLEX::NO_CACHE();
				file_put_contents('trace.log',$_REQUEST);
				if ($_SERVER['REQUEST_METHOD']=='POST')
					{
						try
							{
								switch($action=$_POST['file_action'])
									{
										case 'mkdir':
												self::MKDIR();
											break;
										case 'delete':
												self::DELETE();
											break;
										case 'rename':
												self::RENAME();
											break;
										case 'upload':
												self::UPLOAD();
											break;
										default:
											self::$ERROR=' ';
									}
							}
						catch(Exception $E)
							{
								self::$ERROR=$E->getMessage();
							}
						echo '<HTML><HEAD><SCRIPT>', "\n",
						'flex_action="', addslashes($action), '";', "\n";

						if(self::$ERROR)
							{
								echo 'flex_error="', addslashes(self::$ERROR), '"', ";\n";
							}
						else
							{
								if (self::$VARS)
									foreach(self::$VARS as $k=>$v)
										echo $k, '="', addslashes($v), '";', "\n";
							}
						echo '</SCRIPT></HEAD><BODY></BODY></HTML>';
						return true;
					}
				return false;
			}

		static function QUERY($_dir=null)
			{

				file_put_contents('trace.log', print_r($_REQUEST,true));
				
				if (!$_dir)
					$_dir=FLEX::$document_root;
					//die($_dir);

				 $f=fopen("log111.txt","w");
                fwrite($f,"aaa_".$_dir);
				$t=$_GET['query'];
				$dirname=FLEX::CANONICAL_NAME($t, true, true);
				
				$dirname_short=FLEX::CANONICAL_NAME($t);
				
				$root=FLEX::CANONICAL_NAME($_dir, true, true);
				
				$root_list=self::LIST_DIR($_dir, null, null, true);
				/*var_dump($_dir);
				
				var_dump($root_list);
				die();*/
				$sub_dirs=array();
				if (!$ar=self::LIST_DIR($t))
					{
						$ar=$root_list;
					}
				else
					$sub_dirs=array_values(array_diff($dirname, $root));
				$names=$ar['name'];
				ob_start();
				echo '<dirstruct>';
				if (is_array($root_list))
					{
						foreach($root_list['name'] as $k=>$v)
							{
								echo '<', FLEX::CONVERT($v), '|', FLEX::CONVERT($v), '|0|', ($v==$dirname_short ? '1' : '0'), '>';
								if ($v==$sub_dirs[0])
									for($i=1, $L=sizeof($sub_dirs); $i < $L; $i++)
										echo '<', implode('/', array_slice($sub_dirs, 0, $i)), '/', FLEX::CONVERT($sub_dirs[$i]), '|', FLEX::CONVERT($sub_dirs[$i]), '|', $i, '|', ($i==$L-1 ? '1' : '0'), '>';
							}
					}
				echo '</dirstruct>';
				echo '<filelist src="', $dirname_short, '">';
				if (is_array($names))
					{
						foreach($names as $k=>$v)
							{
								if (self::$mime[$ar['type'][$k]])
									$icon_id=self::$mime[$ar['type'][$k]];
								elseif ($ar['size'][$k]===null)
									$icon_id=1;
								else
								$icon_id=0;
								echo '<k', FLEX::CONVERT(basename($v)), '|', FLEX::CONVERT($v), '|', $icon_id, '|', ($ar['stat'][$k] & FLEXED_IFDIR ? 2 : 1), '|size:', $ar['size'][$k], '>';
							}
					}
				echo '</filelist>';
				$contents=ob_get_clean();
				if (self::$ERROR)
					echo '<error>', self::$ERROR, '</error>';
				//echo htmlspecialchars($contents);
				echo $contents;
			}

		static function LIST_DIR($_dirname, $_exclusions=null, $_sort='name', $_dirs_only=false)
			{
               
                //die(1);
				$files=array();
				$dirs=array();
				if (!$_dirname)
					$_dirname=FLEX::$document_root;
				
				$filepath=rtrim(FLEX::CANONICAL_NAME($_dirname, true), DIRECTORY_SEPARATOR);
				
				if (!file_exists($filepath))
					{
					
						self::$ERROR='  ';
						return false;
					}

				if (!is_dir($filepath))
					{
					
						self::$ERROR='   ';
					}

				if (is_array($_exclusions))
					{
						$_exclusions=array_flip($_exclusions);
						$_exclusions['.']=1;
						$_exclusions['..']=1;
					}
				else
					$_exclusions=array('.'=>1, '..'=>1);

				$pdir=getcwd();
					
				$order=(substr($_sort, -1, 1)=='-') ? SORT_DESC : SORT_ASC;
				
				$dir_name=array();
				$dir_access=array();
				$dir_mod=array();
				$dir_stat=array();
				$dir_type=array();
				$dir_sizes=array();
				
				$name=array();
				$sizes=array();
				$access=array();
				$type=array();
				$stat=array();
				$mod=array();

				/*$filepath = str_replace('//', '/', $filepath);
				echo $filepath;
				var_dump(is_dir($filepath));
				//chdir($filepath);
				echo 'nice';
				die($filepath);*/
				
				if ($dir = opendir($filepath))
					{

						while(false !== ($file = readdir($dir)))
							if (!isset($_exclusions[$file]))
								{
									$fstatus=stat($fpath=$filepath.DIRECTORY_SEPARATOR.$file);
									if (FLEXED_IFDIR == ($fstatus[2] & FLEXED_IFMT))
										{
											$dir_name[]=$file;
											$dir_access[]=$fstatus[8];
											$dir_mod[]=$fstatus[9];
											$dir_stat[]=$fstatus[2];
											$dir_type[]=null;
											$dir_sizes[]=null;
										}
									elseif (!$_dirs_only)
										{
											$name[]=$file;
											$stat[]=$fstatus[2];
											$access[]=$fstatus[8];
											$mod[]=$fstatus[9];
											$type[]=strrchr($file, '.');
											$sizes[]=$fstatus[7];
										}
								}

						switch($_sort)
							{
								case 'mod':
									array_multisort(
										$dir_mod, SORT_NUMERIC, $order,
										$dir_name, $dir_sizes, $dir_type, $dir_access, $dir_stat);
									array_multisort(
										$mod, SORT_NUMERIC, $order,
										$name, $sizes, $type, $access, $stat);
								break;
								case 'access':
									array_multisort(
										$dir_access, SORT_NUMERIC, $order,
										$dir_name, $dir_sizes, $dir_type, $dir_mod, $dir_stat);
									array_multisort(
										$access, SORT_NUMERIC, $order,
										$name, $sizes, $type, $mod, $stat);
								break;
								case 'size':
									array_multisort(
										$dir_sizes, SORT_NUMERIC, $order,
										$dir_name, $dir_type, $dir_access, $dir_mod, $dir_stat);
									array_multisort(
										$sizes, SORT_NUMERIC, $order,
										$name, $type, $access, $mod, $stat);
								break;
								case 'type':
									array_multisort(
										$dir_type, SORT_STRING, $order,
										$dir_name, $dir_sizes, $dir_access, $dir_mod, $dir_stat);
									array_multisort(
										$type, SORT_STRING, $_desc ? SORT_DESC : SORT_ASC,
										$name, $sizes, $access, $mod, $stat);
								break;
								default:
									array_multisort(
										$dir_name, SORT_STRING, $order,
										$dir_mod, $dir_sizes, $dir_type, $dir_access, $dir_stat);
									array_multisort(
										$name, SORT_STRING, $order,
										$mod, $sizes, $type, $access, $stat);

							}
						closedir($dir);
					}
				//chdir($pdir);
				return array(
					'name'=>array_merge($dir_name, $name),
					'size'=>array_merge($dir_sizes, $sizes),
					'type'=>array_merge($dir_type, $type),
					'access'=>array_merge($dir_access, $access),
					'mod'=>array_merge($dir_mod, $mod),
					'stat'=>array_merge($dir_stat, $stat)
					);
				
			}

		static function UPLOAD($_dir=null)
			{
				if (!$_dir)
					$_dir=FLEX::$document_root;

				if (isset($_POST['folder']))
					{
						@set_time_limit((int)30);
						if (!$upload=$_FILES['uploadfile'])
							{
								self::$ERROR='   ';
								return false;
							}
						switch($upload['error'])
							{
								case 0:
									if ($_POST['newfilename'])
										{
											$filename=basename($_POST['newfilename']);
											if ((strrchr($filename, '.')===false))
												$filename.=strrchr($upload['name'], '.');
										}
									else
										$filename=$upload['name'];
									$filename=FLEX::TRANSLIT($filename);
									if (file_exists($old_file=FLEX::CANONICAL_NAME($_dir.DIRECTORY_SEPARATOR.$_POST['folder'].DIRECTORY_SEPARATOR.$filename)))
										{
											FLEX::DELETE($old_file, false, true);
										}
									try
										{
											$new_file=FLEX::MOVE_UPLOADED_FILE($upload['tmp_name'], $_dir.DIRECTORY_SEPARATOR.$_POST['folder'], $filename, $error);
											if ($new_file)
												{
													$old = umask(011);
													chmod($new_file, 0777);
													umask($old);
												self::$VARS=array(
													'result'=>' ',
													'filename'=>$filename
													);
												}
											else
												if ($error)
													self::$ERROR=$error;

										}
									catch(Exception $e)
										{
											self::$ERROR=$e->GetMessage();
										}
									return true;
									break;
								case UPLOAD_ERR_INI_SIZE:
									self::$ERROR='    ';
									break;
								case UPLOAD_ERR_FORM_SIZE:
									self::$ERROR='    ';
									break;

								case UPLOAD_ERR_PARTIAL:
									self::$ERROR='  ';
									break;
								case UPLOAD_ERR_NO_FILE:
									self::$ERROR='  ';
									break;
								case 5:
								case UPLOAD_ERR_NO_TMP_DIR:
									self::$ERROR='    ';
									break;
								case UPLOAD_ERR_CANT_WRITE:
									self::$ERROR='      ';
									break;
								default:
									self::$ERROR = ' ';
							}
					}
				if (self::$ERROR)
					self::$VARS=array(
						'result'=>'!',
						'filename'=>$filename
					);
				return false;
			}

		static function GET_UNIQUE_NAME($_basename, $_dir, $_ext=false, $_prefix='', $_postfix='')
			{
				if (preg_match('/(.*)(\d+)$/Uu', $_basename, $xmatch))
					{
						$name=$xmatch[1];
						$x=(int)$xmatch[2];
					}
				else
					{
						$name=$_basename;
						$x=0;
					}
				
				if (!($bname=basename($name, $_ext)))
					$bname=$name;
				$y=strlen($bname);
				if ($dh = @opendir($_dir))
					{
						while (false != ($file = readdir($dh)))
							if (substr($file, 0, $y)==$bname && strrchr($file, '.')==$_ext) //TODO : strtolower on WIN32 platforms
								$names[basename($file, $_ext)] = true;
						@closedir($dh);
					}
				else
					return false;

				while(isset($names[$nm=$bname.($x ? $_prefix.$x.$_postfix : '')]))
					$x++;
				return $nm.$_ext;
			}

		static function MKDIR($_dir=null)
			{
				if (!$_dir)
					$_dir=FLEX::$document_root;
				if (isset($_POST['folder']))
					{
						$folder=$_dir.DIRECTORY_SEPARATOR.trim($_POST['folder']);
						if (!$defname=self::DEFAULT_DIR_NAME)
							$defname='folder';
						$name=self::GET_UNIQUE_NAME($defname, $folder, false, '(', ')');
						$name=FLEX::TRANSLIT($name);
						try
							{
								FLEX::MKDIR($folder.DIRECTORY_SEPARATOR.$name, 0755);
							}
						catch(Exception $e)
							{
								self::$ERROR=$e->GetMessage();
							}
						self::$VARS=array(
							'flex_result'=>' ',
							'filename'=>$name
							);
					}
				return false;
			}

		static function DELETE($_dir=null)
			{
				if (!$_dir)
					$_dir=FLEX::$document_root;

				$filename=$_POST['filename'] ? $_POST['filename'] : $_POST['ifilename'];
				if (!($filename && $filename!='..' &&  $filename!='.'))
					throw new Exception("  ");

				$filename=basename($filename);

				if (isset($_POST['folder']) && $_POST['folder']!='..' && $_POST['folder']!='.')
					{
						$folder=FLEX::CANONICAL_NAME(DIRECTORY_SEPARATOR.trim($_POST['folder']), true);
						if (file_exists($file=$folder.DIRECTORY_SEPARATOR.$filename))
							{
								try
									{
										FLEX::DELETE($file, false, false, $_files);
									}
								catch(Exception $e)
									{
										self::$ERROR=$e->GetMessage();
									}
							}
						self::$VARS=array(
							'flex_result'=>'  ',
							'filename'=>$folder
							);
					}
			}

		static function RENAME($_dir=null)
			{
				if (!$_dir)
					$_dir=FLEX::$document_root;

				$filename=$_POST['filename'] ? $_POST['filename'] : $_POST['ifilename'];

				if (!($filename && $filename!='..' &&  $filename!='.'))
					throw new Exception("  ");
				$filename=basename($filename);

				if (isset($_POST['folder']) && $_POST['prop'])
					{
						$newname=basename($_POST['prop']);
						$folder=$_dir.DIRECTORY_SEPARATOR.trim($_POST['folder']);
						if (file_exists($destination=$folder.DIRECTORY_SEPARATOR.$newname))
							{
								throw new Exception('     ');
							}
						else
							{
								try
									{
										FLEX::MOVE($folder.DIRECTORY_SEPARATOR.$filename, $destination);
									}
								catch(Exception $e)
									{
										self::$ERROR=$e->GetMessage();
									}
							}
						self::$VARS=array(
							'flex_result'=>'  ',
							'filename'=>$newname
							);
					}
				return false;
			}
	}

?>