ListUtil=
	{
		info_body: null,
		visible: false,
		info_x: 0,
		info_y: 0,
		info_dx: 0,
		info_dy: 0,
		timer: 0,
		opacity: 0,

		showInfo: function(sText, bMode)
			{
				if (bMode && sText)
					{
						ListUtil.visible=true;
						var o=ListUtil.info_body, dx=0, dy=0, o;
						if (event.srcElement)
							{
								o=event.srcElement.parentElement;
								while(o.tagName.toLowerCase()!='body')
									{
										if (o.tagName!='TR' && o.tagName!='TD')
											{
												dx+=parseInt(o.offsetLeft, 10);
												dy+=parseInt(o.offsetTop, 10);
											}
										o=o.parentElement;
									}
							}
						ListUtil.info_dx=dx;
						ListUtil.info_dy=dy;
						ListUtil.info_body.innerHTML=sText;
						ListUtil.timer=setTimeout(ListUtil.pStart, 800);
					}
				else
					{
						ListUtil.info_body.style.visibility='hidden';
						ListUtil.visible=false;
						ListUtil.info_body.filters[0].opacity=0;
						if (ListUtil.timer)
							clearInterval(ListUtil.timer);
					}
			},

		pStart: function()
			{
				if (ListUtil.visible)
					{
						var x=ListUtil.info_dx+ListUtil.info_x+5, y=ListUtil.info_dy+ListUtil.info_y+5;
						if (x+ListUtil.info_body.clientWidth > document.body.clientWidth-10)
							x=x-ListUtil.info_body.clientWidth+5;
						if (y+ListUtil.info_body.clientHeight > document.body.clientHeight-10)
							y=y-ListUtil.info_body.clientHeight+5;
						ListUtil.info_body.style.visibility='visible';
						ListUtil.info_body.style.posLeft=x;
						ListUtil.info_body.style.posTop=y;
						ListUtil.info_body.filters[0].opacity=0;
						ListUtil.opacity=0;
						ListUtil.timer=setInterval(ListUtil.pAnimate, 5);
					}
			},

		pAnimate: function()	
			{
				if (ListUtil.opacity >= 100)
					clearInterval(ListUtil.timer);
				else
					{
						ListUtil.opacity+=10;
						ListUtil.info_body.filters[0].opacity=ListUtil.opacity;
					}
			},

		mousemove: function()	
			{
				ListUtil.info_x=event.x;
				ListUtil.info_y=event.y;
			},
		
		cancelEvent: function()
			{
				event.cancelBubble=true;
				return false;
			}
	}
	
function List(id)
	{
		this.p_id=id ? id : "list"+Math.round(Math.random()*1000)+(t=new Date).getTime();
		this.p_body=null;
		this.p_tab=null;
		this.p_tab_row=null;
		this.p_keys={};
		this.p_records={};
		
		this.z_cur=[];
		this.z_cur_indexes={};

		this.p_sel_start=null;
		
		this.p_info_body=null;

		this.p_inited=false;
		this.p_isbusy=false;

		this.icon_src='';
		
		this.p_height=0;
		this.p_item_height=20;
		this.p_col_items=0;
		this.p_cell_width=0;
		
		this.onselect=null;
		this.ondblclick=null;
		this.onkeydown=null;
		this.oncontextmenu=null;

		return this;
	}

List.prototype.assemble=function()
	{
		document.write('<DIV id="'+this.p_id+'" class="olist"></DIV>');
		this.p_body=document.getElementById(this.p_id);
		this.p_body.o_root=this;
		this.p_body.onselectstart=ListUtil.cancelEvent;
		this.p_body.oncontrolselect=this.pEvControl;
		this.p_body.onkeydown=this.pKeyDown;
		this.p_body.onmousewheel=this.pMouseWheel;
		this.p_body.onmousedown=this.pBodyMouseDown;
		this.p_body.oncontextmenu=this.pContextMenu;
		
		var tab=document.createElement('<TABLE style="height:100%" border=0 cellspacing=0 cellpadding=0></TABLE>');
		if (!ListUtil.info_body)
			{
				var info=document.createElement('DIV');
				info.style.cssText='position:absolute; display:block; border:1px solid #000000; white-space: pre; width:150px; padding:7px; background:infobackground';
				info.style.filter="progid:DXImageTransform.Microsoft.Alpha(opacity=0)";
				ListUtil.info_body=info;
				document.body.insertAdjacentElement('AfterBegin', info);
			}
		this.p_tab=tab;
		this.p_body.appendChild(tab);
		
		var func=new Function('var f=document.getElementById("'+this.p_id+'"); if (f) f.o_root.zResize()'), x;
		this.p_tab_row=tab.insertRow();
		window.attachEvent('onresize', func);
		window.attachEvent('onload', func);
	}

List.prototype.addRecord=function(sKey, sText, sData, iFlags, iconId)
	{
		if (sKey)
			{
				if (this.p_inited)
					{
						var obj=document.createElement('DIV'), cell;
						obj.sKey=sKey;
						obj.sText=sText;
						obj.innerText=sText ? sText : '     ';
						obj.sData=sData;
						obj.icon_id=iconId;
						obj.iFlags=iFlags;
						obj.o_root=this;
						obj.onmousedown=this.pMouseDown;
						obj.onmouseover=this.pMouseOver;
						obj.onmouseout=this.pMouseOut;
						obj.ondblclick=this.pDblClick;
						obj.onmousemove=ListUtil.mousemove;
						if (iconId!=undefined && !isNaN(iconId))
							{
								obj.style.backgroundImage='url('+this.icon_src+')';
								obj.style.backgroundPositionY=-iconId*20;
							}
						this.p_keys[sKey]=obj;
						cell=this.p_tab.cells[this.p_tab.cells.length-1];
						if (!cell || cell.childNodes.length >= this.p_col_items)
							{
								cell=this.p_tab_row.insertCell();
								cell.style.verticalAlign='top';
							}
						cell.appendChild(obj);
					}
				else
					this.p_records[sKey]=[sText, sData, iFlags, iconId];
			}
	}

List.prototype.pContextMenu=function()
	{
		var oObj=event.srcElement, V=document.createEventObject();
		if (oObj.sKey)
			{
				if (this.o_root.pInSelection(oObj))
					{
						V.selection=this.o_root.getSelection();
						this.o_root.pToggleItem('all', 1);
						this.o_root.pToggleItem(oObj, 2);
					}
				else
					{
						this.o_root.pAddToSelection(oObj, 0);
						V.sKey=oObj.sKey;
						V.iFlags=oObj.iFlags;
					}
			}
		V.srcObject=oObj;
		V.offsetY=event.offsetY;
		V.offsetX=event.offsetX;
		V.srcRootElement=this.o_root;
		V.eventName='oncontextmenu';
		this.o_root.p_body.fireEvent('oncontrolselect', V);
		event.cancelBubble=true;
		return false;
	}

List.prototype.deleteRecord=function(sKey)
	{
		if (this.p_keys[sKey])
			{
				this.p_keys[sKey].removeNode(true);
				delete this.p_keys[sKey];
				this.pReformat();
			}
		else if (this.p_records[sKey])
				delete this.p_records[sKey];
	}

List.prototype.pReformat=function()
	{
		var i=0, ncell, aitems=[], delta;
		this.p_isbusy=true;
		this.p_tab.style.visible='hidden';
		while(cell=this.p_tab.cells[i])
			{
				if (cell.childNodes.length==0)
					{
						cell.removeNode();
					}
				else
					{
						delta=this.p_col_items - cell.childNodes.length;
						if (cell.childNodes.length < this.p_col_items)
							{
								if (ncell=this.p_tab.cells[i+1])
									{
										for(j=0; j < delta; j++)
											{
												if (ncell.childNodes.length == 0)
													{
														ncell.removeNode();
														ncell=this.p_tab.cells[i+1];
													}
												if (ncell)
													cell.appendChild(ncell.removeChild(ncell.childNodes[0]));
												else
													break;
											}
									}
							}
						else if (cell.childNodes.length > this.p_col_items)
							{
								if (!(ncell=this.p_tab.cells[i+1]))
									{
										ncell=this.p_tab_row.insertCell();
										ncell.style.verticalAlign='top';
									}
								delta=-delta;
								for(j=0; j<delta; j++)
									{
										ncell.insertBefore(cell.removeChild(cell.childNodes[cell.childNodes.length-1]), ncell.firstChild);
									}
							}
						i++;
					}
			}
		this.p_tab.style.visible='visible';
	}

List.prototype.zResize=function()
	{
		this.p_cur_height=this.p_body.clientHeight;
		this.p_col_items=Math.floor(this.p_cur_height / this.p_item_height);
		if (!this.p_inited)
			{
				this.p_inited=true;
				for(x in this.p_records)
					this.addRecord(x, this.p_records[x][0], this.p_records[x][1], this.p_records[x][2], this.p_records[x][3]);
				this.p_records=[];
			}
		else
			if (!this.p_isbusy)
				this.pReformat();
		var tm=setTimeout('var f=document.getElementById("'+this.p_id+'"); if (f) f.o_root.p_isbusy=false;', 50);
	}

List.prototype.pToggleItem=function(obj, bMode)
	{
		var cname='';
		switch (bMode)
			{
				case 1:
						cname='selected';
					break;
				case 2:
						cname='selected focused';
					break;
				default:
					cname='';
			}

		if (obj=='all')
			{
				for(var i=0; i < this.z_cur.length; i++)
						this.z_cur[i].className=cname;
			}
		else if (obj)
			obj.className=cname;
	}

List.prototype.pInSelection=function(obj)
	{
		if (obj && this.z_cur_indexes[obj.sKey])
			return true;
		return false;
	}

List.prototype.pAddToSelection=function(obj, bMode ) //bMode : 0 - replace selection, 1 - add isolate selection, 2 - group selection;
	{
		var i=0;
		switch(bMode)
			{
				case 1:
					this.pToggleItem('all', 1);
					if (this.z_cur_indexes[obj.sKey])
						{
							for(var i=0; i < this.z_cur.length; i++)
								if (this.z_cur[i].sKey==obj.sKey)
									this.z_cur.splice(i, 1);
							delete this.z_cur_indexes[obj.sKey];
							this.pToggleItem(obj, 0);
							this.pToggleItem(this.z_cur[this.z_cur.length-1], 2);
						}
					else
						{
							this.z_cur.push(obj);
							this.z_cur_indexes[obj.sKey]=obj;
							this.pToggleItem(obj, 2);
						}
					break;
				case 2:
					var prev;
					if (prev=this.z_cur[0])
						{
							this.pToggleItem('all', 0);
							this.z_cur=[];
							this.z_cur_indexes={};
							this.pToggleItem(prev, 1);
							var index1=prev.parentElement.cellIndex, index2=obj.parentElement.cellIndex, i, j, x=prev, to=obj, t;
							if (index1 > index2 || (index1==index2 && obj.offsetTop < prev.offsetTop))
								{
									if (obj.offsetTop < prev.offsetTop)
										{
											//to=prev;
											//x=obj;
										}
									for(i=index1; i >= index2; i--)
										{
											while(x && x!==to)
												{
													this.z_cur.push(x);
													this.z_cur_indexes[x.sKey]=x;
													this.pToggleItem(x, 1);
													x=x.previousSibling;
												}
											if (x===to)
												{
													this.z_cur.push(x);
													this.z_cur_indexes[x.sKey]=x;
													this.pToggleItem(obj, 2);
													break;
												}
											if (i > index2)
												x=this.p_tab.cells[i-1].lastChild;
										}
								}
							else
								{
									for(i=index1; i <= index2; i++)
										{
											while(x && x!==to)
												{
													this.z_cur.push(x);
													this.z_cur_indexes[x.sKey]=x;
													this.pToggleItem(x, 1);
													x=x.nextSibling;
												}
											if (x===to)
												{
													this.z_cur.push(x);
													this.z_cur_indexes[x.sKey]=x;
													this.pToggleItem(obj, 2);
													break;
												}
											if (i < index2)
												x=this.p_tab.cells[i+1].firstChild;
										}
								}
						}
					break;
					default:
						this.pToggleItem('all', 0);
						this.z_cur=[];
						this.z_cur_indexes={};
						this.z_cur.push(obj);
						this.z_cur_indexes[obj.sKey]=obj;
						this.pToggleItem(obj, 2);
			}
	}

List.prototype.pMouseDown=function()
	{
		if (event.button==1)
			{
				this.o_root.pAddToSelection(this, event.ctrlKey ? 1 : (event.shiftKey ? 2 : 0));
				var V=document.createEventObject();
				V.srcRootElement=this.o_root;
				V.eventName='onselect';
				this.o_root.p_body.fireEvent('oncontrolselect', V);
				//event.cancelBubble=true;
				//return false;
			}
	}

List.prototype.pMouseOver=function()
	{
		ListUtil.showInfo('<i>'+this.sText+'</i><br>'+this.sData, true);
	}

List.prototype.pMouseOut=function()
	{
		ListUtil.showInfo(null);
	}

List.prototype.pMouseWheel=function()
	{
		if (event.wheelDelta >= 120)
			{
				this.scrollLeft-=40;
			}
		else if (event.wheelDelta <= -120)
			{
				this.scrollLeft+=40;
			}
		return false;
	}

List.prototype.pEvControl=function()
	{
		if (ListUtil.visible)
			ListUtil.showInfo(null);
		switch(event.eventName)
			{
				case 'onselect':
					if (this.o_root.onselect && typeof(this.o_root.onselect)=='function')
						return this.o_root.onselect(event)===false ? false : true;
					return true;
				case 'ondblclick':
					if (this.o_root.ondblclick && typeof(this.o_root.ondblclick)=='function')
						return this.o_root.ondblclick(event)===false ? false : true;
					
				case 'onkeydown':
					if (this.o_root.onkeydown && typeof(this.o_root.onkeydown)=='function')
						return this.o_root.onkeydown(event)===false ? false : true;
				case 'oncontextmenu':
					if (this.o_root.oncontextmenu && typeof(this.o_root.oncontextmenu)=='function')
						return this.o_root.oncontextmenu(event)===false ? false : true;
			}
	}

List.prototype.pDblClick=function()
	{
		var V=document.createEventObject();
		V.srcRootElement=this.o_root;
		V.eventName='ondblclick';
		V.key=this.sKey;
		V.data=this.sData;
		V.text=this.sText;
		V.flags=this.iFlags;
		this.o_root.p_body.fireEvent('oncontrolselect', V);
	}

List.prototype.clear=function()
	{
		this.p_keys={};
		this.p_records={};
		this.z_cur_indexes={};
		this.z_cur=[];
		
		for(var i=this.p_tab.cells.length-1; i >=0 ; i--)
			this.p_tab.cells[i].removeNode(true);
		ListUtil.showInfo(false);
	}

List.prototype.getSelection=function(iWhereFlags)
	{
		var result={}, i;
		if (isNaN(iWhereFlags))
			iWhereFlags=255;
		for(i=0; i < this.z_cur.length; i++)
			if (this.z_cur[i].iFlags & iWhereFlags)
				result[this.z_cur[i].sKey]=[this.z_cur[i].sText, this.z_cur[i].sData, this.z_cur[i].iFlags];
		return result;
	}

List.prototype.getSelectionTitles=function(iWhereFlags)
	{
		var result=[], i;
		if (isNaN(iWhereFlags))
			iWhereFlags=255;
		for(i=0; i < this.z_cur.length; i++)
			if (this.z_cur[i].iFlags & iWhereFlags)
				result[result.length]=this.z_cur[i].sText;
		return result;
	}

List.prototype.getLastSelected=function()
	{
		if (this.z_cur.length)
			{
				var t=this.z_cur[this.z_cur.length-1]
				return {key : t.sKey, text : t.sText, data : t.sData, flags : t.iFlags};
			}
		return null;
	}

List.prototype.pScrollCurToView=function()
	{
		if (this.z_cur.length==0)
			{
				if (this.z_tab.cells[0])
					cur=this.z_tab.cells[0].firstChild
			}
		else
			cur=this.z_cur[this.z_cur.length-1];
		if ((this.p_body.scrollLeft + this.p_body.offsetWidth-cur.offsetWidth) < cur.parentElement.offsetLeft)
			{
				this.p_body.scrollLeft=cur.parentElement.offsetLeft-this.p_body.offsetWidth+cur.offsetWidth+15;
			}
		else
			{
				if (cur.parentElement.offsetLeft < this.p_body.scrollLeft)
					this.p_body.scrollLeft = cur.parentElement.offsetLeft;
			}
	}

List.prototype.pKeyDown=function()
	{
		var cur=t=null, tab=this.o_root.p_tab;
		if (this.o_root.z_cur.length==0)
			{
				if (tab.cells[0])
					cur=tab.cells[0].firstChild
			}
		else
			cur=this.o_root.z_cur[this.o_root.z_cur.length-1];
			
		if (ListUtil.visible)
			ListUtil.showInfo(false);

		switch (event.keyCode)
			{
				case 38:
						if (!(t=cur.previousSibling))
							{
								if (tab.cells[cur.parentElement.cellIndex-1])
									t=tab.cells[cur.parentElement.cellIndex-1].lastChild
							}
					break;
				case 40:
						if (!(t=cur.nextSibling))
							{
								if (tab.cells[cur.parentElement.cellIndex+1])
									t=tab.cells[cur.parentElement.cellIndex+1].firstChild;
							}
					break;
				case 37:
				case 33:
						if (tab.cells[cur.parentElement.cellIndex-1])
							{
								t=tab.cells[cur.parentElement.cellIndex-1].childNodes[Math.round(cur.offsetTop / this.o_root.p_item_height)];
							}
						if (!t)
							t=tab.cells[0].firstChild;
					break;
				case 39:
				case 34:
						if (tab.cells[cur.parentElement.cellIndex+1])
							{
								t=tab.cells[cur.parentElement.cellIndex+1].childNodes[Math.round(cur.offsetTop / this.o_root.p_item_height)];
							}
						if (!t)
							t=tab.cells[tab.cells.length-1].lastChild;
					break;
				case 36:
						if (tab.cells[0])
							t=tab.cells[0].firstChild;
					break;
				case 35:
						if (tab.cells.length)
							t=tab.cells[tab.cells.length-1].lastChild;
					break;
				default:
					
			}

		var V=document.createEventObject();
		V.srcRootElement=this.o_root;

		if (t)
			{
				this.o_root.pAddToSelection(t, event.shiftKey ? 2 : 0);
				this.o_root.pScrollCurToView();
				V.eventName='onselect';
				t=undefined;
			}
		else
			{
				V.eventName='onkeydown';
				V.keyCode=event.keyCode;
				V.ctrlKey=event.ctrlKey;
				V.altKey=event.altKey;
				V.shiftKey=event.shiftKey;
			}
		this.o_root.p_body.fireEvent('oncontrolselect', V);
		return false;
	}

List.prototype.loadDataFromString=function(sStr)
	{
		re=new RegExp('<([^\\|<]*)\\|([^\\|]*)\\|([^\\|]*)\\|([^\\|]*)\\|([^>]*)>', 'g');
		while(null!==(res=re.exec(sStr)))
			{
				this.addRecord(res[1], res[2], res[5], res[4], res[3]);
			}
	}

List.prototype.pBodyMouseDown=function()
	{
		if (event.srcElement===this.p_body)
			{
				this.o_root.pToggleItem('all', 0);
				this.o_root.z_cur=[];
				this.o_root.z_cur_indexes={};
				if (ListUtil.visible)
					ListUtil.showInfo(false);
				return false;
			}
	}

List.prototype.keyExists=function(sKey)
	{
		return this.p_keys[sKey] ? true : false;
	}