function EditableGrid(id)
	{
		this.id=id ? id : "egrid"+Math.round(Math.random()*1000)+(t=new Date).getTime();
		this.header_visible=true;
		this.row_auto_prefix='row';
		this.row_auto_id=0;
		this.p_columns=[];
		this.p_rows={};
		this.p_doc=null;
		this.p_disabled=false;
		this.p_columns_num=0;
		this.p_item_height=18;
		this.h_holder=null;
		this.p_prevsel=null;
		this.p_table=null;
		this.p_head=null;
		this.p_body=null;
		
		this.onchange=null;

		this.z_current;
		this.z_curcell;
		return this;
	}

EditableGrid.prototype.create=function()
	{
		document.write('<DIV id="'+this.id+'_grid" class="grid_holder"><TABLE cellspacing=0 cellpadding=0 border=0 class="grid"><THEAD></THEAD><TBODY><TR isGrid=1><TD class="first_row"></TD></TR></TBODY><TBODY class="grid_body"></TBODY></TABLE></DIV>');
		this.h_holder=document.getElementById(this.id+'_grid');
		this.p_doc=document;
		this.assemble();
	}

EditableGrid.prototype.wrapAround=function(oObj, bInheritStyle)
	{
		if (!oObj)
			return false;
		var css='', doc=oObj.document;

		this.h_holder=doc.createElement('DIV');
		this.h_holder.id=this.id;
		this.h_holder.className='grid_holder';
		if (bInheritStyle)
			{
				if (oObj.className)
					this.h_holder.className=oObj.className+' grid_holder';
				css=oObj.runtimeStyle.cssText;
				this.h_holder.style.cssText=css;
			}
		this.h_holder.innerHTML='<TABLE id="'+this.id+'_grid" cellspacing=0 cellpadding=0 border=0 class="grid" style="'+css+'"><THEAD></THEAD><TBODY><TR isGrid=1><TD class="first_row"></TD></TR></TBODY><TBODY class="grid_body"></TBODY></TABLE>';
		oObj.replaceNode(this.h_holder);
		this.p_doc=doc;
		this.assemble();
	}

EditableGrid.prototype.assemble=function()
	{
		this.p_table=this.h_holder.firstChild;
		this.p_body=this.p_table.tBodies[1];
		this.p_head=this.p_table.tHead.insertRow();
		this.h_holder.o_ref=this;
		this.h_holder.onkeydown=this.pKeyDown;
		this.h_holder.onmousedown=this.pMouseDown;
		this.h_holder.onclick=this.pMouseUp;
		this.h_holder.ondblclick=this.pDblClick;
		this.h_holder.oncontrolselect=this.pEvControl;
		if (!this.header_visible)
			{
				this.p_head.style.display='none';
				this.p_table.tBodies[0].style.display='none';
			}
	}
	
EditableGrid.prototype.addColumn=function(sCaption, iWidth, oData)
	{
		/*oData - value, options, maxlength, */
		var oCol=this.p_head.insertCell();
		oCol.noWrap=true;
		oCol.width = iWidth;
		oCol.innerHTML = '<DIV noWrap=true>'+sCaption+'</DIV>';
		oCol.oData=oData ? oData : {};
		this.p_columns_num=this.p_head.cells.length;
	}

EditableGrid.prototype.clear=function()
	{
		var width=this.p_table.clientWidth;
		this.p_rows={};
		for(var i=this.p_body.rows.length - 1; i >= 0; i--)
			this.p_body.deleteRow(i);
		this.p_table.width='100%';
		this.z_curcell=null;
		this.z_current=null;
	}

EditableGrid.prototype.removeRow=function(sKey)
	{
		if (this.p_rows[sKey])
			{
				this.p_rows[sKey].removeNode(true);
				delete this.p_rows[sKey];
			}
	}
	
EditableGrid.prototype.removeCurrentRow=function()
	{
		if (this.z_current)
			{
				delete this.p_rows[this.z_current.sKey];
				var t=this.z_current;
				this.pSelect(this.z_current.nextSibling ? this.z_current.nextSibling : (this.z_current.previousSibling ? this.z_current.previousSibling : null));
				t.removeNode(true);
			}
	}

EditableGrid.prototype.setValue=function(sKey, iIndex, value)
	{
		var oCell;
		if (this.p_rows[sKey] && (oCell=this.p_rows[sKey].cells[iIndex]))
			{
				switch (oCell.sType)
					{
						case 'checkbox':
							oCell.firstChild.checked = value ? true : false;
						break;
						case 'label':
								oCell.title = value ? value : false;
						case 'readonly':
								oCell.innerHTML=value;
							break;
						case 'htmlarea':
								oCell.firstChild.innerHTML=value;
							break;
						case 'select':
								for (var i=0; i < oCell.firstChild.options.length; i++)
									if (oCell.firstChild.options[i].value == value)
										{
											oCell.firstChild.selectedIndex=i;
											break;
										}
							break;
						case 'command':
							break;
						case 'int':
						case 'dialog':
						default:
							oCell.firstChild.value=value;
							oCell.firstChild.oldValue=value;
						}
			}
	}
	
EditableGrid.prototype.addRow=function()
	{
		var oRow, aColumns, oCell, oData, oDefData, type, sKey, maxlen=0;
		if (!(sKey = arguments[0]))
			sKey = this.row_auto_prefix+(this.row_auto_id++);
		if (this.p_rows[sKey])
			return false;
		oRow=this.p_body.insertRow();
		oRow.sKey=sKey;
		this.p_rows[sKey]=oRow;
		for (var i=0; i < this.p_columns_num; i++)
			{
				
				oCell=oRow.insertCell();
				oCell.isGrid=1;
				oCell.noWrap=true;
				oDefData=this.p_head.cells[i].oData;
				oCell.width=this.p_head.cells[i].width;
				if (!(oData=arguments[i+1]))
					oData=oDefData;
				type = oData.type ? oData.type : oDefData.type;
				value = (oData.value ===undefined) ? (oDefData.value ? oDefData.value : '') : oData.value;
				if (isNaN(maxlen = oData.maxlength ? oData.maxlength : oDefData.maxlength))
						maxlen=0;
				switch (type)
					{
							case 'checkbox':
								oCell.style.cursor='default';
								oCell.style.textAlign='center';
								oCell.innerHTML='<INPUT type="checkbox" '+(value ? 'checked' : '')+' style="border:none; width:18px" hideFocus=true>';
								oCell.firstChild.onclick=this.pOnChange;
								oCell.firstChild.isGrid=1;
								oCell.firstChild.o_ref=this;
							break;
							case 'label':
								oCell.title = value ? value : false;
							case 'readonly':
								oCell.innerHTML=value ? value : '&nbsp;';
								oCell.className=type;
							break;
							case 'htmlarea':
								oCell.innerHTML='<DIV class="htmlareabody">'+(value ? value : '')+'</DIV>';
								oCell.firstChild.isGrid=1;
								oCell.className=type;
							break;
							case 'select':
								var html='', options = oData.options ? oData.options : oDefData.options, popt, sel_id;
								if (typeof (options)=='object')
									{
										for(var p in options)
												html+='<OPTION value="'+p+'"'+(p==value ? ' selected' : '')+'>'+options[p]+'</OPTION>';	
									}
								oCell.innerHTML='<SELECT style="width:100%">'+html+'</SELECT>';
								oCell.style.cursor='default';
								oCell.firstChild.onchange=this.pOnChange;
								oCell.firstChild.isGrid=1;
								oCell.firstChild.o_ref=this;
								break;
							case 'textarea':
								oCell.innerHTML='<TEXTAREA>'+value+'</TEXTAREA>';
								oCell.firstChild.onchange=this.pOnChange;
								oCell.firstChild.isGrid=1;
								oCell.firstChild.o_ref=this;
								oCell.style.posHeight=oCell.firstChild.clientHeight;
								break;
							case 'command':
								oCell.innerHTML='<INPUT type="button" class="button" value="'+value+'" hideFocus=true>';
								oCell.firstChild.onclick=this.pOnChange;
								oCell.firstChild.isGrid=1;
								oCell.firstChild.o_ref=this;
								break;
							default:
								if (!(value===undefined || value === null))
									{
										oCell.innerHTML='<INPUT type="text" value="'+value+(maxlen ? '"' : '" max_length='+maxlen)+'>';
										oCell.firstChild.oldValue=value;
										oCell.firstChild.isGrid=1;
										if (type=='int')
											oCell.firstChild.onpropertychange=this.pCheckValue;
									}
								else
									oCell.innerHTML='<INPUT type="text" value="">';
								if (type=='dialog')
									{
										var oBtn=this.p_doc.createElement('BUTTON');
										oBtn.innerHTML='...';
										oBtn.onclick=this.pDialogClick;
										oBtn.target = oData.target ? oData.target : oDefData.target;
										oBtn.o_ref=this;
										oCell.appendChild(oBtn);
										oCell.firstChild.className='dialog';
									}
								oCell.firstChild.onchange=this.pOnChange;
								oCell.firstChild.o_ref=this;
					}
				oCell.sType=type;
			}
		return sKey;
	}
	
EditableGrid.prototype.pDialogClick=function()
	{
		var v=this.document.createEventObject();
		v.srcRootElement=this.o_ref;
		v.key=this.parentElement.parentElement.sKey;
		v.index=this.parentElement.cellIndex;
		v.value=this.value;
		v.eventName='ondialog';
		this.o_ref.p_body.fireEvent('oncontrolselect', v);
		return true;
	}

EditableGrid.prototype.pCheckValue=function()
	{
		var ev=this.document.parentWindow.event;
		if (ev.propertyName=='value')
			{
				var p=ev.srcElement.onpropertychange, t, u=false;
				ev.srcElement.onpropertychange=null;
				if (this.value=='')	
					{
						u=true;
						this.xValue=0;
					}
				else
					{
						t=parseFloat(this.value);
						if (isNaN(t))
							this.value=this.xValue ? this.xValue : 0
						else
							if (t!=this.value)
								this.value=t;
							else
								{
									u=true;
									this.xValue=this.value;
								}
					}
				this.document.parentWindow.event.srcElement.onpropertychange=p;
			}
		return u;
	}

EditableGrid.prototype.setRows=function(oData)
	{
		this.clear();
		var x;
		for (x in oData)
			{
				this.addRow(x, oData[x]);
			}
	}
	
EditableGrid.prototype.getRows=function()
	{
		var x, oRes=[], oCell, i, oCur, oRow;
		for (x in this.p_rows)
			{
				oRow=[];
				for (i=0; i < this.p_rows[x].cells.length; i++)
					{
						oCell=this.p_rows[x].cells[i];
						oCur='';
						switch (oCell.sType)
							{
								case 'checkbox':
									oCur=oCell.firstChild.checked;
								break;
								case 'label':
								case 'readonly':
									oCur=oCell.innerHTML;
								break;
								case 'htmlarea':
									oCur=oCell.firstChild.innerHTML;
								break;
								case 'select':
									oCur=oCell.firstChild.options[oCell.firstChild.selectedIndex];
									if (oCur)
										oCur=oCur.value;
									else
										oCur=null;
								break;
								case 'textarea':
									oCur=oCell.firstChild.value;
								break;
								case 'command':
								break;
								default:
								if (oCell.firstChild && oCell.firstChild.tagName=='INPUT')
									oCur=oCell.firstChild.value;
								else
									oCur='';
							}
						oRow.push(oCur);
					}
				oRes.push(oRow);
			}
		return oRes;
	}

EditableGrid.prototype.pSelect=function(oRow)
	{
		if (this.p_disabled || oRow===this.z_current)
			return false;
		if (this.z_current)
			{
				this.z_current.className='';
				this.z_current=false;
			}

		if (oRow)
			{
				oRow.className='selected';
				this.z_current=oRow;
				return true;
			}
		return false;
	}

EditableGrid.prototype.pOnChange=function()
	{
		var v=this.document.createEventObject();
		v.srcRootElement=this.o_ref;
		v.key=this.parentElement.parentElement.sKey;
		switch (this.type)
			{
				case 'checkbox':
					v.value = this.checked ? true : false;
					break;
				case 'button':
					v.value=1;
					break;
				default:
					this.oldValue=this.value;
					v.value=this.value;
					//this.o_ref.pSelect();
			}
		v.eventName='onchange';
		this.o_ref.p_body.fireEvent('oncontrolselect', v);
		this.document.parentWindow.event.cancelBubble=true;
		//return false;
	}

EditableGrid.prototype.pMouseDown=function()
	{
		var oEl=this.document.parentWindow.event.srcElement;
		if (oEl.isGrid)
			{
				if (oEl.tagName=='INPUT' || oEl.tagName=='TEXTAREA' || oEl.tagName=='DIV')
					{
						this.o_ref.z_cur_cell=oEl.parentElement;
						this.o_ref.pSelect(oEl.parentElement.parentElement);
						if (oEl.type!='button' && oEl.tagName!='TEXTAREA' && oEl.select && this.o_ref.p_prevsel!==oEl)
							oEl.select();
						oEl.focus();
						oEl.setActive();
					}
				else if (oEl.tagName=='SELECT')
					{
						this.o_ref.z_cur_cell=oEl.parentElement;
						this.document.selection.empty();
						this.o_ref.pSelect(oEl.parentElement.parentElement);
					}
				else
					{
						this.o_ref.pSelect(oEl.parentElement);
					}
				this.o_ref.pScrollIntoView();
			}
		else
			{
				this.o_ref.pSelect();
			}
		this.document.parentWindow.event.cancelBubble=true;
		return false;
	}

EditableGrid.prototype.pMouseUp=function()
	{
		var oEl=this.document.parentWindow.event.srcElement;
		
		if (oEl.isGrid && (oEl.tagName=='INPUT'))
			{
				if (oEl.select && oEl.type!='button')
					{
						if (this.o_ref.p_prevsel!==oEl)
							oEl.select();
						oEl.focus();
					}
				oEl.setActive();
			}
		this.o_ref.p_prevsel=oEl;
		this.document.parentWindow.event.cancelBubble=true;
		return false;
	}

EditableGrid.prototype.pDblClick=function()
	{
		var oEl=this.document.parentWindow.event.srcElement;
		if (oEl.isGrid && (oEl.tagName=='INPUT' && oEl.type!='button') || oEl.tagName=='TEXTAREA')
			{
				var range=oEl.createTextRange();
				range.collapse(1);
				range.select();
				oEl.focus();
				oEl.setActive();
			}
		this.document.parentWindow.event.cancelBubble=true;
		return false;
	}

EditableGrid.prototype.pScrollIntoView=function()
	{
	}

EditableGrid.prototype.pKeyDown=function()
	{
		EV=this.document.parentWindow.event;
		var oEl=EV.srcElement, oObj, cellIndex=null, oChild, oCell;
		if (oEl.tagName=='INPUT' || oEl.tagName=='TEXTAREA' || oEl.tagName=='SELECT')
			{
				if (oEl.tagName!='TEXTAREA')
					{
						oCell=oEl.parentElement;
						cellIndex=oCell.cellIndex;
					}
				switch (EV.keyCode)
					{
						case 27:
							oEl.value=oEl.oldValue;
						case 13:
							if (oEl.tagName!='TEXTAREA')
								{
									oEl.blur();
									EV.returnValue=false;
									EV.cancelBubble=true;
									return false;
								}
						break;
					}
			}

		if (this.o_ref.z_cur_cell)
			{
				oCell=this.o_ref.z_cur_cell;
				cellIndex=oCell.cellIndex;
			}
		else
			oCell=oEl;


		if (oCell && oCell.isGrid && this.o_ref.z_current)
			{
				switch(EV.keyCode)
					{
						case 38:
							oObj=this.o_ref.z_current.previousSibling;
						break;
						case 40:
							oObj=this.o_ref.z_current.nextSibling;
						break;
					}
			}

		if (oObj)
			{
				this.o_ref.pSelect(oObj);
				this.o_ref.pScrollIntoView();
				if (cellIndex !==null && oObj.cells[cellIndex] && (oChild=oObj.cells[cellIndex].firstChild) && oChild.nodeType==1)
					{
						oChild.focus();
						if (oChild.tagName=='INPUT' && oChild.type=='text')
							{
								var range=oChild.createTextRange(), range1=range.duplicate();
								range.collapse(1);
								range1.collapse(0);
								range.setEndPoint('EndToEnd', range1);
								range.select();
								return false;
							}
						else
							if (oChild.tagName=='TEXTAREA')
								{
									var range=oChild.createTextRange();
									range.collapse(0);
									range.select();
									return false;
								}
					}
				this.document.selection.empty();
			}
	}

EditableGrid.prototype.pEvControl=function()
	{
		//ev = self.event ? self.event : this.document.parentWindow.event;
		ev=this.document.parentWindow.event;
		switch(ev.eventName)
			{
				case 'onchange':
					if (this.o_ref.onchange && typeof(this.o_ref.onchange)=='function')
						return this.o_ref.onchange(ev)===false ? false : true;
					return true;

				case 'ondialog':
					if (this.o_ref.ondialog && typeof(this.o_ref.ondialog)=='function')
						return this.o_ref.ondialog(ev)===false ? false : true;
					return true;
			}
	}