
function AdvSelector(id)
	{
		this.size=5;
		this.width=280;
		this.clientWidth=0;
		this.title='';
		this.editable=false;
		this.maxHeight=100;
		this.onchange=null;


		this.is_strict=false;
		this.p_id=id ? id : "select"+Math.round(Math.random()*1000)+(t=new Date).getTime();

		this.p_self=null;
		this.p_field=null;
		this.p_popup=null;
		this.p_doc=null;
		this.p_body=null;

		this.p_height=0;

		this.p_temp_md=null;
		this.p_temp_mm=null;

		this.p_changed=false;
		this.p_current=null;
		
		this.p_items=null;
		this.keys={};
		this.p_old_value=null;

		this.is_disabled=false;
		this.p_visible=false;
		return this;
	}

	
AdvSelector.prototype.assemble=function()
	{
		document.write('<TABLE id="'+this.p_id+'_body" cellspacing=0 cellpadding=0 border=0 class="advselector"></TABLE>');
		this.p_self=document.getElementById(this.p_id+'_body');
		this.create();
	}

AdvSelector.prototype.pDropDown=function()
	{
		if (this.o_root.is_disabled)
			return false;
	//	window.event.cancelBubble=true;
		if (!this.o_root.p_visible)
			{
				this.o_root.p_visible=true;
				this.o_root.show();
				this.o_root.pSetState(2);
			}
		else
			{
				this.o_root.p_visible=false;
				this.o_root.hide();
				this.o_root.pSetState(1);
			}
		return false;
	}

AdvSelector.prototype.find=function(sString)
	{
		var i;
		sString=String(sString);
		if (-1 < (i=this.pFindIndex(sString)))
			this.pSetIndexTo(this.p_items[i]);
		else
			{
				this.pSetIndexTo(null);
				this.p_old_value='';
			}
		this.pSetText();
		return i;
	}

AdvSelector.prototype.findKey=function(sString)
	{
		var i;
		sString=String(sString);
		if (this.keys[sString])
			{
				this.pSetIndexTo(this.keys[sString]);
				this.pSetText();
				return true;
			}
		this.pSetIndexTo(null);
		this.p_old_value='';
		this.pSetText();
		return false;
	}

AdvSelector.prototype.show=function()
	{
		if (!this.p_popup.isOpen)
			{
				//status+='show';
				if (this.p_current)
					this.pSetIndexTo(this.p_current);
				if (!this.clientWidth || isNaN(this.clientWidth))
					this.clientWidth=this.width;
				this.p_popup.show(0, this.p_self.offsetHeight, this.clientWidth, this.maxHeight, this.p_self);
				this.pSetCapture(true);
				this.p_visible=true;
			}
	}

AdvSelector.prototype.hide=function()
	{
		//status+='(hide)';
		this.pSetState(0);
		this.p_visible=false;
		this.p_popup.hide();
		this.pSetCapture(false);
	}

AdvSelector.prototype.addElement=function(sKey, sValue, sStyle, iPos)
	{
		var el=this.p_doc.createElement('DIV'), t;
		if (!isNaN(iPos))
			iPos=0;
		if (sStyle)
			{
				el.style.cssText=this.pParseStyle(sStyle);
			}
		el.index = this.p_items.length;
		el.noWrap=true;
		el.innerText=sValue;
		el.key=sKey;
		el.value=sValue;
		this.keys[sKey]=el;
		if (t=this.p_body.childNodes[iPos+1])
			this.p_body.insertBefore(el, t)
		else
			this.p_body.insertBefore(el);
	}

AdvSelector.prototype.removeElement=function(key)
	{
		if (this.keys[key])
			{
				this.keys[key].removeNode(true);
				delete this.keys[key];
			}
	}
		
AdvSelector.prototype.setCaption=function(sText)
	{
		if (this.p_field)
			{
				this.p_field.blur();
				this.p_field.value=sText;
			}
	}

AdvSelector.prototype.pSetIndexTo=function(oElement)
	{
		
		if (this.p_current)
			{
				this.p_current.className='';
				this.p_current=null;
			}
		if (!oElement)
			return false;
		oElement.className="sel";
		this.p_current=oElement;
		return true;
	}
	
AdvSelector.prototype.pSetText=function()
	{
		if (this.p_field)
			this.p_field.value=this.p_current ? this.p_current.innerText : this.p_old_value;
	}

AdvSelector.prototype.pSetState=function(x)
	{
		if (this.p_disabled)
			{
				this.p_self.className = 'advselector';
				return;
			}
		switch(x)
			{
				case 1:
					this.p_self.className = 'advselector_selected advselector';
					break;
				case 2:
					this.p_self.className = 'advselector_pressed advselector';
					break;
				default:
					this.p_self.className = 'advselector';
			}
	}

AdvSelector.prototype.pApply=function()
	{
		//status+='(app:'+this.p_current.key+')';
		this.hide();
		this.p_old_value=this.p_field_value;
		var V = document.createEventObject();
		V.index=-1;
		V.key=null;
		V.value=null;
		if (this.p_current)
			{
				V.index = this.p_current.index;
				V.key = this.p_current.key;
				V.value = this.p_current.value;
			}
		this.p_self.fireEvent('oncontrolselect', V);
	}

AdvSelector.prototype.pCancel=function()
	{
		status+='(can)';
		this.pSetCapture(false);
		this.hide();
		this.p_field=this.p_old_value;
	}
		
AdvSelector.prototype.pFindIndex=function(sString, index)
	{
		var i= index ? index-1 : -1;
		if (!sString)
			return -1;
		if (this.is_strict)
			{
				while (t=this.p_items[++i])
					if (t.innerText.indexOf(sString)==0)
						return i;
			}
		else
			{
				sString=sString.toLowerCase();
				while(t=this.p_items[++i])
					if (t.innerText.toLowerCase().indexOf(sString)==0)
						return i;
			}
		return -1;
	}
	
AdvSelector.prototype.clear=function()
	{
		try
			{
				this.keys={};
				this.p_body.innerHTML='';
				this.p_old_value='';
				this.pSetCapture(false);
				this.p_field.blur();
				this.p_field.value='';
				this.p_changed=false;
			}
		catch(e)
			{
			}
		return true;
	}
		
AdvSelector.prototype.pParseStyle=function(sStyle)
	{
		var res='', r=String(sStyle).match(/(font(-family|-size|-style|-variant|-weight)?|letter-spacing|line-(break|height)|text-(align|decoration|indent|transform)|background(-color|-image|-repeat|-position)?|color|border(-top|-bottom|-left|-right)?(-color|-width|-style)?|(padding|margin)(-bottom|-left|-right|-top)|list-style(-image|-position|-type))\s*\:\s*.+?\s*(\;|$)/gi);
		if (r)
			{
				res=r.join(' ');
			}
		return res;
	}

AdvSelector.prototype.pSetCapture=function(state)
	{
		if (state)
			{
				if (this.p_temp_md==-1)
					{
						this.p_temp_md=document.onmousedown;
						//this.p_temp_mm=document.onmousemove;
						//document.onmousemove=new Function('var t=document.getElementById("'+this.p_id+'_body"); if (!t.o_root.p_visible) t.o_root.pSetIndexTo(); event.cancelBubble=true;');
						document.onmousedown=new Function('var t=document.getElementById("'+this.p_id+'_body"); if (event.srcElement.o_rootid==t.o_rootid) return true; t.o_root.pCancel(); event.cancelBubble=true;');
					}
			}
		else
			{
				if (this.p_temp_md!=-1)
					{
						document.onmousedown=this.p_temp_md;
						//document.onmousemove=this.p_temp_mm;
						this.p_temp_md=-1;
						//this.p_temp_mm=-1;
					}
			}
	}

AdvSelector.prototype.setCurrentKey=function(key)
	{
		if (this.keys[key])
			{
				this.pSetIndexTo(this.keys[key]);
				this.pSetText();
			}
	}

AdvSelector.prototype.getCurrentKey=function()
	{
		if (this.p_current)
			return this.p_current.key;
		return null;
	}

AdvSelector.prototype.getCurrentValue=function()
	{
		if (this.p_current)
			return this.p_current.value;
		return null;
	}

AdvSelector.prototype.zMouseOver=function()
	{
		if (!this.o_root.p_visible)
			this.o_root.pSetState(1);
	}

AdvSelector.prototype.zMouseOut=function()
	{
		if (!this.o_root.p_visible)
			{
				this.o_root.pSetState(0);
			}
	}

AdvSelector.prototype.zMouseDown=function()
	{
		if (this.o_root.p_visible)
			this.o_root.show();
		//status+=this.o_root.p_visible;
		//event.cancelBubble=true;
	}

AdvSelector.prototype.zControlSelect=function()
	{
		if (this.o_root.onchange && typeof(this.o_root.onchange)=='function')
			this.o_root.onchange();
	}

AdvSelector.prototype.zDocClick=function()
	{
		var o=this.body.firstChild.o_root;
		if (o)
			{
				o.pSetText();
				o.pApply();
			}
	}

AdvSelector.prototype.zBodyMouseOver=function()
	{
		var e=this.document.parentWindow.event.srcElement;
		if (e && e.index!==undefined)
			{
				this.o_root.pSetIndexTo(e);
				//this.o_root.pSetText();
			}
	}

AdvSelector.prototype.zCancel=function()
	{
		return false;
	}

AdvSelector.prototype.zKeyDown=function()
	{
		var t, i, o=this.o_root;
		event.cancelBubble=true;
		var code=event.keyCode;
		if (!o.editable)
			return false;
		if (!o.p_current)
			{
				
				if (!o.p_body.firstChild)
					return false;
				else
					t=o.p_body.firstChild;
				if (t && t.index!==undefined) o.pSetIndexTo(t);
				//status+=o.p_current;
				o.pSetText();
			}
		else
			if (!(event.ctrlKey || event.altKey || event.shiftKey))
				switch (code)
					{
						case 13:
							o.pApply();
							o.p_field.blur();
							return false;
							break;
						case 27:
							o.pCancel();
							return false;
							break;
						case 38:
							t=o.p_current.previousSibling;
							if (t && t.index!==undefined) o.pSetIndexTo(t);
							o.pSetText();
							return false;
						case 40:
							t=o.p_current.nextSibling;
							if (t && t.index!==undefined) o.pSetIndexTo(t);
							o.pSetText();
							return false;
						case 33: case 34:
							i=o.p_body.firstChild ? o.p_body.firstChild.sourceIndex : 0;
							if (code==33)
								{
									if(0>(i=o.p_current.sourceIndex-o.size-i))
										i=0;
								}
							else
								if (o.p_body.childNodes.length<=(i=o.p_current.sourceIndex+o.size-i))
							i=o.p_body.childNodes.length-1;
							t=o.p_body.childNodes[i];
							if (t && t.index) o.pSetIndexTo(t);
							o.pSetText();
							return false;
					}
	}

AdvSelector.prototype.zKeyUp=function()
	{
		if (!this.o_root.editable)
			return false;
		switch(event.keyCode)
			{
				case 33: case 34: case 38: case 40: return false;
				default:
						var
							val=this.o_root.p_field.value,
							idx=this.o_root.pFindIndex(val),
							item=this.o_root.p_items[idx];
	
						if (this.o_root.pSetIndexTo(item))
							this.o_root.p_current=item;
						this.o_root.p_changed=true;	
			}
	}

AdvSelector.prototype.zBlur=function()
	{
		if (this.o_root.p_changed)
			{
				this.o_root.pApply();
			}
	}

AdvSelector.prototype.create=function(oParentObj)
	{
		var cell, r, div;
		if (!this.p_self)
			{
				if (oParentObj)
					this.p_self=document.createElement('<TABLE  id="'+this.p_id+'_body" cellspacing=0 cellpadding=0 border=1 class="advselector">');
				else
					return false;
			}
		this.p_self.o_root=this;
		this.p_self.o_rootid=this.p_id;
		this.p_self.style.cssText='width:'+this.width+'!important; height:24px!important; table-layout:fixed';
		this.p_self.hideFocus=true;
		this.p_self.unselectable="on";
		if (this.title)
			this.p_self.title=this.title;
		this.p_self.onmouseover=this.zMouseOver
		this.p_self.onmouseout=this.zMouseOut
		this.p_self.onmousedown=this.zMouseDown;
		this.p_self.oncontrolselect=this.zControlSelect;

		r=this.p_self.insertRow();

		cell=r.insertCell();
		
		this.p_field=document.createElement('<INPUT value="">');
		this.p_field.style.cssText='font:12px Helvetica, Tahoma; margin:0px; padding:2px; border:none; height:100%!important; width:'+(parseInt(this.width)-14)+'px!important';
		this.p_field.o_root=this;
		this.p_field.o_rootid=this.p_id;
		if (!this.editable)
			{
				this.p_field.readOnly=true;
			}

		cell.appendChild(this.p_field);
		this.p_field.value='';
		cell=null;
		cell=r.insertCell();
		cell.style.cssText='width:14px!important';

		div=document.createElement('DIV');
		div.style.cssText='width:14px!important; height:100%;';
		div.className='advselector_btn';
		div.hideFocus=true;
		div.unselectable="on";
		div.onmousedown=this.pDropDown;
		div.o_root=this;
		div.o_rootid=this.p_id;
		cell.appendChild(div);

		this.p_popup=createPopup();
		this.p_doc=this.p_popup.document;
		this.p_doc.write('<HTML><HEAD><STYLE>DIV {width:100%; padding:2px; margin:0px; font-family:Tahoma; font-size:12px; height:22px; cursor:default; border:1px solid transparent; background-color:#ffffff;};  DIV.sel {color:#ffffff!important; background-color:highlight!important; border:1px dotted #000000;}</STYLE></HEAD><BODY style="margin:0px; border:1px solid black; padding:0" scroll="no"><SPAN style="width:100%; height:100%; padding:0px; overflow-y:auto; overflow-x:hidden; display:block; background:#ffffff; scrollbar-arrow-color:#d9d3d8; scrollbar-face-color:#60695b; scrollbar-base-color:#4e5b48; scrollbar-highlight-color:#b7c1b1; scrollbar-shadow-color:#919c8a; scrollbar-3dlight-color:#4e5b48; scrollbar-darkshadow-color:#3e4938"></SPAN></BODY>');
		this.p_doc.onclick=this.zDocClick;
		this.p_doc.onselectstart=this.zCancel;
		this.p_body=this.p_doc.body.firstChild;
		this.p_items=this.p_body.childNodes;
		this.p_body.o_root=this;
		this.p_body.onmouseover=this.zBodyMouseOver;
		this.p_body.onscroll=this.zCancel;
		this.p_self.onkeydown=this.zKeyDown;
		this.p_self.onkeyup=this.zKeyUp;
		this.p_field.onblur=this.zBlur;

		if (oParentObj)
			oParentObj.appendChild(this.p_self);

		this.clear();
	}