jsCore.dom={
	create:{
		tag: function(tag){
			return document.createElement(tag);
		},
		text: function(str) {
			return document.createTextNode(str);
		}
	},
	remove: function(obj){
		if(obj.parentNode)
			obj.parentNode.removeChild(obj);
		else
			delete obj;
	},
	get:{
		body: function(){
			return document.body || document.documentElement;
		},
		iframeBody: function(obj){
				return obj.contentWindow.document || obj.contentDocument || obj.document || null;
		},
		id: function(id){
			return document.getElementById(id);
		},
		objId: function(obj){
/*			var res=null;
			try{
				res=obj.getAttribute('id');
			}catch(e){}
			return res;*/
			return obj.getAttribute('id')||obj.id;
		},
		tag: function(tag) {
			var res=null;
			try{
				res=document.getElementsByTagName(tag)
			}catch(e){}
			return res;
		},
		cls: function(obj){
			return obj.className;
		},
		items: function(o){
			return o.childNodes||null;
		},
		source: function(obj){
			return obj.src || '';
		},
		x: function(obj){
			var left=0;
			while(obj.offsetParent){
				left+=obj.offsetLeft+(obj.currentStyle?(parseInt(obj.currentStyle.borderLeftWidth)).NaN0():0);
				obj=obj.offsetParent;
			}
			left+=obj.offsetLeft+(obj.currentStyle?(parseInt(obj.currentStyle.borderLeftWidth)).NaN0():0);
			return left;
		},
		y: function(obj){
			var top=0;
			while(obj.offsetParent){
				top+=obj.offsetTop+(obj.currentStyle?(parseInt(obj.currentStyle.borderTopWidth)).NaN0():0);
				obj=obj.offsetParent;
			}
			top+=obj.offsetTop+(obj.currentStyle?(parseInt(obj.currentStyle.borderTopWidth)).NaN0():0);
			return top;
		},
		width: function(obj){
			return obj.width||obj.offsetWidth||parseInt(jsCore.dom.get.style(obj,'width'));
		},
		height: function(obj){
			return obj.height||obj.offsetHeight||parseInt(jsCore.dom.get.style(obj,'height'));
		},
		availWidth: function(){
			var de=document.documentElement;
			return self.innerWidth || (de&&de.clientWidth) || document.body.clientWidth;
		},
		availHeight: function(){
			var de = document.documentElement;
			return self.innerHeight || (de&&de.clientHeight) || document.body.clientHeight;
		},
		cursorPosition: function(obj,e){
			e=e || window.event;
			var cursor={x:0, y:0};
			if(e && (e.pageX || e.pageY)){
				cursor.x = e.pageX;
				cursor.y = e.pageY;
			}else if(e && (e.clientX || e.clientY)){
				cursor.x = e.clientX;
				cursor.y = e.clientY;
			}else{
				var de = document.documentElement;
				var b = document.body;
				cursor.x = e.clientX +
					(de.scrollLeft || b.scrollLeft) - (de.clientLeft || 0);
				cursor.y = e.clientY +
					(de.scrollTop || b.scrollTop) - (de.clientTop || 0);
			}
			return cursor;
		},
		style: function(obj,attr){
			if(jsCore.browser.isIE){
				try{
					if(attr==='border'){
						var w=Math.max(
							parseInt(obj.currentStyle['borderTopWidth']),
							parseInt(obj.currentStyle['borderRightWidth']),
							parseInt(obj.currentStyle['borderBottomWidth']),
							parseInt(obj.currentStyle['borderLeftWidth'])
						)+'px';
						var s=obj.currentStyle['borderTopStyle']||
							obj.currentStyle['borderRightStyle']||
							obj.currentStyle['borderBottomStyle']||
							obj.currentStyle['borderLeftStyle'];
						var c=obj.currentStyle['borderTopColor']||
							obj.currentStyle['borderRightColor']||
							obj.currentStyle['borderBottomColor']||
							obj.currentStyle['borderLeftColor'];
						return w+' '+s+' '+c;
					}else{
						return obj.currentStyle[attr];
					}
				}catch(e){
					if(!window.getComputedStyle){
//						alert('start calculate:'+"\n");
						window.getComputedStyle=function(obj,pseudo){
							this.obj=obj;
							this.getPropertyValue=function(attr){
								var re=/(\-([a-z]){1})/g;
								if(attr==='float') attr='cssFloat';
//								jsCore.debug(attr,131,'dom.js','jsCore.dom.get.style::attr');
								if(re.test(attr)){
									attr=attr.replace(re, function(){
										return arguments[2].toUpperCase();
									});
								}
								return obj.currentStyle[attr] ? obj.currentStyle[attr] : null;
							}
							return this;
						}
					}
				}
			}else{
				if(attr==='border'){
					var w=Math.max(
						parseInt(window.getComputedStyle(obj,"")['borderTopWidth']),
						parseInt(window.getComputedStyle(obj,"")['borderRightWidth']),
						parseInt(window.getComputedStyle(obj,"")['borderBottomWidth']),
						parseInt(window.getComputedStyle(obj,"")['borderLeftWidth'])
					)+'px';
					var s=window.getComputedStyle(obj,"")['borderTopStyle']||
						window.getComputedStyle(obj,"")['borderRightStyle']||
						window.getComputedStyle(obj,"")['borderBottomStyle']||
						window.getComputedStyle(obj,"")['borderLeftStyle'];
					var c=window.getComputedStyle(obj,"")['borderTopColor']||
						window.getComputedStyle(obj,"")['borderRightColor']||
						window.getComputedStyle(obj,"")['borderBottomColor']||
						window.getComputedStyle(obj,"")['borderLeftColor'];
					return w+' '+s+' '+c;
/*					if(jsCore.browser.isGecko)
						console.log(w,s,c);*/
				}else{
					return window.getComputedStyle(obj,"")[attr];
				}
			}
		},
		text: function(obj){
			if(obj.type=="textarea" || obj.type=="text"){
				return obj.value;
			}else if(obj.tagName.toLowerCase()=="iframe"){
				return "<html>\n"+jsCore.dom.get.iframeBody(obj).documentElement.innerHTML+"\n</html>";
			}else{
				return obj.innerHTML;
			}
		}
	},
	set:{
		id: function(obj,id){
			obj.setAttribute('id',id);
		},
		cls:{
			clear: function(obj){
				if(jsCore.browser.isGecko)
					obj.removeAttribute('class');
				else if(jsCore.browser.isIE)
					obj.removeAttribute('className');
			},
			remove: function(obj,cls){
				jsCore.dom.set.cls.replace(obj,cls,'');
			},
			add: function(obj,cls){
				var cur_cls=jsCore.dom.get.cls(obj);
				if(jsCore.browser.isGecko)
					obj.setAttribute('class',(cur_cls!=null && cur_cls.length>0 ? cur_cls+' ' : '')+cls);
				else if(jsCore.browser.isIE)
					obj.setAttribute('className',(cur_cls!=null && cur_cls.length>0 ? cur_cls+' ' : '')+cls);
			},
			replace: function(obj,remCls,addCls){
				var cur_cls=jsCore.dom.get.cls(obj);
				if(cur_cls){
					var curListCls=cur_cls.split(' ');
					var newListCls=new Array();
					for(var el in curListCls)
						if(curListCls[el]==remCls)
							newListCls.push(addCls);
						else
							newListCls.push(curListCls[el]);
					if(jsCore.browser.isGecko)
						obj.setAttribute('class',newListCls.join(' '));
					else if(jsCore.browser.isIE)
						obj.setAttribute('className',newListCls.join(' '));
				}
			}
		},
		item:{
			clear: function(obj){
				if(typeof obj=='object')
					obj.innerHTML='';
			},
			remove: function(objChild){
				if(typeof objChild=='object')
					objChild.parentNode.removeChild(objChild);
			},
			add: function(objParent,objChild){
				if(typeof objChild=='object'){
					objParent.appendChild(objChild);
				}
			},
			addBefore: function(objParent,objChild,objBefore){
				if(typeof objChild=='object' && typeof objBefore=='object')
					objParent.insertBefore(objChild, objBefore);
			},
			replace: function(objParent,objRemChild,objAddChild){
				if(typeof objAddChild=='object' && typeof objRemChild=='object')
					objParent.replaceChild(objAddChild,objRemChild);
			}
		},
		source: function(obj,data){
			obj.src=data;
		},
		style: function(obj,param,value){
			obj.style[param]=value;
		},
		text:{
			clear: function(obj){
				if(obj.type==="textarea" || obj.type==="text")
					obj.value='';
				else
					obj.innerHTML='';
			},
			add: function(obj,data){
				if(obj.type=="textarea" || obj.type=="text")
					obj.value=jsCore.dom.get.text(obj)+data;
				else
					obj.innerHTML=jsCore.dom.get.text(obj)+data;
			},
			replace: function(obj,data){
				jsCore.dom.set.text.clear(obj);
				jsCore.dom.set.text.add(obj,data);
			}
		},
		x: function(obj,value){
			jsCore.dom.set.style(obj,'left',parseInt(value)+'px');
		},
		y: function(obj,value){
			jsCore.dom.set.style(obj,'top',parseInt(value)+'px');
		},
		width: function(obj,value){
			jsCore.dom.set.style(obj,'width',parseInt(value)+'px');
		},
		height: function(obj,value){
			jsCore.dom.set.style(obj,'height',parseInt(value)+'px');
		},
		editable: function(obj){
			var doc=jsCore.dom.get.iframeBody(obj);
			if(doc){
				try{
					if(jsCore.browser.isGecko)
						doc.designMode='On';
					if(jsCore.browser.isIE)
						doc.body.contentEditable=true;
				}catch(e){
					alert(e);
				}
			}
		},
		notEditable: function(obj){
			var doc=jsCore.dom.get.iframeBody(obj);
			if(doc){
				try{
					if(jsCore.browser.isGecko)
						doc.designMode='Off';
					if(jsCore.browser.isIE)
						doc.body.contentEditable=false;
				}catch(e){
					alert(e);
				}
			}
		}
	},
	event:{
		add: function(obj,type,listener){
/*			if(type=='mousedown')
				jsCore.debug('"obj"=>'+obj+"\n"+'"type"=>'+type+" ("+(typeof type)+")\n"+'"listener"=>'+listener+" ("+(typeof listener)+")\n",232,'dom.js','event::add::mousedown');*/
			if(obj.addEventListener){
				obj.addEventListener(type,listener,true);
			}else if(obj.attachEvent){
				obj.attachEvent('on'+type,listener);
			}else{
				obj['on'+type]=listener;
			}
		},
		remove: function(obj,type,listener){
			if(obj.removeEventListener){
				obj.removeEventListener(type,listener,true);
			}else if(obj.detachEvent){
				obj.detachEvent('on'+type,listener);
			}else{
				obj['on'+type]='';
			}
		},
		replace: function(obj,type,lsnOld,lsnNew){
			jsCore.dom.event.remove(obj,type,lsnOld);
			jsCore.dom.event.add(obj,type,lsnNew);
		}
	}
};