jsCore.element=function(config){
	config = config || {};
	var tag=config.tag || 'div';
	var id=config.id || ('jscore-gen-element'+jsCore.counter.inc());
	var cls=config.cls || '';
	var style=config.style || {};
	var text=config.text || '';
	var source=config.source || '';
	var items=config.items || [];
	var image=config.image || [];
	var alt=config.alt || '';
	var attributes=config.attributes || {};
	var on=config.on || {};

	var object=jsCore.dom.create.tag(tag);
	var self=object;
	if(tag==='label'){
		self.setAttribute('for',id);
		if(jsCore.browser.isIE&&parseInt(jsCore.browser.version)==6){
			self.onclick=function(){
				$(id).click();
			}
		}
	}else{
		jsCore.dom.set.id(self,id);
	}
	var a=0;
	if(cls.length>0)
		jsCore.dom.set.cls.add(self,cls);
	for(var stAttr in style)
		if(stAttr.toString().toLowerCase()==='cssfloat' && jsCore.browser.isIE)
			jsCore.dom.set.style(self,'styleFloat',style[stAttr]);
		else
			jsCore.dom.set.style(self,stAttr,style[stAttr]);
	for(a=0;a<items.length;a++)
		jsCore.dom.set.item.add(self,items[a]);
	for(a=0;a<image.length;a++)
		jsCore.dom.set.item.add(self,image[a]);
	if(alt.length>0){
		self.setAttribute('alt',alt);
		self.setAttribute('title',alt);
	}
	if(attributes){
		for(var attr in attributes){
			self.setAttribute(attr,attributes[attr]);
		}
	}
	if(text.length>0 && tag.toLowerCase()!='iframe')
		jsCore.dom.set.text.add(self,text);
	if(source.length>0 && (tag.toLowerCase()!='iframe' || tag.toLowerCase()!='img'))
		jsCore.dom.set.source(self,source);
    if(on)
        for(var ev in on){
            jsCore.dom.event.add(self,ev.toLowerCase(),on[ev]);
        }
//	object.constructor=this;

	object.getCls=function(){
		return jsCore.dom.get.cls(self);
	}
	object.getStyle=function(attr){
		return jsCore.dom.get.style(self,attr);
	};
	object.items=jsCore.dom.get.items(self);

	return object;
};
jsCore.container=function(config){
	config = config || {};
	var object=new jsCore.element({
		id: config.id || 'jscore-gen-container'+jsCore.counter.inc(),
		cls: config.cls || 'container',
		text: config.text || '',
		style: config.style || {
			overflow: 'auto'
		},
		items: config.items || [],
		on: config.on || {}
	});
	return object;
};
jsCore.panel=function(config){
	config = config || {};
	var object=new jsCore.element({
		id: config.id || 'jscore-gen-panel'+jsCore.counter.inc(),
		cls: config.cls || 'panel',
		style: config.style || {},
		text: config.text || '',
		items: config.items || [],
		image: config.image || [],
		on: config.on || {}
	});
	return object;
};
jsCore.toolbar=function(obj){
	items = obj.buttons || new Array;

	var lines=new Array();
	var panels=null;
	var buttons=null;
	var button_name='';
	var image=null;
	for(var l=0;l<items.length;l++){
		panels=new Array();
		for(var p=0;p<items[l].length;p++){
			buttons=new Array();
			for(var b=0;b<items[l][p].length;b++){
// 
				button_name=items[l][p][b];
//
				if(button_name=='divider'){
					buttons.push(new jsCore.tbSeparator());
				}else{
//
					if(obj.properties[button_name].type=='button'){
						image=obj.properties[button_name].image
							? [new jsCore.image({
								source: jsCore.tbImgURL+obj.properties[button_name].image,
								alt: obj.properties[button_name].hint
								})]
							: [];
						if(image.length>0){
							obj.properties[button_name].style={
								backgroundImage: "url('"+jsCore.tbImgURL+obj.properties[button_name].image+"')"
							};
						}
						image=image.length>0
							? [new jsCore.image({
									id: '_'+obj.properties[button_name].id,
									source: jsCore.imgBlank,
									alt: obj.properties[button_name].hint,
									style: {
										width: '21px',
										height: '21px',
										filter: 'alpha(opacity=10)'
									},
									on: {
										click: obj.properties[button_name].method ? jsCore.func[obj.properties[button_name].method] : null,
										mouseover: jsCore.func.setActiveButton,
										mouseout: jsCore.func.setInactiveButton
									}
								})]
							: [];
						obj.properties[button_name].image=image;
						buttons.push(new jsCore.tbButton(obj.properties[button_name]));
// 
					}else if(obj.properties[button_name].type=='select'){
						buttons.push(
							new jsCore.element({
								cls: 'tb_select_container',
								items: [
									new jsCore.tbSelect(obj.properties[button_name])
								]
							})
						);
					}
				}
			}
			panels.push(
				new jsCore.element({
					id: 'jscore-gen-toolbar'+jsCore.counter.inc(),
					cls: 'toolbar',
					items: buttons
				})
			);
		}
		lines.push({cells:[{items: panels}]});
	}
	var main_panel = new jsCore.table({
		attributes: {
			cellPadding: '0',
			cellSpacing: '0',
			border: '0',
			width: '100%'
		},
		rows: lines
	});
	return main_panel;
};
jsCore.statusbar=function(config){
	config = config || {};
	var object=new jsCore.element({
		id: config.id || 'jscore-gen-statusbar'+jsCore.counter.inc(),
		cls: config.cls || 'statusbar',
		style: config.style || {},
		items: config.items || []
	});
	return object;
};
jsCore.tbButton=function(config){
	config = config || {};
	var object=new jsCore.element({
		id: config.id || 'jscore-gen-tb_button'+jsCore.counter.inc(),
		cls: config.cls || 'tb_button',
		style: config.style || {},
		text: config.text || '',
		image: config.image || []
	});
	return object;
};
jsCore.tbSeparator=function(config){
	config = config || {};
	var object=new jsCore.element({
		id: config.id || 'jscore-gen-tb_separator'+jsCore.counter.inc(),
		cls: config.cls || 'tb_separator',
		image: config.image || [new jsCore.image({
			tag: 'img',
			source: jsCore.tbImgURL+'separator.png'
		})]
	});
	return object;
};
jsCore.tbSelect=function(config){
	config = config || {};
	var object=new jsCore.input({
		tag: 'select',
		id: config.id || 'jscore-gen-tb_select'+jsCore.counter.inc(),
		cls: config.cls || 'tb_select',
		style: config.style || {},
		attributes: config.attributes || {},
		on: config.on || {}
	});
	var self=object;
	if(config.menu){
		new jsCore.tbSelectOption(self,config.menu);
	}
	object.setItemIdx=function(v){
		self.selectedIndex=parseInt(v)>self.length?0:parseInt(v);
	};
	object.setItem=function(v){
		for(var idx=0;idx<self.length;idx++){
			if(self[idx].value.toLowerCase()===v.toString().toLowerCase()){
				self.selectedIndex=idx;
				break;
			}
		}
	};
	object.setStyle=function(p,v){
		if(p.toString().toLowerCase()==='cssfloat' && jsCore.browser.isIE)
			jsCore.dom.set.style(self,'styleFloat',v);
		else
			jsCore.dom.set.style(self,p,v);
	}
	object.setItemIdx(0);
	return object;
};
jsCore.tbSelectOption=function(obj,config){
	config = config || {};
	var option=null;
	for(var opt_name in config){
		var span=new jsCore.element({
			tag: 'span',
			text: config[opt_name].text || '',
			style: config[opt_name].style
		});
		option=new Option(config[opt_name].text,config[opt_name].value);
		jsCore.dom.set.id(option,config[opt_name].id || 'jscore-gen-tb_select_option'+jsCore.counter.inc());
		jsCore.dom.set.cls.add(option,config[opt_name].cls || 'tb_select_option');
		for(var st in config[opt_name].style){
			if(config[opt_name].style[st].length>0){
				if(st.toString().toLowerCase()==='cssfloat' && jsCore.browser.isIE)
					jsCore.dom.set.style(option,'styleFloat',config[opt_name].style[st]);
				else
					jsCore.dom.set.style(option,st,config[opt_name].style[st]);
			}
		}
		obj.options.add(option);
	}
};
jsCore.image=function(config){
	config=config||{};
	if(jsCore.browser.isIE){
		var span=jsCore.dom.create.tag('span');
		span.innerHTML='<img'
			+' src="'+(config.source?config.source:jsCore.imgBlank)+'"'
			+' id="'+(config.id?config.id:'jscore-gen-image'+jsCore.counter.inc())+'"'
			+(config.alt?' alt="'+config.alt+'" title="'+config.alt+'"':'')
			+'>';
		var object=span.childNodes[0];
		if(config.cls)
			jsCore.dom.set.cls.add(object,config.cls);
		for(var stAttr in config.style)
			if(stAttr.toString().toLowerCase()==='cssfloat')
				jsCore.dom.set.style(object,'styleFloat',config.style[stAttr]);
			else
				jsCore.dom.set.style(object,stAttr,config.style[stAttr]);
		if(config.on)
			for(var ev in config.on)
				jsCore.dom.event.add(object,ev.toLowerCase(),config.on[ev]);
		object.getCls=function(){
			return jsCore.dom.get.cls(object);
		}
		object.getStyle=function(attr){
			return jsCore.dom.get.style(object,attr);
		};
	}else{
		var object=new jsCore.element({
			tag: 'img',
			id: config.id || 'jscore-gen-image'+jsCore.counter.inc(),
			cls: config.cls || '',
			style: config.style || {},
			source: config.source || jsCore.imgBlank,
			alt: config.alt || '',
			on: config.on || {}
		});
	}
	return object;
};
jsCore.richedit=function(config){
	config = config || {};
	var object=new jsCore.element({
		tag: 'iframe',
		id: config.id || 'jscore-gen-iframe'+core.counter.inc(),
		cls: config.cls || 'richedit',
		style: config.style || {},
		name: config.name || config.id || 'jscore-gen-textarea'+jsCore.counter.get(),
		text: config.text || ''
	});
	var self=object;

	object.clear=function(){
		jsCore.dom.set.text.clear(self);
	};
	object.setEditable=function(){
		jsCore.dom.set.editable(self);
	};
	object.disableEditable=function(){
		jsCore.dom.set.notEditable(self);
	};
	object.addText=function(value){
		jsCore.dom.set.text.add(self,value);
	};
	object.replaceText=function(value){
		var self_doc=jsCore.dom.get.iframeBody(object);
		self_doc.open();
		self_doc.write(value);
		self_doc.close();
		jsCore.func.setREEvents();
	};
	object.getText=function(){
		var self_doc=jsCore.dom.get.iframeBody(self).body;
		self.disableEditable();
		if(jsCore.browser.isIE&&self_doc.getAttribute('contentEditable'))
			self_doc.removeAttribute('contentEditable');
		var r=jsCore.dom.get.text(self);
		self.setEditable();
		return r;
	};
	return object;
};
jsCore.memo=function(config){
	config = config || {};
	var object=new jsCore.input({
		tag: 'textarea',
		id: config.id || 'jscore-gen-textarea'+jsCore.counter.inc(),
		cls: config.cls || 'memo',
		style: config.style || {},
		name: config.name || config.id || 'jscore-gen-textarea'+jsCore.counter.get(),
		text: config.text || ''/*,
		on: {
			keyup: function(){
				jsCore.func.updateToolbar();
			}
		}*/
	});
	var self=object;
	object.setFocus=function(){
		if(jsCore.browser.isIE){
			var r=self.createTextRange();
			r.collapse(self);
			r.select();
		}else{
			self.setSelectionRange(0,0);
			self.focus();
		}
	};
	return object;
};
jsCore.Button=function(config){
	config = config || {};
	var id=config.id || 'jscore-gen-button'+jsCore.counter.inc();
	var cls=config.cls || 'button';
	var style=config.style || {};
	var text=config.text || '';
	var image=config.image || [];
	var on=config.on || {};

	var imgs=new Array();
	if(image.length>0){
		for(var b=0;b<image.length;b++){
			imgs.push(new jsCore.image(image[b]));
		}
	}
	var object=jsCore.element({
		id: id,
		cls: cls,
		style: style,
		on: on,
		items: [
			new jsCore.table({
				attributes: {
					cellPadding: '0',
					cellSpacing: '0'
				},
				rows: [
					{
						cells: [
							{
								cls: 'btn_left'
							},
							{
								cls: 'btn_center',
								items: (imgs.length>0
									? imgs
									: null),
								text: (text
									? text
									: null)
							},
							{
								cls: 'btn_right'
							}
						]
					}
				]
			})
		]
	});
	return object;
};
jsCore.input=function(config){
	config = config || {};
	var tag=config.tag || 'input';
	var id=config.id || ('jscore-gen-input'+jsCore.counter.inc());
	var type=config.type || '';
	var name=config.name || id;
	var text=config.text || '';
	var cls=config.cls || 'jscore-input';
	var style=config.style || {};
	var attributes=config.attributes || {};
	var on=config.on || {};

	var object=null
	if(jsCore.browser.isIE&&tag==='input'){
		var strAttr='';
		if(attributes){
			for(var attr in attributes){
				if(attr==='checked'&&inarray(attributes[attr],['checked','on','enable','1'])>=0)
					strAttr+=' checked';
				else
					strAttr+=' '+attr+'="'+attributes[attr]+'"';
			}
		}
		object=jsCore.dom.create.tag('<'+tag+' id="'+id+'" name="'+(name.length>0?name:id)+(type.length>0?'" type="'+type+'"':'')+(text.length>0?' value="'+text+'"':'')+strAttr+' />');
	}else{
		object=jsCore.dom.create.tag(tag);
		object.id=id;
		object.name=name;
		if(type.length>0)
			object.type=type;
		if(text.length>0)
			object.value=text;
		if(attributes){
			for(var attr in attributes){
				object.setAttribute(attr,attributes[attr]);
			}
		}
	}
	if(cls.length>0)
		jsCore.dom.set.cls.add(object,cls);
	for(var st in style)
		if(st.toString().toLowerCase()==='cssfloat' && jsCore.browser.isIE)
			jsCore.dom.set.style(object,'styleFloat',style[st]);
		else
			jsCore.dom.set.style(object,st,style[st]);
    if(on)
        for(var ev in on){
            jsCore.dom.event.add(object,ev.toLowerCase(),on[ev]);
        }
	var self=object;
//	object.constructor=this;

	object.getCls=function(){
		return jsCore.dom.get.cls(self);
	}
	object.getStyle=function(attr){
		return jsCore.dom.get.style(self,attr);
	};
	object.addText=function(t){
		self.value+=t;
	}
	object.clear=function(){
		self.value='';
	}
	object.replaceText=function(t){
		self.value=t;
	}
	object.disable=function(){
		self.disabled=true;
	}
	object.enable=function(){
		self.disabled=false;
	}
	if(type==='checkbox'||type==='radio'){
		object.check=function(){
			self.checked=true;
		}
		object.uncheck=function(){
			self.checked=false;
		}
	}

	return object;
};
jsCore.table=function(config){
	config = config || {};
	var r=0;
	var c=0;
	var object=null;
	var rows=new Array();
	var cells=new Array();
	var row=null;
	var cell=null;
	var items=config.rows||[];
	var attr=null;
	var st=null;
	var trid='';
	var trcls='';
	var tdid='';
	var tdcls='';
	var selfid='';
	var selfrow=null;
	var selfcell=null;
/**
 * Creating table for IE
 */
	selfid=config.id || 'jscore-gen-table'+jsCore.counter.inc();
	if(jsCore.browser.isIE){
		object=new jsCore.element({
			tag: 'table',
			id: selfid,
			cls: config.cls || '',
			style: config.style || {},
			attributes: config.attributes || {},
			on: config.on || {}
		});
		for(r=0;r<items.length;r++){
			row=object.insertRow(r);
			trid=(typeof items[r].id!='undefined')?items[r].id:'jscore-gen-tr'+jsCore.counter.inc();
			try{
				if(typeof items[r].cls!='undefined'){
					trcls=items[r].cls;
				}
			}catch(e){}
			with(jsCore.dom.set){
				id(row,trid);
				cls.add(row,trcls);
			}
			try{
				if(typeof items[r].attributes!='undefined')
					for(attr in items[r].attributes)
						row.setAttribute(attr,items[r].attributes[attr]);
			}catch(e){}
			try{
				if(typeof items[r].style!='undefined')
					for(st in items[r].style)
						if(st.toString().toLowerCase()==='cssfloat' && jsCore.browser.isIE)
							jsCore.dom.set.style(row,'styleFloat',items[r].style[st]);
						else
							jsCore.dom.set.style(row,st,items[r].style[st]);
			}catch(e){}
			selfrow=row;
			row.getCls=function(){
				return jsCore.dom.get.cls(selfrow);
			}
			row.getStyle=function(attr){
				return jsCore.dom.get.style(selfrow,attr);
			};
			for(c=0;c<items[r].cells.length;c++){
				cell=row.insertCell(c);
				tdid=(typeof items[r].cells[c].id!='undefined')?items[r].cells[c].id:'jscore-gen-td'+jsCore.counter.inc();
				try{
					if(typeof items[r].cells[c].cls!='undefined')
						tdcls=items[r].cells[c].cls;
				}catch(e){}
				with(jsCore.dom.set){
					id(cell,tdid);
					cls.add(cell,tdcls);
				}
				try{
					if(typeof items[r].cells[c].attributes!='undefined')
						for(attr in items[r].cells[c].attributes)
							cell.setAttribute(attr,items[r].cells[c].attributes[attr]);
				}catch(e){}
				try{
					if(typeof items[r].cells[c].style!='undefined')
						for(st in items[r].cells[c].style)
							if(st.toString().toLowerCase()==='cssfloat' && jsCore.browser.isIE)
								jsCore.dom.set.style(cell,'styleFloat',items[r].cells[c].style[st]);
							else
								jsCore.dom.set.style(cell,st,items[r].cells[c].style[st]);
				}catch(e){}
				try{
					if(typeof items[r].cells[c].text!='undefined' && items[r].cells[c].text.length>0)
						cell.innerHTML=items[r].cells[c].text;
				}catch(e){}
				try{
					if(typeof items[r].cells[c].on!='undefined')
						for(attr in items[r].cells[c].on)
							jsCore.dom.event.add(items[r].cells[c],attr.toLowerCase(),items[r].cells[c].on[attr]);
				}catch(e){}
				try{
					if(typeof items[r].cells[c].items!='undefined' && items[r].cells[c].items.length>0)
						for(var i=0;i<items[r].cells[c].items.length;i++)
							jsCore.dom.set.item.add(cell,items[r].cells[c].items[i]);
				}catch(e){}
				selfcell=cell;
				cell.getCls=function(){
					return jsCore.dom.get.cls(selfcell);
				}
				cell.getStyle=function(attr){
					return jsCore.dom.get.style(selfcell,attr);
				};
			}
		}
/**
 * Creating table for other browsers
 */
	}else{
		for(r=0;r<items.length;r++){
			for(c=0;c<items[r].cells.length;c++){
				tdid=items[r].cells[c].id || 'jscore-gen-td'+jsCore.counter.inc();
				cell=new jsCore.element({
					tag: 'td',
					id: tdid,
					cls: items[r].cells[c].cls || '',
					text: items[r].cells[c].text || '',
					style: items[r].cells[c].style || {},
					attributes: items[r].cells[c].attributes || {},
					on: items[r].cells[c].on || {},
					items: items[r].cells[c].items
				});
				selfcell=cell;
				cell.getCls=function(){
					return jsCore.dom.get.cls(selfcell);
				}
				cell.getStyle=function(attr){
					return jsCore.dom.get.style(selfcell,attr);
				};
				cells.push(cell);
			}
			trid=items[r].id || 'jscore-gen-tr'+jsCore.counter.inc();
			row=new jsCore.element({
				tag: 'tr',
				id: trid,
				cls: items[r].cls || '',
				style: items[r].style || {},
				attributes: items[r].attributes || {},
				on: items[r].on || {},
				items: cells
			});
			selfrow=row;
			row.getCls=function(){
				return jsCore.dom.get.cls(selfrow);
			}
			row.getStyle=function(attr){
				return jsCore.dom.get.style(selfrow,attr);
			};
			rows.push(row);
			cells=new Array();
		}
		object=new jsCore.element({
			tag: 'table',
			id: selfid,
			cls: config.cls || '',
			style: config.style || {},
			attributes: config.attributes || {},
			on: config.on || {},
			items: rows
		});
	}
	var selfobj=object;
	object.getCls=function(){
		return jsCore.dom.get.cls(selfobj);
	}
	object.getStyle=function(attr){
		return jsCore.dom.get.style(selfobj,attr);
	};
	return object;
}