<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 exabis internet solutions <info@exabis.at>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

include_once('mysql_iconv.php');
/**
  class.xml2array.php
  The class xml2Array: Parse an XML-File to an array.
  Most parts are taken from the SCORM-Extension of the
  Moodle project (www.moodle.org) (GPL)
*/

class xml2Array {
   var $arrOutput = array();
   var $resParser;
   var $strXmlData;
   var $error;
   
   function parse($strInputXML) {
       $this->resParser = xml_parser_create ('UTF-8');
       xml_set_object($this->resParser,$this);
       xml_set_element_handler($this->resParser, "tagOpen", "tagClosed");
       
       xml_set_character_data_handler($this->resParser, "tagData");
   
       $this->strXmlData = xml_parse($this->resParser,$strInputXML );
       if(!$this->strXmlData) {
           $this->error = sprintf("XML error: %s at line %d", xml_error_string(xml_get_error_code($this->resParser)), xml_get_current_line_number($this->resParser));
           return false;
       }
       
       xml_parser_free($this->resParser);
       return $this->arrOutput;
   }
   
   function tagOpen($parser, $name, $attrs) {
       $tag=array("name"=>$name,"attrs"=>$attrs); 
       array_push($this->arrOutput,$tag);
   }
   
   function tagData($parser, $tagData) {
       if($tagData) {
           if(isset($this->arrOutput[count($this->arrOutput)-1]['tagData'])) {
               $this->arrOutput[count($this->arrOutput)-1]['tagData'] .= utf8_cp1251($tagData);
           } else {
               $this->arrOutput[count($this->arrOutput)-1]['tagData'] = utf8_cp1251($tagData);
           }
       }
   }
   
   function tagClosed($parser, $name) {
       $this->arrOutput[count($this->arrOutput)-2]['children'][] = $this->arrOutput[count($this->arrOutput)-1];
       array_pop($this->arrOutput);
   }
}
?>