-- MySQL dump 10.11
--
-- Host: localhost    Database: twclass
-- ------------------------------------------------------
-- Server version	5.1.23-rc

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES cp1251 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `action_log`
--

DROP TABLE IF EXISTS `action_log`;
CREATE TABLE `action_log` (
  `Id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `MID` int(9) DEFAULT NULL,
  `action_type` varchar(255) DEFAULT NULL,
  `data` datetime DEFAULT NULL,
  `role` tinyint(4) DEFAULT '0',
  `success` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`Id`)
) ENGINE=MyISAM AUTO_INCREMENT=6911 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `action_log`
--

LOCK TABLES `action_log` WRITE;
/*!40000 ALTER TABLE `action_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `action_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admins`
--

DROP TABLE IF EXISTS `admins`;
CREATE TABLE `admins` (
  `AID` int(11) NOT NULL AUTO_INCREMENT,
  `MID` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `AID` (`AID`),
  UNIQUE KEY `MID` (`MID`)
) ENGINE=MyISAM AUTO_INCREMENT=66 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `admins`
--

LOCK TABLES `admins` WRITE;
/*!40000 ALTER TABLE `admins` DISABLE KEYS */;
INSERT INTO `admins` VALUES (1,1);
/*!40000 ALTER TABLE `admins` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arhiv`
--

DROP TABLE IF EXISTS `arhiv`;
CREATE TABLE `arhiv` (
  `vremya` datetime DEFAULT NULL,
  `PID` int(11) NOT NULL DEFAULT '0',
  `type` varchar(255) DEFAULT NULL,
  `temp` text,
  `id` int(11) DEFAULT NULL,
  `cid` int(11) DEFAULT NULL,
  `md5` varchar(40) NOT NULL DEFAULT ''
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `arhiv`
--

LOCK TABLES `arhiv` WRITE;
/*!40000 ALTER TABLE `arhiv` DISABLE KEYS */;
/*!40000 ALTER TABLE `arhiv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cam_casting`
--

DROP TABLE IF EXISTS `cam_casting`;
CREATE TABLE `cam_casting` (
  `castID` int(11) NOT NULL AUTO_INCREMENT,
  `cam_key` varchar(32) NOT NULL DEFAULT '0',
  `CID` tinyint(4) NOT NULL DEFAULT '0',
  `MID` int(11) NOT NULL DEFAULT '0',
  `SHEID` int(11) NOT NULL DEFAULT '0',
  `FILE` blob,
  UNIQUE KEY `castID` (`castID`,`cam_key`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `cam_casting`
--

LOCK TABLES `cam_casting` WRITE;
/*!40000 ALTER TABLE `cam_casting` DISABLE KEYS */;
/*!40000 ALTER TABLE `cam_casting` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cgname`
--

DROP TABLE IF EXISTS `cgname`;
CREATE TABLE `cgname` (
  `cgid` int(11) NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL,
  `name_fa` varchar(255) NOT NULL DEFAULT '-',
  `name_ru` varchar(255) NOT NULL DEFAULT '-',
  KEY `cgid` (`cgid`)
) ENGINE=MyISAM AUTO_INCREMENT=40 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `cgname`
--

LOCK TABLES `cgname` WRITE;
/*!40000 ALTER TABLE `cgname` DISABLE KEYS */;
/*!40000 ALTER TABLE `cgname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `chat`
--

DROP TABLE IF EXISTS `chat`;
CREATE TABLE `chat` (
  `CHID` bigint(20) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `type` int(11) DEFAULT '0',
  `CID` int(11) DEFAULT '0',
  PRIMARY KEY (`CHID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `chat`
--

LOCK TABLES `chat` WRITE;
/*!40000 ALTER TABLE `chat` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `chathistory`
--

DROP TABLE IF EXISTS `chathistory`;
CREATE TABLE `chathistory` (
  `HISTORYID` int(11) NOT NULL AUTO_INCREMENT,
  `CHATID` int(11) NOT NULL DEFAULT '0',
  `Login` varchar(255) NOT NULL DEFAULT '',
  `TimeDate` datetime DEFAULT NULL,
  `MsgText` text,
  `Params` text,
  PRIMARY KEY (`HISTORYID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `chathistory`
--

LOCK TABLES `chathistory` WRITE;
/*!40000 ALTER TABLE `chathistory` DISABLE KEYS */;
/*!40000 ALTER TABLE `chathistory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `claimants`
--

DROP TABLE IF EXISTS `claimants`;
CREATE TABLE `claimants` (
  `SID` int(11) NOT NULL AUTO_INCREMENT,
  `MID` int(11) NOT NULL DEFAULT '0',
  `CID` int(11) NOT NULL DEFAULT '0',
  `Teacher` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`SID`)
) ENGINE=MyISAM AUTO_INCREMENT=373 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `claimants`
--

LOCK TABLES `claimants` WRITE;
/*!40000 ALTER TABLE `claimants` DISABLE KEYS */;
/*!40000 ALTER TABLE `claimants` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `conf_cid`
--

DROP TABLE IF EXISTS `conf_cid`;
CREATE TABLE `conf_cid` (
  `cid` int(10) unsigned NOT NULL DEFAULT '0',
  `autoindex` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `conf_cid`
--

LOCK TABLES `conf_cid` WRITE;
/*!40000 ALTER TABLE `conf_cid` DISABLE KEYS */;
/*!40000 ALTER TABLE `conf_cid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `courses`
--

DROP TABLE IF EXISTS `courses`;
CREATE TABLE `courses` (
  `CID` int(4) NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) CHARACTER SET cp1251 COLLATE cp1251_general_cs NOT NULL DEFAULT '-',
  `Description` text,
  `TypeDes` tinyint(4) NOT NULL DEFAULT '0',
  `CD` text,
  `cBegin` date DEFAULT NULL,
  `cEnd` date DEFAULT NULL,
  `Fee` float DEFAULT NULL,
  `valuta` tinyint(4) NOT NULL DEFAULT '0',
  `Status` varchar(25) DEFAULT NULL,
  `createby` varchar(50) DEFAULT NULL,
  `createdate` date NOT NULL DEFAULT '0000-00-00',
  `Title_fa` varchar(255) NOT NULL DEFAULT '-',
  `Title_ru` varchar(255) NOT NULL DEFAULT '-',
  `Description_fa` text,
  `Description_ru` text,
  `CD_fa` text,
  `CD_ru` text,
  `Assign` tinyint(4) NOT NULL DEFAULT '2',
  `scorm` tinyint(1) NOT NULL DEFAULT '0',
  `scorm_opt` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `SpID` varchar(255) DEFAULT NULL,
  `vers` varchar(255) DEFAULT '1.0.0',
  `auto` smallint(1) DEFAULT NULL,
  PRIMARY KEY (`CID`)
) ENGINE=MyISAM AUTO_INCREMENT=1000201 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `courses`
--

LOCK TABLES `courses` WRITE;
/*!40000 ALTER TABLE `courses` DISABLE KEYS */;
INSERT INTO `courses` VALUES (1000200,' 1','',0,NULL,'2009-10-15','2014-10-15',NULL,0,'1','','2009-10-15','-','-',NULL,NULL,NULL,NULL,2,0,0,'','1.0.0',0);
/*!40000 ALTER TABLE `courses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `courses_stat`
--

DROP TABLE IF EXISTS `courses_stat`;
CREATE TABLE `courses_stat` (
  `CID` int(11) NOT NULL DEFAULT '0',
  `last_access` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `MID` int(11) NOT NULL DEFAULT '0',
  `teacher` char(1) DEFAULT NULL,
  PRIMARY KEY (`CID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `courses_stat`
--

LOCK TABLES `courses_stat` WRITE;
/*!40000 ALTER TABLE `courses_stat` DISABLE KEYS */;
/*!40000 ALTER TABLE `courses_stat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `deans`
--

DROP TABLE IF EXISTS `deans`;
CREATE TABLE `deans` (
  `DID` int(11) NOT NULL AUTO_INCREMENT,
  `MID` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`DID`),
  UNIQUE KEY `MID` (`MID`)
) ENGINE=MyISAM AUTO_INCREMENT=57 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `deans`
--

LOCK TABLES `deans` WRITE;
/*!40000 ALTER TABLE `deans` DISABLE KEYS */;
INSERT INTO `deans` VALUES (1,1);
/*!40000 ALTER TABLE `deans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `depart`
--

DROP TABLE IF EXISTS `depart`;
CREATE TABLE `depart` (
  `DID` bigint(3) unsigned NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) DEFAULT '-',
  `Title_fa` varchar(255) DEFAULT '-',
  `Title_ru` varchar(255) DEFAULT '-',
  `Description` text,
  `Description_fa` text,
  `Description_ru` text,
  `ParentDID` int(11) DEFAULT '0',
  PRIMARY KEY (`DID`)
) ENGINE=MyISAM AUTO_INCREMENT=56 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `depart`
--

LOCK TABLES `depart` WRITE;
/*!40000 ALTER TABLE `depart` DISABLE KEYS */;
INSERT INTO `depart` VALUES (55,' 1','-','-','',NULL,NULL,0);
/*!40000 ALTER TABLE `depart` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `direction`
--

DROP TABLE IF EXISTS `direction`;
CREATE TABLE `direction` (
  `DID` int(15) NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) DEFAULT NULL,
  `Description` text,
  PRIMARY KEY (`DID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 COMMENT='???????????';

--
-- Dumping data for table `direction`
--

LOCK TABLES `direction` WRITE;
/*!40000 ALTER TABLE `direction` DISABLE KEYS */;
/*!40000 ALTER TABLE `direction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ekzamen`
--

DROP TABLE IF EXISTS `ekzamen`;
CREATE TABLE `ekzamen` (
  `PID` int(11) NOT NULL DEFAULT '0',
  `data` date DEFAULT '0000-00-00',
  `CID` int(11) NOT NULL DEFAULT '0',
  `duration` tinyint(4) DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `ekzamen`
--

LOCK TABLES `ekzamen` WRITE;
/*!40000 ALTER TABLE `ekzamen` DISABLE KEYS */;
/*!40000 ALTER TABLE `ekzamen` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eventtools`
--

DROP TABLE IF EXISTS `eventtools`;
CREATE TABLE `eventtools` (
  `TypeID` bigint(20) NOT NULL AUTO_INCREMENT,
  `TypeName` varchar(255) NOT NULL DEFAULT '',
  `Student` tinyint(4) NOT NULL DEFAULT '0',
  `Teacher` tinyint(4) NOT NULL DEFAULT '0',
  `Deen` tinyint(4) NOT NULL DEFAULT '0',
  `Icon` varchar(255) NOT NULL DEFAULT '',
  `XSL` varchar(255) NOT NULL DEFAULT '',
  `Description` text,
  `tools` text,
  `Description_fa` text,
  `Description_ru` text,
  `status` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`TypeID`)
) ENGINE=MyISAM AUTO_INCREMENT=71 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `eventtools`
--

LOCK TABLES `eventtools` WRITE;
/*!40000 ALTER TABLE `eventtools` DISABLE KEYS */;
INSERT INTO `eventtools` VALUES (1,'',0,0,0,'ico_test.gif','def.xsl','','tests','','',0),(2,' ',0,0,0,'ico_video.gif','def.xsl','','liveCamPro','','',0),(4,'   ',0,0,0,'ico_ie.gif','def.xsl','','externalURLs','','',0),(5,' ',0,0,0,'ico_list.gif','def.xsl','','module','','',0),(6,'  ',0,0,0,'standart.gif','def.xsl','','module, books','','',0),(7,'  ',0,0,0,'ico_info.gif','def.xsl','','books','','',0),(11,'   ',0,0,0,'ico_list2.gif','def.xsl','','tests, books','','',0),(12,'NetMeeting',0,0,0,'ico_work.gif','def.xsl','','nm',NULL,NULL,0),(13,'Desktop',0,0,0,'ico_ring.gif','def.xsl','','nm2',NULL,NULL,0),(23,'URLs',0,0,0,'ico_info.gif','def.xsl','','externalURLs',NULL,NULL,0),(28,'LiveCam',0,0,0,'standart.gif','def.xsl','','liveCamPro',NULL,NULL,0);
/*!40000 ALTER TABLE `eventtools` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `exercise`
--

DROP TABLE IF EXISTS `exercise`;
CREATE TABLE `exercise` (
  `Id` int(6) unsigned NOT NULL AUTO_INCREMENT,
  `cid` bigint(20) DEFAULT NULL,
  `lid` bigint(20) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `e_type` int(11) DEFAULT '0',
  PRIMARY KEY (`Id`)
) ENGINE=MyISAM AUTO_INCREMENT=198 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `exercise`
--

LOCK TABLES `exercise` WRITE;
/*!40000 ALTER TABLE `exercise` DISABLE KEYS */;
/*!40000 ALTER TABLE `exercise` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `exercise_otch`
--

DROP TABLE IF EXISTS `exercise_otch`;
CREATE TABLE `exercise_otch` (
  `Id` int(6) unsigned NOT NULL AUTO_INCREMENT,
  `mid` bigint(20) DEFAULT NULL,
  `eid` int(7) DEFAULT NULL,
  `data` datetime DEFAULT NULL,
  `balmax` int(6) DEFAULT NULL,
  `bal` int(6) DEFAULT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `exercise_otch`
--

LOCK TABLES `exercise_otch` WRITE;
/*!40000 ALTER TABLE `exercise_otch` DISABLE KEYS */;
/*!40000 ALTER TABLE `exercise_otch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `file`
--

DROP TABLE IF EXISTS `file`;
CREATE TABLE `file` (
  `kod` varchar(100) NOT NULL DEFAULT '',
  `fnum` int(11) NOT NULL DEFAULT '0',
  `ftype` int(11) NOT NULL DEFAULT '0',
  `fname` varchar(100) NOT NULL DEFAULT '',
  `fdata` longblob,
  `fdate` int(10) unsigned DEFAULT NULL,
  `fx` int(11) NOT NULL DEFAULT '0',
  `fy` int(11) NOT NULL DEFAULT '0',
  `fsize` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`kod`,`fnum`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `file`
--

LOCK TABLES `file` WRITE;
/*!40000 ALTER TABLE `file` DISABLE KEYS */;
/*!40000 ALTER TABLE `file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `file_tranfer`
--

DROP TABLE IF EXISTS `file_tranfer`;
CREATE TABLE `file_tranfer` (
  `ftID` int(11) NOT NULL AUTO_INCREMENT,
  `ft_key` varchar(32) NOT NULL DEFAULT '',
  `ModID` int(11) NOT NULL DEFAULT '0',
  `t_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `MID` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `ft_key` (`ft_key`),
  KEY `ftID` (`ftID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `file_tranfer`
--

LOCK TABLES `file_tranfer` WRITE;
/*!40000 ALTER TABLE `file_tranfer` DISABLE KEYS */;
/*!40000 ALTER TABLE `file_tranfer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filefoto`
--

DROP TABLE IF EXISTS `filefoto`;
CREATE TABLE `filefoto` (
  `mid` int(11) NOT NULL DEFAULT '0',
  `foto` mediumblob NOT NULL,
  `last` int(11) NOT NULL DEFAULT '0',
  `fx` smallint(6) NOT NULL DEFAULT '0',
  `fy` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`mid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `filefoto`
--

LOCK TABLES `filefoto` WRITE;
/*!40000 ALTER TABLE `filefoto` DISABLE KEYS */;
/*!40000 ALTER TABLE `filefoto` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `formula`
--

DROP TABLE IF EXISTS `formula`;
CREATE TABLE `formula` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '-',
  `formula` text NOT NULL,
  `type` int(11) NOT NULL DEFAULT '0',
  `CID` int(11) NOT NULL DEFAULT '0',
  `name_fa` varchar(255) NOT NULL DEFAULT '-',
  `name_ru` varchar(255) NOT NULL DEFAULT '-',
  `formula_fa` text NOT NULL,
  `formula_ru` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `formula`
--

LOCK TABLES `formula` WRITE;
/*!40000 ALTER TABLE `formula` DISABLE KEYS */;
/*!40000 ALTER TABLE `formula` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `forumdiv`
--

DROP TABLE IF EXISTS `forumdiv`;
CREATE TABLE `forumdiv` (
  `fdid` int(6) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `SpID` varchar(255) DEFAULT NULL,
  `CID` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`fdid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `forumdiv`
--

LOCK TABLES `forumdiv` WRITE;
/*!40000 ALTER TABLE `forumdiv` DISABLE KEYS */;
/*!40000 ALTER TABLE `forumdiv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `forumfiles`
--

DROP TABLE IF EXISTS `forumfiles`;
CREATE TABLE `forumfiles` (
  `fid` int(6) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `realname` varchar(255) DEFAULT NULL,
  `msgid` int(6) DEFAULT NULL,
  PRIMARY KEY (`fid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `forumfiles`
--

LOCK TABLES `forumfiles` WRITE;
/*!40000 ALTER TABLE `forumfiles` DISABLE KEYS */;
/*!40000 ALTER TABLE `forumfiles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `forummessages`
--

DROP TABLE IF EXISTS `forummessages`;
CREATE TABLE `forummessages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `thread` int(11) DEFAULT NULL,
  `posted` varchar(15) DEFAULT NULL,
  `icon` tinyint(4) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `sendmail` tinyint(1) DEFAULT NULL,
  `message` text,
  `lang` varchar(10) NOT NULL DEFAULT '',
  `correct` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=250 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `forummessages`
--

LOCK TABLES `forummessages` WRITE;
/*!40000 ALTER TABLE `forummessages` DISABLE KEYS */;
/*!40000 ALTER TABLE `forummessages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `forumthreads`
--

DROP TABLE IF EXISTS `forumthreads`;
CREATE TABLE `forumthreads` (
  `thread` int(11) NOT NULL AUTO_INCREMENT,
  `course` varchar(100) DEFAULT NULL,
  `lastpost` varchar(15) DEFAULT NULL,
  `answers` int(11) DEFAULT '0',
  `to_id` int(10) DEFAULT NULL,
  `SpID` bigint(3) DEFAULT NULL,
  `fdid` int(6) DEFAULT NULL,
  PRIMARY KEY (`thread`)
) ENGINE=MyISAM AUTO_INCREMENT=142 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `forumthreads`
--

LOCK TABLES `forumthreads` WRITE;
/*!40000 ALTER TABLE `forumthreads` DISABLE KEYS */;
/*!40000 ALTER TABLE `forumthreads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glosary`
--

DROP TABLE IF EXISTS `glosary`;
CREATE TABLE `glosary` (
  `name` varchar(255) DEFAULT NULL,
  `html` text,
  `file` varchar(255) NOT NULL DEFAULT '',
  `CID` int(9) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `glosary`
--

LOCK TABLES `glosary` WRITE;
/*!40000 ALTER TABLE `glosary` DISABLE KEYS */;
/*!40000 ALTER TABLE `glosary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `graduated`
--

DROP TABLE IF EXISTS `graduated`;
CREATE TABLE `graduated` (
  `SID` int(11) NOT NULL AUTO_INCREMENT,
  `MID` int(11) NOT NULL DEFAULT '0',
  `CID` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`SID`)
) ENGINE=MyISAM AUTO_INCREMENT=141 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `graduated`
--

LOCK TABLES `graduated` WRITE;
/*!40000 ALTER TABLE `graduated` DISABLE KEYS */;
/*!40000 ALTER TABLE `graduated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `groupname`
--

DROP TABLE IF EXISTS `groupname`;
CREATE TABLE `groupname` (
  `gid` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '-',
  `name_fa` varchar(255) DEFAULT NULL,
  `name_ru` varchar(255) DEFAULT NULL,
  `status` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`gid`)
) ENGINE=MyISAM AUTO_INCREMENT=51 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `groupname`
--

LOCK TABLES `groupname` WRITE;
/*!40000 ALTER TABLE `groupname` DISABLE KEYS */;
/*!40000 ALTER TABLE `groupname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `groupuser`
--

DROP TABLE IF EXISTS `groupuser`;
CREATE TABLE `groupuser` (
  `id` int(6) NOT NULL DEFAULT '0',
  `mid` int(11) NOT NULL DEFAULT '0',
  `cid` int(11) NOT NULL DEFAULT '0',
  `gid` int(11) NOT NULL DEFAULT '0',
  KEY `gid` (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `groupuser`
--

LOCK TABLES `groupuser` WRITE;
/*!40000 ALTER TABLE `groupuser` DISABLE KEYS */;
/*!40000 ALTER TABLE `groupuser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jobpos`
--

DROP TABLE IF EXISTS `jobpos`;
CREATE TABLE `jobpos` (
  `JPID` bigint(3) unsigned NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) DEFAULT '-',
  `Title_fa` varchar(255) DEFAULT '-',
  `Title_ru` varchar(255) DEFAULT '-',
  `Description` text,
  `Description_fa` text,
  `Description_ru` text,
  PRIMARY KEY (`JPID`)
) ENGINE=MyISAM AUTO_INCREMENT=49 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `jobpos`
--

LOCK TABLES `jobpos` WRITE;
/*!40000 ALTER TABLE `jobpos` DISABLE KEYS */;
INSERT INTO `jobpos` VALUES (48,' 1','-','-','',NULL,NULL);
/*!40000 ALTER TABLE `jobpos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `knigi`
--

DROP TABLE IF EXISTS `knigi`;
CREATE TABLE `knigi` (
  `KID` int(11) NOT NULL AUTO_INCREMENT,
  `CID` int(11) NOT NULL DEFAULT '0',
  `Name` text NOT NULL,
  `Author` text NOT NULL,
  `Izdatel` text NOT NULL,
  `Year` int(11) DEFAULT NULL,
  `Description` longtext NOT NULL,
  `Url` text NOT NULL,
  `Name_fa` text,
  `Name_ru` text,
  `Author_fa` text,
  `Author_ru` text,
  `Izdatel_fa` text,
  `Izdatel_ru` text,
  `Url_fa` text,
  `Url_ru` text,
  `Description_fa` longtext,
  `Description_ru` longtext,
  PRIMARY KEY (`KID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `knigi`
--

LOCK TABLES `knigi` WRITE;
/*!40000 ALTER TABLE `knigi` DISABLE KEYS */;
/*!40000 ALTER TABLE `knigi` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lesson`
--

DROP TABLE IF EXISTS `lesson`;
CREATE TABLE `lesson` (
  `LID` int(11) NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) NOT NULL DEFAULT '-',
  `Title_fa` varchar(255) NOT NULL DEFAULT '-',
  `Title_ru` varchar(255) NOT NULL DEFAULT '-',
  `Description` text NOT NULL,
  `Description_fa` text,
  `Description_ru` text,
  `lesson_target` varchar(255) DEFAULT NULL,
  `CID` int(11) DEFAULT NULL,
  `MID` int(11) DEFAULT NULL,
  `link` text,
  `ord` int(11) DEFAULT NULL,
  `version` varchar(32) DEFAULT '1.0.1',
  PRIMARY KEY (`LID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `lesson`
--

LOCK TABLES `lesson` WRITE;
/*!40000 ALTER TABLE `lesson` DISABLE KEYS */;
/*!40000 ALTER TABLE `lesson` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lesson_target`
--

DROP TABLE IF EXISTS `lesson_target`;
CREATE TABLE `lesson_target` (
  `lesson_target_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `lesson_id` bigint(20) DEFAULT NULL,
  `target_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`lesson_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;

--
-- Dumping data for table `lesson_target`
--

LOCK TABLES `lesson_target` WRITE;
/*!40000 ALTER TABLE `lesson_target` DISABLE KEYS */;
/*!40000 ALTER TABLE `lesson_target` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `list`
--

DROP TABLE IF EXISTS `list`;
CREATE TABLE `list` (
  `kod` varchar(100) NOT NULL DEFAULT '',
  `qtype` int(11) NOT NULL DEFAULT '0',
  `qdata` text NOT NULL,
  `qtema` text NOT NULL,
  `qmoder` tinyint(4) NOT NULL DEFAULT '0',
  `adata` text NOT NULL,
  `balmax` int(11) NOT NULL DEFAULT '0',
  `balmin` int(11) NOT NULL DEFAULT '0',
  `url` text NOT NULL,
  `last` int(11) NOT NULL DEFAULT '0',
  `qdata_fa` text,
  `qdata_ru` text,
  `qtema_fa` text,
  `qtema_ru` text,
  `adata_fa` text,
  `adata_ru` text,
  PRIMARY KEY (`kod`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `list`
--

LOCK TABLES `list` WRITE;
/*!40000 ALTER TABLE `list` DISABLE KEYS */;
/*!40000 ALTER TABLE `list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `logseance`
--

DROP TABLE IF EXISTS `logseance`;
CREATE TABLE `logseance` (
  `stid` int(10) unsigned NOT NULL DEFAULT '0',
  `mid` int(10) unsigned NOT NULL DEFAULT '0',
  `cid` int(10) unsigned NOT NULL DEFAULT '0',
  `tid` int(10) unsigned NOT NULL DEFAULT '0',
  `kod` varchar(255) NOT NULL DEFAULT '',
  `number` smallint(5) unsigned NOT NULL DEFAULT '0',
  `time` int(10) unsigned NOT NULL DEFAULT '0',
  `bal` float NOT NULL DEFAULT '0',
  `balmax` float NOT NULL DEFAULT '0',
  `balmin` float NOT NULL DEFAULT '0',
  `good` int(11) NOT NULL DEFAULT '0',
  `vopros` longblob NOT NULL,
  `otvet` longblob NOT NULL,
  `attach` longblob NOT NULL,
  `filename` varchar(255) NOT NULL DEFAULT '',
  `text` text NOT NULL,
  `md5` varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY (`stid`,`kod`),
  KEY `mid` (`mid`),
  KEY `cid` (`cid`),
  KEY `tid` (`tid`),
  KEY `kod` (`kod`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `logseance`
--

LOCK TABLES `logseance` WRITE;
/*!40000 ALTER TABLE `logseance` DISABLE KEYS */;
/*!40000 ALTER TABLE `logseance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `loguser`
--

DROP TABLE IF EXISTS `loguser`;
CREATE TABLE `loguser` (
  `stid` int(11) NOT NULL AUTO_INCREMENT,
  `mid` int(11) NOT NULL DEFAULT '0',
  `cid` int(11) NOT NULL DEFAULT '0',
  `tid` int(11) NOT NULL DEFAULT '0',
  `balmax` float NOT NULL DEFAULT '0',
  `balmin` float NOT NULL DEFAULT '0',
  `balmax2` float NOT NULL DEFAULT '0',
  `balmin2` float NOT NULL DEFAULT '0',
  `bal` float NOT NULL DEFAULT '0',
  `questdone` smallint(5) unsigned NOT NULL DEFAULT '0',
  `questall` smallint(5) unsigned NOT NULL DEFAULT '0',
  `qty` smallint(6) NOT NULL DEFAULT '0',
  `free` tinyint(4) NOT NULL DEFAULT '0',
  `skip` tinyint(4) NOT NULL DEFAULT '0',
  `start` int(11) unsigned NOT NULL DEFAULT '0',
  `stop` int(11) unsigned NOT NULL DEFAULT '0',
  `fulltime` int(10) unsigned NOT NULL DEFAULT '0',
  `moder` tinyint(4) NOT NULL DEFAULT '0',
  `needmoder` tinyint(4) NOT NULL DEFAULT '0',
  `status` tinyint(4) NOT NULL DEFAULT '0',
  `moderby` int(11) NOT NULL DEFAULT '0',
  `modertime` int(10) unsigned NOT NULL DEFAULT '0',
  `teachertest` tinyint(4) NOT NULL DEFAULT '0',
  `log` blob NOT NULL,
  `porog` int(11) NOT NULL DEFAULT '0',
  `md5` varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY (`stid`),
  KEY `mid` (`mid`),
  KEY `cid` (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `loguser`
--

LOCK TABLES `loguser` WRITE;
/*!40000 ALTER TABLE `loguser` DISABLE KEYS */;
/*!40000 ALTER TABLE `loguser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mail`
--

DROP TABLE IF EXISTS `mail`;
CREATE TABLE `mail` (
  `MailID` int(10) NOT NULL AUTO_INCREMENT,
  `Subject` text NOT NULL,
  `Body` text,
  `PID` varchar(20) DEFAULT '0',
  `data` datetime DEFAULT NULL,
  `From` bigint(20) unsigned DEFAULT NULL,
  PRIMARY KEY (`MailID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `mail`
--

LOCK TABLES `mail` WRITE;
/*!40000 ALTER TABLE `mail` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mail_files`
--

DROP TABLE IF EXISTS `mail_files`;
CREATE TABLE `mail_files` (
  `mail_files_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `filename` varchar(255) DEFAULT NULL,
  `real_name` varchar(255) DEFAULT NULL,
  `mail_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`mail_files_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;

--
-- Dumping data for table `mail_files`
--

LOCK TABLES `mail_files` WRITE;
/*!40000 ALTER TABLE `mail_files` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail_files` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mail_resource`
--

DROP TABLE IF EXISTS `mail_resource`;
CREATE TABLE `mail_resource` (
  `ID` int(6) NOT NULL DEFAULT '0',
  `subject` text,
  `subject_fa` text,
  `subject_ru` text,
  `body` text,
  `body_fa` text,
  `body_ru` text,
  `comment` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `mail_resource`
--

LOCK TABLES `mail_resource` WRITE;
/*!40000 ALTER TABLE `mail_resource` DISABLE KEYS */;
INSERT INTO `mail_resource` VALUES (0,'     [COURSE]  ','      . [COURSE].','     [COURSE]','!      [COURSE]<br />\r\n   :<br />\r\n   (): [LOGIN] <br />\r\n : [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>',' !        [COURSE]<br />\r\n :<br />\r\n   ( ) : [LOGIN]<br />\r\n   ( ): [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','!      [COURSE]<br />\r\n   :<br />\r\n   (): [LOGIN]<br />\r\n : [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n','     '),(1,'      [COURSE] ','     _   . [COURSE]. ','    ',' ,      [COURSE]. <br />\r\n<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>  ','      _  . [COURSE]. ',' ,      [COURSE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','     '),(2,'     [COURSE]   ',' !       . [COURSE].  ','    ','!      [COURSE]<br />\r\n<br />\r\n<hr><br />\r\n[DEANNAME]  <br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n',' !       . [COURSE]<br />\r\n<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','!      [COURSE]<br />\r\n<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n','   '),(3,'   ','     . ','    ',' ,     [COURSE]  <br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a> ','       . [COURSE].',' ,     .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','     '),(5,'    ','      .','   ','!     [COURSE]   .<br />\r\n<br />\r\n   :<br />\r\n   (): [LOGIN]  <br />\r\n : [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n',' !   .    . [COURSE].<br />\r\n:<br />\r\n   ( ): [LOGIN]<br />\r\n   ( ): [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','!     [COURSE]   .<br />\r\n<br />\r\n   :<br />\r\n   (): [LOGIN]<br />\r\n : [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n','    '),(6,'       ','      _  . ','    ',' ,        [COURSE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>  ','      _  . [COURSE]. ',' ,        [COURSE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','     '),(7,'      ','     . ','    ',' ,             [COURSE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>  ','      _  . [COURSE].  ',' ,             [COURSE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','     '),(8,'       ','      _   . ','     ','   : [COURSE].   <br />\r\n  :<br />\r\n[DESCRIPTION].<br />\r\n<hr><br />\r\n  e-mail <a href=\"mailto:[MAILTO]\">[MAILTO]</a><br />\r\n','     _     . [COURSE].<br />\r\n      : \"[DESCRIPTION]\".<br />\r\n _      <a href=\"mailto:[MAILTO]\">[MAILTO]</a><br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','   : [COURSE].<br />\r\n  :<br />\r\n[DESCRIPTION].<br />\r\n<hr><br />\r\n  e-mail <a href=\"mailto:[MAILTO]\">[MAILTO]</a>','    '),(9,'       ','  _      _ _ѡ   . ','     ','          [COURSE]<br />\r\n    .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>   <br />\r\n','     [COURSE]      _ .<br />\r\n      _.<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','          [COURSE]<br />\r\n     .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n','   '),(10,'      ','    .','   ',' [NEWCOURSENAME]        !    <br />\r\n            ,    , ,      .       .<br />\r\n       ,               .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>',' \"[NEWCOURSENAME]\"  _         _  _!  _        _                        .     _   _ . _        _     _              .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>',' [NEWCOURSENAME]        !<br />\r\n            ,    , ,      .       .<br />\r\n       ,               .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','   '),(11,'     ','!','  ','!   [COURSE]   \" \"<br />\r\n      , , ,  .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>   ',' !   ѡ  [COURSE]   \"   \"  _  .<br />\r\n_               _    .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','!   [COURSE]   \"\"<br />\r\n      , , ,   .<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','     \" \"'),(12,'     <br />\r\n','_  _    _ _. ','    ','<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>  ','<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','  '),(13,'     ','_    _   .','  ',' , [LFNAME].   <br />\r\n[LFNAME2]     [COURSE]:<br />\r\n<hr><br />\r\n[MESSAGE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n',' [LFNAME], <br />\r\n[LFNAME2]          . \'[COURSE]\'.<br />\r\n<hr><br />\r\n[MESSAGE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>',' , [LFNAME].<br />\r\n[LFNAME2]     [COURSE].<br />\r\n<hr><br />\r\n[MESSAGE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n','   '),(14,'  ','_       .  ','  ',', [LFNAME]!<br />\r\n[LFNAME2]    [COURSE]    .<br />\r\n<hr><br />\r\n[MESSAGE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>   <br />\r\n',' [LFNAME], <br />\r\n[LFNAME2]   _        . \'[COURSE]\'.<br />\r\n<hr><br />\r\n[MESSAGE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>',' [LFNAME]!<br />\r\n[LFNAME2]     [COURSE].<br />\r\n<hr><br />\r\n[MESSAGE].<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a><br />\r\n','   '),(15,'   ','  . ',' ','      .<br />\r\n   :<br />\r\n  : [LOGIN]<br />\r\n : [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>   <br />\r\n','       _ _   _.<br />\r\n: <br />\r\n   (  ): [LOGIN]<br />\r\n   ( ): [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','      .<br />\r\n   :<br />\r\n  : [LOGIN]<br />\r\n : [PASSWORD]<br />\r\n<hr><br />\r\n[DEANNAME]<br />\r\n<a href=\"mailto:[DEANMAIL]\">[DEANMAIL]</a>','   '),(16,'        ','       .','      ','        [COURSE].<br />\r\n      .             .<br />\r\n        .<br />\r\n[DEANNAME]  ','       [COURSE] .<br />\r\n     .      ѡ         .<br />\r\n_  _ԡ         _    .<br />\r\n     .<br />\r\n[DEANNAME]','        [COURSE]<br />\r\n      .             .<br />\r\n        .<br />\r\n[DEANNAME]','     '),(17,'    ','   ','  ',', [LFNAME2],         [COURSE]<br />\r\n  e-mail<br />\r\n[MAILTO]   ','ȡ [LFNAME2],     [COURSE]     _.<br />\r\n _    :<br />\r\n[MAILTO]',', [LFNAME2],         [COURSE]<br />\r\n  e-mail<br />\r\n[MAILTO]','       '),(18,'   ','!     .',' ','!     [COURSE]    <br />\r\n   :<br />\r\n : [LOGIN]<br />\r\n: [PASSWORD]<br />\r\n      <br />\r\n',' !    [COURSE]   _ .<br />\r\n  (  ) :   [LOGIN]<br />\r\n  : [PASSWORD]<br />\r\n               <br />\r\n[MAILTO]','!     [COURSE]<br />\r\n   :<br />\r\n : [LOGIN]<br />\r\n: [PASSWORD]<br />\r\n      \'\'<br />\r\n[MAILTO]','        \" \"'),(19,'    ','      .','  ',', [LFNAME2],      [COURSE],   .<br />\r\n  e-mail: [MAILTO]   ','  [LFNAME2]            [COURSE]  _.<br />\r\n _      .<br />\r\n[MAILTO]',', [LFNAME2],      [COURSE],   .<br />\r\n  e-mail: [MAILTO]','          \" \"'),(20,'        ','        ','      ','        [COURSE]. <br />\r\n      .          . <br />\r\n         . <br />\r\n<HR><br />\r\n[MAILTO]  ','        [COURSE]  .<br />\r\n               .<br />\r\n_  _       _ _      .<br />\r\n      .<br />\r\n[MAILTO]','        [COURSE]. <br />\r\n    .          . <br />\r\n         . <br />\r\n<HR><br />\r\n[MAILTO]','    '),(21,'    ','    ','  ',', [LFNAME2],         [COURSE]<br />\r\n  e-mail    <br />\r\n[MAILTO]','ȡ [LFNAME2],     [COURSE]     _.<br />\r\n _    :<to><br />\r\n[MAILTO]',', [LFNAME2],         [COURSE]<br />\r\n  e-mail<br />\r\n[MAILTO]','       ');
/*!40000 ALTER TABLE `mail_resource` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mid_log`
--

DROP TABLE IF EXISTS `mid_log`;
CREATE TABLE `mid_log` (
  `mid` bigint(20) unsigned NOT NULL DEFAULT '0',
  `page` varchar(255) DEFAULT NULL,
  `role` tinyint(4) DEFAULT NULL,
  `data` datetime DEFAULT NULL,
  PRIMARY KEY (`mid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `mid_log`
--

LOCK TABLES `mid_log` WRITE;
/*!40000 ALTER TABLE `mid_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `mid_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mod_content`
--

DROP TABLE IF EXISTS `mod_content`;
CREATE TABLE `mod_content` (
  `McID` int(11) NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) NOT NULL DEFAULT '-',
  `ModID` int(11) NOT NULL DEFAULT '0',
  `mod_l` varchar(255) DEFAULT NULL,
  `type` varchar(40) NOT NULL DEFAULT '0',
  `conttype` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`McID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `mod_content`
--

LOCK TABLES `mod_content` WRITE;
/*!40000 ALTER TABLE `mod_content` DISABLE KEYS */;
/*!40000 ALTER TABLE `mod_content` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mod_lesson`
--

DROP TABLE IF EXISTS `mod_lesson`;
CREATE TABLE `mod_lesson` (
  `mod_lesson_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `mod_id` bigint(20) DEFAULT NULL,
  `lesson_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`mod_lesson_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;

--
-- Dumping data for table `mod_lesson`
--

LOCK TABLES `mod_lesson` WRITE;
/*!40000 ALTER TABLE `mod_lesson` DISABLE KEYS */;
/*!40000 ALTER TABLE `mod_lesson` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mod_list`
--

DROP TABLE IF EXISTS `mod_list`;
CREATE TABLE `mod_list` (
  `ModID` int(11) NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) NOT NULL DEFAULT '-',
  `Num` varchar(40) NOT NULL DEFAULT '0',
  `Descript` text,
  `Pub` tinyint(2) NOT NULL DEFAULT '0',
  `CID` int(11) NOT NULL DEFAULT '0',
  `PID` int(11) NOT NULL DEFAULT '0',
  `forum_id` int(11) DEFAULT NULL,
  `test_id` varchar(255) NOT NULL DEFAULT '',
  `Title_fa` varchar(255) DEFAULT NULL,
  `Title_ru` varchar(255) DEFAULT NULL,
  `Descript_fa` text,
  `Descript_ru` text,
  `Num_fa` varchar(40) DEFAULT NULL,
  `Num_ru` varchar(40) DEFAULT NULL,
  `mod_lesson` varchar(255) DEFAULT NULL,
  `ord` int(11) DEFAULT NULL,
  `version` varchar(32) DEFAULT '1.0.1',
  PRIMARY KEY (`ModID`),
  UNIQUE KEY `mod_lesson` (`mod_lesson`)
) ENGINE=MyISAM AUTO_INCREMENT=1000232 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `mod_list`
--

LOCK TABLES `mod_list` WRITE;
/*!40000 ALTER TABLE `mod_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `mod_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `money`
--

DROP TABLE IF EXISTS `money`;
CREATE TABLE `money` (
  `moneyid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `sum` int(11) DEFAULT NULL,
  `mid` int(11) DEFAULT NULL,
  `trid` int(11) DEFAULT NULL,
  `date` int(11) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `sign` int(11) DEFAULT NULL,
  `info` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`moneyid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `money`
--

LOCK TABLES `money` WRITE;
/*!40000 ALTER TABLE `money` DISABLE KEYS */;
/*!40000 ALTER TABLE `money` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `new_news`
--

DROP TABLE IF EXISTS `new_news`;
CREATE TABLE `new_news` (
  `nID` int(11) NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL DEFAULT '0000-00-00',
  `autor` varchar(40) NOT NULL DEFAULT '',
  `email` varchar(60) NOT NULL DEFAULT '',
  `Title` varchar(120) NOT NULL DEFAULT '',
  `news` text NOT NULL,
  `perm` tinyint(2) NOT NULL DEFAULT '0',
  `inarhiv` tinyint(2) NOT NULL DEFAULT '0',
  `image` blob,
  PRIMARY KEY (`nID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `new_news`
--

LOCK TABLES `new_news` WRITE;
/*!40000 ALTER TABLE `new_news` DISABLE KEYS */;
/*!40000 ALTER TABLE `new_news` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news`
--

DROP TABLE IF EXISTS `news`;
CREATE TABLE `news` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` varchar(50) DEFAULT NULL,
  `author` varchar(50) DEFAULT NULL,
  `message` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `news`
--

LOCK TABLES `news` WRITE;
/*!40000 ALTER TABLE `news` DISABLE KEYS */;
/*!40000 ALTER TABLE `news` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news2`
--

DROP TABLE IF EXISTS `news2`;
CREATE TABLE `news2` (
  `nID` int(11) NOT NULL AUTO_INCREMENT,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `Title` varchar(255) NOT NULL DEFAULT '',
  `author` varchar(50) DEFAULT NULL,
  `message` text NOT NULL,
  `lang` char(3) NOT NULL DEFAULT '',
  `showflag` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`nID`)
) ENGINE=MyISAM AUTO_INCREMENT=27 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `news2`
--

LOCK TABLES `news2` WRITE;
/*!40000 ALTER TABLE `news2` DISABLE KEYS */;
/*!40000 ALTER TABLE `news2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `options`
--

DROP TABLE IF EXISTS `options`;
CREATE TABLE `options` (
  `OptionID` tinyint(4) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `value` text NOT NULL,
  PRIMARY KEY (`OptionID`)
) ENGINE=MyISAM AUTO_INCREMENT=25 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `options`
--

LOCK TABLES `options` WRITE;
/*!40000 ALTER TABLE `options` DISABLE KEYS */;
INSERT INTO `options` VALUES (1,'adminLogin','admin'),(2,'adminPass',''),(3,'dekanLogin','dean'),(4,'dekanPass',''),(5,'dekanEMail','info@ksob.ru'),(6,'dekanName',''),(7,'template','style'),(9,'build','20020827'),(8,'version','2.0'),(21,'indexing_status','can run'),(16,'lesson_type','0'),(19,'Mail','0'),(18,'livecam','0'),(23,'video',''),(22,'notif','1'),(20,'upload_url','http://twclass.ksob.ru/twclass/'),(15,'schedule','1'),(17,'porog','85'),(24,'chat','');
/*!40000 ALTER TABLE `options` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `organizations`
--

DROP TABLE IF EXISTS `organizations`;
CREATE TABLE `organizations` (
  `oid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `cid` int(11) DEFAULT NULL,
  `root_ref` int(11) DEFAULT NULL,
  `level` int(11) DEFAULT NULL,
  `next_ref` int(11) DEFAULT NULL,
  `prev_ref` int(11) DEFAULT NULL,
  `mod_ref` int(11) DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `vol1` int(11) DEFAULT NULL,
  `vol2` int(11) DEFAULT NULL,
  `metadata` text,
  PRIMARY KEY (`oid`),
  KEY `prev_ref` (`prev_ref`)
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `organizations`
--

LOCK TABLES `organizations` WRITE;
/*!40000 ALTER TABLE `organizations` DISABLE KEYS */;
/*!40000 ALTER TABLE `organizations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `people`
--

DROP TABLE IF EXISTS `people`;
CREATE TABLE `people` (
  `MID` int(11) NOT NULL AUTO_INCREMENT,
  `LastName` varchar(255) NOT NULL DEFAULT '-',
  `FirstName` varchar(255) NOT NULL DEFAULT '-',
  `Registered` int(11) NOT NULL DEFAULT '0',
  `Course` int(11) DEFAULT NULL,
  `EMail` varchar(255) NOT NULL DEFAULT '',
  `Phone` varchar(255) DEFAULT NULL,
  `Information` text,
  `Patronymic` varchar(255) DEFAULT '-',
  `Address` text,
  `Fax` varchar(255) DEFAULT NULL,
  `Password` varchar(255) NOT NULL DEFAULT '',
  `javapassword` varchar(20) NOT NULL DEFAULT '',
  `Login` varchar(255) NOT NULL DEFAULT '',
  `BirthDate` date DEFAULT NULL,
  `CellularNumber` varchar(255) DEFAULT NULL,
  `ICQNumber` varchar(11) DEFAULT NULL,
  `Age` tinyint(4) DEFAULT NULL,
  `last` int(11) unsigned DEFAULT '0',
  `countlogin` int(11) NOT NULL DEFAULT '0',
  `RegisterDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `Department` varchar(10) DEFAULT '0',
  `Job_Position_Title` varchar(10) DEFAULT '0',
  `Category` varchar(11) DEFAULT '0',
  `National_Codes` varchar(45) DEFAULT NULL,
  `Postal_Address` varchar(255) DEFAULT NULL,
  `ID` varchar(45) DEFAULT NULL,
  `Gender` tinyint(4) NOT NULL DEFAULT '1',
  `reg` tinyint(4) NOT NULL DEFAULT '0',
  `forum_spec` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`MID`)
) ENGINE=MyISAM AUTO_INCREMENT=332 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `people`
--

LOCK TABLES `people` WRITE;
/*!40000 ALTER TABLE `people` DISABLE KEYS */;
INSERT INTO `people` VALUES (1,'Admin','Admin',0,NULL,'','','','','','','c4ca4238a0b923820dcc509a6f75849b','','admin','2004-01-01','','',0,1255615990,2388,'0000-00-00 00:00:00','1','1','1000000','','','',1,1,'1000000;1000002');
/*!40000 ALTER TABLE `people` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `personal`
--

DROP TABLE IF EXISTS `personal`;
CREATE TABLE `personal` (
  `PID` tinyint(4) NOT NULL AUTO_INCREMENT,
  `FIO` varchar(255) NOT NULL DEFAULT '-',
  `work` varchar(255) NOT NULL DEFAULT '-',
  `tel` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `type` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`PID`)
) ENGINE=MyISAM AUTO_INCREMENT=20 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `personal`
--

LOCK TABLES `personal` WRITE;
/*!40000 ALTER TABLE `personal` DISABLE KEYS */;
/*!40000 ALTER TABLE `personal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `posts`
--

DROP TABLE IF EXISTS `posts`;
CREATE TABLE `posts` (
  `posted` varchar(15) NOT NULL DEFAULT '',
  `name` varchar(255) DEFAULT NULL,
  `course` varchar(100) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `text` text,
  PRIMARY KEY (`posted`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `posts`
--

LOCK TABLES `posts` WRITE;
/*!40000 ALTER TABLE `posts` DISABLE KEYS */;
/*!40000 ALTER TABLE `posts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `posts3`
--

DROP TABLE IF EXISTS `posts3`;
CREATE TABLE `posts3` (
  `PostID` int(11) NOT NULL AUTO_INCREMENT,
  `posted` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `name` varchar(255) NOT NULL DEFAULT '',
  `CID` int(11) NOT NULL DEFAULT '0',
  `email` varchar(120) NOT NULL DEFAULT '',
  `text` text NOT NULL,
  `lang` varchar(10) NOT NULL DEFAULT '',
  PRIMARY KEY (`PostID`)
) ENGINE=MyISAM AUTO_INCREMENT=64 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `posts3`
--

LOCK TABLES `posts3` WRITE;
/*!40000 ALTER TABLE `posts3` DISABLE KEYS */;
/*!40000 ALTER TABLE `posts3` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reports`
--

DROP TABLE IF EXISTS `reports`;
CREATE TABLE `reports` (
  `rpt_id` smallint(5) unsigned NOT NULL,
  `rpt_name` varchar(255) NOT NULL,
  `rpt_active` tinyint(1) NOT NULL,
  `rpt_ord` smallint(5) unsigned NOT NULL,
  `rpt_header` text NOT NULL,
  `rpt_footer` text NOT NULL,
  PRIMARY KEY (`rpt_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;

--
-- Dumping data for table `reports`
--

LOCK TABLES `reports` WRITE;
/*!40000 ALTER TABLE `reports` DISABLE KEYS */;
INSERT INTO `reports` VALUES (1,'   ',1,100,'<center><b>[%REP_TITLE%]</b></center>    \r\n||\r\n||<b>[REP_NUM]:</b>|   [%REP_NUM%]  ||<b>[REP_DATE]:</b>|   [%REP_DATE%]  |\r\n||<b>[S_DEPT]:</b>|   [%S_DEPT%]  ||<b>[S_CAT]:</b>|   [%S_CAT%]  |\r\n||<b>[S_NAME]:</b>|   [%S_NAME%]  ||<b>[S_JOBPOS]:</b>|   [%S_JOBPOS%]  |\r\n||<b>[COURSE]:</b>|   [%COURSE%]  ||||\r\n\r\n\r\n',''),(2,'   .   . ',1,200,'<center><b>[%REP_TITLE%]</b></center>\r\n\r\n||\r\n||<b>[REP_NUM]:</b>|   [%REP_NUM%]  ||<b>[REP_DATE]:</b>|   [%REP_DATE%]  |\r\n||<b>[S_DEPT]:</b>|   [%S_DEPT%]  ||<b>[S_CAT]:</b>|   [%S_CAT%]  |\r\n||<b>[S_NAME]:</b>|   [%S_NAME%]  ||<nobr><b>[S_JOBPOS]:</b></nobr>|   [%S_JOBPOS%]  |\r\n||\r\n||<b>[COURSE]:</b>|   [%COURSE%]  ||\r\n||',''),(3,'   .   .',1,400,'<center><b>[%REP_TITLE%]</b></center>\r\n\r\n||\r\n||<b>[REP_NUM]:</b>|   [%REP_NUM%]  ||<b>[REP_DATE]:</b>|   [%REP_DATE%]  |\r\n||<b>[S_DEPT]:</b>|   [%S_DEPT%]  ||<b>[S_CAT]:</b>|   [%S_CAT%]  |\r\n||<b>[S_NAME]:</b>|   [%S_NAME%]  ||<nobr><b>[S_JOBPOS]:</b></nobr>|   [%S_JOBPOS%]  |\r\n||\r\n||<b>[COURSE]:</b>|   [%COURSE%]  ||\r\n||',''),(4,'  .  .  ',1,700,'<center><b>[%REP_TITLE%]</b></center>\r\n\r\n||\r\n||<b>[GROUP]:</b>|   [%GROUP%]  ||<b>[REP_DATE]:</b>|   [%REP_DATE%]  |\r\n||<b>[COURSE]:</b>|   [%COURSE%]  ||<b>[CATS]:</b>|   [%CATS%]  |\r\n||',''),(5,'   .    . ',1,300,'<center><b>[%REP_TITLE%]</b></center>\r\n\r\n||\r\n||<b>[REP_NUM]:</b>|   [%REP_NUM%]  ||<b>[REP_DATE]:</b>|   [%REP_DATE%]  |\r\n||<b>[S_DEPT]:</b>|   [%S_DEPT%]  ||<b>[S_CAT]:</b>|   [%S_CAT%]  |\r\n||<b>[S_NAME]:</b>|   [%S_NAME%]  ||<nobr><b>[S_JOBPOS]:</b></nobr>|   [%S_JOBPOS%]  |\r\n||\r\n||<b>[COURSE]:</b>|   [%COURSE%]  ||\r\n||',''),(6,'  . ',1,800,'<center><b>[%REP_TITLE%]</b></center>\r\n\r\n||\r\n||<b>[REP_NUM]:</b>|   [%REP_NUM%]  ||<b>[REP_DATE]:</b>|   [%REP_DATE%]  |\r\n||<b>[COURSE]:</b>|   [%COURSE%]  ||<b>[CATS]:</b>|   [%CATS%]  |\r\n||',''),(7,' - .',1,500,'<center><b>[%REP_TITLE%]</b></center>\r\n\r\n||\r\n||<b>[REP_NUM]:</b>|   [%REP_NUM%]  ||<b>[REP_DATE]:</b>|   [%REP_DATE%]  |\r\n||<b>[S_DEPT]:</b>|   [%S_DEPT%]  ||<b>[S_CAT]:</b>|   [%S_CAT%]  |\r\n||<b>[S_NAME]:</b>|   [%S_NAME%]  ||<nobr><b>[S_JOBPOS]:</b></nobr>|   [%S_JOBPOS%]  |\r\n||\r\n||<b>[COURSE]:</b>|   [%COURSE%]  ||\r\n||','');
/*!40000 ALTER TABLE `reports` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `resources`
--

DROP TABLE IF EXISTS `resources`;
CREATE TABLE `resources` (
  `ID` varchar(255) NOT NULL DEFAULT '',
  `Title` text NOT NULL,
  `Title_fa` text NOT NULL,
  `Title_ru` text NOT NULL,
  `Comment` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `resources`
--

LOCK TABLES `resources` WRITE;
/*!40000 ALTER TABLE `resources` DISABLE KEYS */;
/*!40000 ALTER TABLE `resources` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rooms`
--

DROP TABLE IF EXISTS `rooms`;
CREATE TABLE `rooms` (
  `rid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `volume` int(11) DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`rid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `rooms`
--

LOCK TABLES `rooms` WRITE;
/*!40000 ALTER TABLE `rooms` DISABLE KEYS */;
/*!40000 ALTER TABLE `rooms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rooms2course`
--

DROP TABLE IF EXISTS `rooms2course`;
CREATE TABLE `rooms2course` (
  `rid` int(11) DEFAULT NULL,
  `cid` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `rooms2course`
--

LOCK TABLES `rooms2course` WRITE;
/*!40000 ALTER TABLE `rooms2course` DISABLE KEYS */;
/*!40000 ALTER TABLE `rooms2course` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `schedule`
--

DROP TABLE IF EXISTS `schedule`;
CREATE TABLE `schedule` (
  `SHEID` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `url` text,
  `descript` text NOT NULL,
  `begin` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `createID` int(11) NOT NULL DEFAULT '0',
  `typeID` int(11) NOT NULL DEFAULT '0',
  `vedomost` int(11) DEFAULT NULL,
  `CID` int(11) DEFAULT NULL,
  `CHID` int(11) DEFAULT NULL,
  `toolParams` text NOT NULL,
  PRIMARY KEY (`SHEID`)
) ENGINE=MyISAM AUTO_INCREMENT=169 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `schedule`
--

LOCK TABLES `schedule` WRITE;
/*!40000 ALTER TABLE `schedule` DISABLE KEYS */;
/*!40000 ALTER TABLE `schedule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `scheduleid`
--

DROP TABLE IF EXISTS `scheduleid`;
CREATE TABLE `scheduleid` (
  `SSID` int(11) NOT NULL AUTO_INCREMENT,
  `SHEID` int(11) NOT NULL DEFAULT '0',
  `MID` int(11) NOT NULL DEFAULT '0',
  `V_STATUS` int(11) NOT NULL DEFAULT '-1',
  `DESCR` text,
  `SMSremind` tinyint(4) NOT NULL DEFAULT '0',
  `ICQremind` tinyint(4) NOT NULL DEFAULT '0',
  `EMAILremind` tinyint(4) NOT NULL DEFAULT '0',
  `ISTUDremind` tinyint(4) NOT NULL DEFAULT '0',
  `test_corr` int(11) NOT NULL DEFAULT '0',
  `test_wrong` int(11) NOT NULL DEFAULT '0',
  `test_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `test_answers` text,
  `test_tries` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`SSID`),
  KEY `SHEID` (`SHEID`)
) ENGINE=MyISAM AUTO_INCREMENT=942 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `scheduleid`
--

LOCK TABLES `scheduleid` WRITE;
/*!40000 ALTER TABLE `scheduleid` DISABLE KEYS */;
/*!40000 ALTER TABLE `scheduleid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sco_ldata`
--

DROP TABLE IF EXISTS `sco_ldata`;
CREATE TABLE `sco_ldata` (
  `did` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `CID` int(10) unsigned NOT NULL DEFAULT '0',
  `TID` varchar(255) NOT NULL DEFAULT '',
  `PID` int(10) unsigned NOT NULL DEFAULT '0',
  `dt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `param` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`did`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `sco_ldata`
--

LOCK TABLES `sco_ldata` WRITE;
/*!40000 ALTER TABLE `sco_ldata` DISABLE KEYS */;
/*!40000 ALTER TABLE `sco_ldata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sco_sdata`
--

DROP TABLE IF EXISTS `sco_sdata`;
CREATE TABLE `sco_sdata` (
  `did` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `CID` int(10) unsigned NOT NULL DEFAULT '0',
  `TID` varchar(255) NOT NULL DEFAULT '',
  `PID` int(10) unsigned NOT NULL DEFAULT '0',
  `dt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `param` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`did`),
  UNIQUE KEY `CID` (`CID`,`TID`,`PID`,`param`)
) ENGINE=MyISAM AUTO_INCREMENT=53 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `sco_sdata`
--

LOCK TABLES `sco_sdata` WRITE;
/*!40000 ALTER TABLE `sco_sdata` DISABLE KEYS */;
/*!40000 ALTER TABLE `sco_sdata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sco_target`
--

DROP TABLE IF EXISTS `sco_target`;
CREATE TABLE `sco_target` (
  `CID` int(11) NOT NULL DEFAULT '0',
  `TID` varchar(255) NOT NULL DEFAULT '',
  `Title` varchar(255) NOT NULL DEFAULT '-',
  `link` text,
  `ad_dfl` text NOT NULL,
  `ad_ms` decimal(10,0) NOT NULL DEFAULT '0',
  `ad_mta` varchar(15) NOT NULL DEFAULT '',
  `ad_tla` varchar(31) NOT NULL DEFAULT '',
  `Description` text,
  `special` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`CID`,`TID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `sco_target`
--

LOCK TABLES `sco_target` WRITE;
/*!40000 ALTER TABLE `sco_target` DISABLE KEYS */;
/*!40000 ALTER TABLE `sco_target` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `seance`
--

DROP TABLE IF EXISTS `seance`;
CREATE TABLE `seance` (
  `stid` int(11) NOT NULL DEFAULT '0',
  `mid` int(11) NOT NULL DEFAULT '0',
  `cid` int(11) NOT NULL DEFAULT '0',
  `tid` int(11) NOT NULL DEFAULT '0',
  `kod` varchar(255) NOT NULL DEFAULT '',
  `attach` longblob NOT NULL,
  `filename` varchar(255) NOT NULL DEFAULT '',
  `text` blob NOT NULL,
  `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `bal` float DEFAULT NULL,
  PRIMARY KEY (`stid`,`kod`),
  KEY `mid` (`mid`),
  KEY `stid` (`stid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `seance`
--

LOCK TABLES `seance` WRITE;
/*!40000 ALTER TABLE `seance` DISABLE KEYS */;
/*!40000 ALTER TABLE `seance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search`
--

DROP TABLE IF EXISTS `search`;
CREATE TABLE `search` (
  `category` varchar(255) DEFAULT NULL,
  `doc_id` varchar(255) DEFAULT NULL,
  `checksumm` int(10) unsigned NOT NULL DEFAULT '0',
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  `wrd` varchar(255) DEFAULT NULL,
  KEY `checksumm` (`checksumm`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `search`
--

LOCK TABLES `search` WRITE;
/*!40000 ALTER TABLE `search` DISABLE KEYS */;
/*!40000 ALTER TABLE `search` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `special`
--

DROP TABLE IF EXISTS `special`;
CREATE TABLE `special` (
  `SpID` bigint(3) unsigned NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) DEFAULT '-',
  `Title_fa` varchar(255) DEFAULT '-',
  `Title_ru` varchar(255) DEFAULT '-',
  `Description` text,
  `Description_fa` text,
  `Description_ru` text,
  PRIMARY KEY (`SpID`)
) ENGINE=MyISAM AUTO_INCREMENT=1000056 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `special`
--

LOCK TABLES `special` WRITE;
/*!40000 ALTER TABLE `special` DISABLE KEYS */;
INSERT INTO `special` VALUES (1000055,' 1','-','-','',NULL,NULL);
/*!40000 ALTER TABLE `special` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `strtest`
--

DROP TABLE IF EXISTS `strtest`;
CREATE TABLE `strtest` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `PID` int(11) NOT NULL DEFAULT '0',
  `Object_type` tinyint(4) NOT NULL DEFAULT '0',
  `Grade` double NOT NULL DEFAULT '0',
  `Parent` int(11) NOT NULL DEFAULT '0',
  `data` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `strtest`
--

LOCK TABLES `strtest` WRITE;
/*!40000 ALTER TABLE `strtest` DISABLE KEYS */;
/*!40000 ALTER TABLE `strtest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `students`
--

DROP TABLE IF EXISTS `students`;
CREATE TABLE `students` (
  `SID` int(11) NOT NULL AUTO_INCREMENT,
  `MID` int(11) NOT NULL DEFAULT '0',
  `CID` int(11) NOT NULL DEFAULT '0',
  `cgid` int(11) NOT NULL DEFAULT '0',
  `Registered` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`SID`),
  KEY `CID` (`CID`)
) ENGINE=MyISAM AUTO_INCREMENT=557 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `students`
--

LOCK TABLES `students` WRITE;
/*!40000 ALTER TABLE `students` DISABLE KEYS */;
/*!40000 ALTER TABLE `students` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `target`
--

DROP TABLE IF EXISTS `target`;
CREATE TABLE `target` (
  `TID` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) NOT NULL DEFAULT '-',
  `Title_fa` varchar(255) NOT NULL DEFAULT '-',
  `Title_ru` varchar(255) NOT NULL DEFAULT '-',
  `link` text,
  `Description` text,
  `Description_fa` text,
  `Description_ru` text,
  `LID` int(11) NOT NULL DEFAULT '0',
  `VID` text,
  `target_special` varchar(255) DEFAULT NULL,
  `CID` int(11) DEFAULT NULL,
  `ord` int(11) DEFAULT NULL,
  `success` tinyint(4) DEFAULT NULL,
  `version` varchar(32) DEFAULT '1.0.1',
  PRIMARY KEY (`TID`)
) ENGINE=MyISAM AUTO_INCREMENT=1000858 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `target`
--

LOCK TABLES `target` WRITE;
/*!40000 ALTER TABLE `target` DISABLE KEYS */;
/*!40000 ALTER TABLE `target` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `target_list`
--

DROP TABLE IF EXISTS `target_list`;
CREATE TABLE `target_list` (
  `id_target_list` bigint(20) NOT NULL AUTO_INCREMENT,
  `id_target` bigint(20) DEFAULT NULL,
  `id_list` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id_target_list`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;

--
-- Dumping data for table `target_list`
--

LOCK TABLES `target_list` WRITE;
/*!40000 ALTER TABLE `target_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `target_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `target_special`
--

DROP TABLE IF EXISTS `target_special`;
CREATE TABLE `target_special` (
  `target_special_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `target_id` bigint(20) DEFAULT NULL,
  `special_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`target_special_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;

--
-- Dumping data for table `target_special`
--

LOCK TABLES `target_special` WRITE;
/*!40000 ALTER TABLE `target_special` DISABLE KEYS */;
/*!40000 ALTER TABLE `target_special` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tbl_maxval`
--

DROP TABLE IF EXISTS `tbl_maxval`;
CREATE TABLE `tbl_maxval` (
  `maxval_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `tablename` varchar(255) NOT NULL,
  `maxval` bigint(20) unsigned zerofill NOT NULL DEFAULT '00000000000000000000',
  PRIMARY KEY (`maxval_id`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `tbl_maxval`
--

LOCK TABLES `tbl_maxval` WRITE;
/*!40000 ALTER TABLE `tbl_maxval` DISABLE KEYS */;
INSERT INTO `tbl_maxval` VALUES (2,'mod_list',00000000000001000231),(3,'lesson',00000000000001000350),(4,'target',00000000000001000857),(5,'test',00000000000001000281),(6,'courses',00000000000001000200),(7,'special',00000000000001000055);
/*!40000 ALTER TABLE `tbl_maxval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `teachers`
--

DROP TABLE IF EXISTS `teachers`;
CREATE TABLE `teachers` (
  `PID` int(11) NOT NULL AUTO_INCREMENT,
  `MID` int(11) NOT NULL DEFAULT '0',
  `CID` int(11) NOT NULL DEFAULT '0',
  `type` tinyint(4) DEFAULT '2',
  PRIMARY KEY (`PID`)
) ENGINE=MyISAM AUTO_INCREMENT=286 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `teachers`
--

LOCK TABLES `teachers` WRITE;
/*!40000 ALTER TABLE `teachers` DISABLE KEYS */;
/*!40000 ALTER TABLE `teachers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `teachnotes`
--

DROP TABLE IF EXISTS `teachnotes`;
CREATE TABLE `teachnotes` (
  `NOTID` int(11) NOT NULL AUTO_INCREMENT,
  `SHEID` int(11) NOT NULL DEFAULT '0',
  `MID` int(11) NOT NULL DEFAULT '0',
  `noteText` text,
  `ISTUDremind` tinyint(4) NOT NULL DEFAULT '0',
  `SMSremind` tinyint(4) NOT NULL DEFAULT '0',
  `EMAILremind` tinyint(4) NOT NULL DEFAULT '0',
  `ICQremind` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`NOTID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `teachnotes`
--

LOCK TABLES `teachnotes` WRITE;
/*!40000 ALTER TABLE `teachnotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `teachnotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `test`
--

DROP TABLE IF EXISTS `test`;
CREATE TABLE `test` (
  `tid` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `cidowner` int(11) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '-',
  `datatype` int(11) NOT NULL DEFAULT '0',
  `data` text,
  `random` tinyint(4) NOT NULL DEFAULT '0',
  `lim` int(11) NOT NULL DEFAULT '0',
  `qty` tinyint(4) NOT NULL DEFAULT '1',
  `sort` tinyint(4) NOT NULL DEFAULT '0',
  `free` tinyint(4) NOT NULL DEFAULT '0',
  `skip` tinyint(4) NOT NULL DEFAULT '0',
  `rating` tinyint(4) NOT NULL DEFAULT '0',
  `status` tinyint(4) NOT NULL DEFAULT '0',
  `questres` tinyint(4) NOT NULL DEFAULT '0',
  `endres` tinyint(4) NOT NULL DEFAULT '1',
  `showurl` tinyint(4) NOT NULL DEFAULT '1',
  `showotvet` tinyint(4) NOT NULL DEFAULT '0',
  `timelimit` smallint(6) NOT NULL DEFAULT '0',
  `timelimit0` smallint(5) unsigned NOT NULL DEFAULT '0',
  `timelimitmethod` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `startlimit` int(11) NOT NULL DEFAULT '1',
  `startlimit0` smallint(5) unsigned NOT NULL DEFAULT '0',
  `startlimitmethod` tinyint(1) NOT NULL DEFAULT '1',
  `limitclean` mediumint(5) NOT NULL DEFAULT '0',
  `last` int(11) NOT NULL DEFAULT '0',
  `lastmid` int(11) NOT NULL DEFAULT '0',
  `cache_qty` int(11) NOT NULL DEFAULT '0',
  `title_fa` varchar(255) NOT NULL DEFAULT '-',
  `title_ru` varchar(255) NOT NULL DEFAULT '-',
  `tonm` tinyint(4) DEFAULT '1',
  `anketa` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `que` tinyint(4) NOT NULL DEFAULT '1',
  `version` varchar(32) DEFAULT '1.0.1',
  PRIMARY KEY (`tid`)
) ENGINE=MyISAM AUTO_INCREMENT=1000282 DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `test`
--

LOCK TABLES `test` WRITE;
/*!40000 ALTER TABLE `test` DISABLE KEYS */;
/*!40000 ALTER TABLE `test` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `test_list`
--

DROP TABLE IF EXISTS `test_list`;
CREATE TABLE `test_list` (
  `testlist_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `id_test` bigint(20) DEFAULT NULL,
  `id_list` varchar(255) DEFAULT NULL,
  `isneeded` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`testlist_id`),
  UNIQUE KEY `index1` (`testlist_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=646 DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;

--
-- Dumping data for table `test_list`
--

LOCK TABLES `test_list` WRITE;
/*!40000 ALTER TABLE `test_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `test_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `testcontent`
--

DROP TABLE IF EXISTS `testcontent`;
CREATE TABLE `testcontent` (
  `QID` int(11) NOT NULL AUTO_INCREMENT,
  `TID` int(11) NOT NULL DEFAULT '0',
  `xmlQ` text NOT NULL,
  `questionText` text NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '0',
  `attachFileName` varchar(255) DEFAULT NULL,
  `attachExt` varchar(255) DEFAULT NULL,
  `theme` varchar(255) NOT NULL DEFAULT '-',
  `isObligatory` tinyint(4) NOT NULL DEFAULT '0',
  `questionText_fa` text NOT NULL,
  `questionText_ru` text NOT NULL,
  `theme_fa` varchar(255) NOT NULL DEFAULT '-',
  `theme_ru` varchar(255) NOT NULL DEFAULT '-',
  PRIMARY KEY (`QID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `testcontent`
--

LOCK TABLES `testcontent` WRITE;
/*!40000 ALTER TABLE `testcontent` DISABLE KEYS */;
/*!40000 ALTER TABLE `testcontent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `testcount`
--

DROP TABLE IF EXISTS `testcount`;
CREATE TABLE `testcount` (
  `mid` int(11) NOT NULL DEFAULT '0',
  `tid` int(11) NOT NULL DEFAULT '0',
  `cid` int(11) NOT NULL DEFAULT '0',
  `qty` smallint(5) unsigned NOT NULL DEFAULT '0',
  `last` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`mid`,`tid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `testcount`
--

LOCK TABLES `testcount` WRITE;
/*!40000 ALTER TABLE `testcount` DISABLE KEYS */;
/*!40000 ALTER TABLE `testcount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `testneed`
--

DROP TABLE IF EXISTS `testneed`;
CREATE TABLE `testneed` (
  `tid` int(11) NOT NULL DEFAULT '0',
  `kod` varchar(100) NOT NULL DEFAULT ''
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `testneed`
--

LOCK TABLES `testneed` WRITE;
/*!40000 ALTER TABLE `testneed` DISABLE KEYS */;
/*!40000 ALTER TABLE `testneed` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `testotch`
--

DROP TABLE IF EXISTS `testotch`;
CREATE TABLE `testotch` (
  `balmax` int(11) DEFAULT NULL,
  `balmin` int(11) DEFAULT NULL,
  `bal` int(11) DEFAULT NULL,
  `tid` int(11) DEFAULT NULL,
  `pid` int(11) DEFAULT NULL,
  `time` datetime DEFAULT NULL,
  `udacha` int(11) DEFAULT NULL,
  `VID` text,
  `balbefore` int(11) NOT NULL DEFAULT '0',
  `md5` varchar(40) NOT NULL DEFAULT ''
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `testotch`
--

LOCK TABLES `testotch` WRITE;
/*!40000 ALTER TABLE `testotch` DISABLE KEYS */;
/*!40000 ALTER TABLE `testotch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `testtitle`
--

DROP TABLE IF EXISTS `testtitle`;
CREATE TABLE `testtitle` (
  `TID` int(11) NOT NULL AUTO_INCREMENT,
  `Title` varchar(255) NOT NULL DEFAULT '-',
  `CID` int(11) NOT NULL DEFAULT '0',
  `timelim` varchar(255) NOT NULL DEFAULT '',
  `blockQ` varchar(255) NOT NULL DEFAULT '',
  `trylimit` varchar(255) NOT NULL DEFAULT '',
  `orderQ` varchar(255) NOT NULL DEFAULT '',
  `questlim` varchar(255) NOT NULL DEFAULT '',
  `Title_fa` varchar(255) NOT NULL DEFAULT '-',
  `Title_ru` varchar(255) NOT NULL DEFAULT '-',
  PRIMARY KEY (`TID`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `testtitle`
--

LOCK TABLES `testtitle` WRITE;
/*!40000 ALTER TABLE `testtitle` DISABLE KEYS */;
/*!40000 ALTER TABLE `testtitle` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tracks`
--

DROP TABLE IF EXISTS `tracks`;
CREATE TABLE `tracks` (
  `trid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `id` varchar(255) DEFAULT NULL,
  `volume` int(11) DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `owner` varchar(255) DEFAULT NULL,
  `totalcost` int(11) DEFAULT NULL,
  `currency` int(11) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`trid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `tracks`
--

LOCK TABLES `tracks` WRITE;
/*!40000 ALTER TABLE `tracks` DISABLE KEYS */;
/*!40000 ALTER TABLE `tracks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tracks2course`
--

DROP TABLE IF EXISTS `tracks2course`;
CREATE TABLE `tracks2course` (
  `trid` int(11) DEFAULT NULL,
  `cid` int(11) DEFAULT NULL,
  `level` int(11) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `tracks2course`
--

LOCK TABLES `tracks2course` WRITE;
/*!40000 ALTER TABLE `tracks2course` DISABLE KEYS */;
/*!40000 ALTER TABLE `tracks2course` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tracks2mid`
--

DROP TABLE IF EXISTS `tracks2mid`;
CREATE TABLE `tracks2mid` (
  `trmid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `trid` int(11) DEFAULT NULL,
  `mid` int(11) DEFAULT NULL,
  `level` int(11) DEFAULT NULL,
  `started` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `stoped` int(11) DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `sign` int(11) DEFAULT NULL,
  `info` text,
  PRIMARY KEY (`trmid`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `tracks2mid`
--

LOCK TABLES `tracks2mid` WRITE;
/*!40000 ALTER TABLE `tracks2mid` DISABLE KEYS */;
/*!40000 ALTER TABLE `tracks2mid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vopotch`
--

DROP TABLE IF EXISTS `vopotch`;
CREATE TABLE `vopotch` (
  `tid` int(11) DEFAULT NULL,
  `pid` int(11) DEFAULT NULL,
  `time` datetime DEFAULT NULL,
  `vid` varchar(255) DEFAULT NULL,
  `bal` int(11) DEFAULT NULL,
  `otv` varchar(255) NOT NULL DEFAULT '',
  `md5` varchar(40) NOT NULL DEFAULT ''
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `vopotch`
--

LOCK TABLES `vopotch` WRITE;
/*!40000 ALTER TABLE `vopotch` DISABLE KEYS */;
/*!40000 ALTER TABLE `vopotch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Dumping routines for database 'twclass'
--
DELIMITER ;;
DELIMITER ;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-10-15 14:19:10
